/* TeeJee.FileSystem.c generated by valac 0.48.19, the Vala compiler
 * generated from TeeJee.FileSystem.vala, do not modify */

/*
 * TeeJee.FileSystem.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <glib/gstdio.h>
#include <glib/gi18n-lib.h>
#include <errno.h>
#include <gee.h>
#include <glib-object.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

#define TEE_JEE_FILE_SYSTEM_KB ((gint64) 1000)
#define TEE_JEE_FILE_SYSTEM_MB (1000 * TEE_JEE_FILE_SYSTEM_KB)
#define TEE_JEE_FILE_SYSTEM_GB (1000 * TEE_JEE_FILE_SYSTEM_MB)
#define TEE_JEE_FILE_SYSTEM_TB (1000 * TEE_JEE_FILE_SYSTEM_GB)
#define TEE_JEE_FILE_SYSTEM_KiB ((gint64) 1024)
#define TEE_JEE_FILE_SYSTEM_MiB (1024 * TEE_JEE_FILE_SYSTEM_KiB)
#define TEE_JEE_FILE_SYSTEM_GiB (1024 * TEE_JEE_FILE_SYSTEM_MiB)
#define TEE_JEE_FILE_SYSTEM_TiB (1024 * TEE_JEE_FILE_SYSTEM_GiB)
gchar* tee_jee_file_system_file_parent (const gchar* file_path);
gchar* tee_jee_file_system_file_basename (const gchar* file_path);
gchar* tee_jee_file_system_path_combine (const gchar* path1,
                                         const gchar* path2);
gchar* tee_jee_file_system_remove_trailing_slash (const gchar* path);
gboolean tee_jee_file_system_file_or_dir_exists (const gchar* item_path);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
gboolean tee_jee_file_system_file_exists_regular (const gchar* file_path);
gboolean tee_jee_file_system_file_delete (const gchar* file_path);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gint64 tee_jee_file_system_file_line_count (const gchar* file_path);
gchar* tee_jee_file_system_escape_single_quote (const gchar* file_path);
gint tee_jee_process_helper_exec_sync (const gchar* cmd,
                                       gchar* * std_out,
                                       gchar* * std_err);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
gboolean tee_jee_file_system_file_write (const gchar* file_path,
                                         const gchar* contents);
gboolean tee_jee_file_system_dir_create (const gchar* dir_path,
                                         gboolean show_message);
gboolean tee_jee_file_system_file_copy (const gchar* src_file,
                                        const gchar* dest_file);
void tee_jee_file_system_file_move (const gchar* src_file,
                                    const gchar* dest_file);
gboolean tee_jee_file_system_file_is_symlink (const gchar* file_path);
gboolean tee_jee_file_system_file_gzip (const gchar* src_file);
gboolean tee_jee_file_system_file_gunzip (const gchar* src_file);
gchar* tee_jee_file_system_file_resolve_executable_path (const gchar* file_path);
gint64 tee_jee_file_system_file_get_size (const gchar* file_path);
GDateTime* tee_jee_file_system_file_get_modified_date (const gchar* file_path);
gchar* tee_jee_file_system_file_get_symlink_target (const gchar* file_path);
gboolean tee_jee_file_system_dir_exists (const gchar* dir_path);
void tee_jee_logging_log_msg (const gchar* message,
                              gboolean highlight);
gboolean tee_jee_file_system_dir_delete (const gchar* dir_path,
                                         gboolean show_message);
void tee_jee_logging_log_debug (const gchar* message);
gboolean tee_jee_file_system_dir_is_empty (const gchar* dir_path);
gboolean tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                            gboolean* is_readonly);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
GeeArrayList* tee_jee_file_system_dir_list_names (const gchar* path);
static gint __lambda15_ (const gchar* a,
                  const gchar* b);
static gint ___lambda15__gcompare_data_func (gconstpointer a,
                                      gconstpointer b,
                                      gpointer self);
gboolean tee_jee_file_system_chown (const gchar* dir_path,
                                    const gchar* user,
                                    const gchar* group);
glong tee_jee_file_system_dir_count (const gchar* path);
gint tee_jee_process_helper_exec_script_sync (const gchar* script,
                                              gchar* * std_out,
                                              gchar* * std_err,
                                              gboolean supress_errors,
                                              gboolean run_as_admin,
                                              gboolean cleanup_tmp,
                                              gboolean print_to_terminal);
glong tee_jee_file_system_dir_size (const gchar* path);
glong tee_jee_file_system_dir_size_kb (const gchar* path);
gchar* tee_jee_file_system_format_file_size (guint64 size,
                                             gboolean binary_units,
                                             const gchar* unit,
                                             gboolean show_units,
                                             gint decimals);
gint tee_jee_file_system_chmod (const gchar* file,
                                const gchar* permission);
gint tee_jee_file_system_rsync (const gchar* sourceDirectory,
                                const gchar* destDirectory,
                                gboolean updateExisting,
                                gboolean deleteExtra);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

gchar*
tee_jee_file_system_file_parent (const gchar* file_path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* _tmp2_;
	GFile* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* result = NULL;
#line 45 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_parent (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_file_get_path (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp3_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 46 "Utility/TeeJee.FileSystem.vala"
	result = _tmp5_;
#line 46 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 166 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_basename (const gchar* file_path)
{
	GFile* _tmp0_;
	GFile* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* result = NULL;
#line 49 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_new_for_path (file_path);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_file_get_basename (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (_tmp1_);
#line 50 "Utility/TeeJee.FileSystem.vala"
	result = _tmp3_;
#line 50 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 193 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_path_combine (const gchar* path1,
                                  const gchar* path2)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path1 != NULL, NULL);
#line 53 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path2 != NULL, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_build_path ("/", path1, path2, NULL);
#line 54 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 54 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 212 "TeeJee.FileSystem.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 239 "TeeJee.FileSystem.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 245 "TeeJee.FileSystem.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 251 "TeeJee.FileSystem.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 255 "TeeJee.FileSystem.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 263 "TeeJee.FileSystem.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 267 "TeeJee.FileSystem.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 279 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_remove_trailing_slash (const gchar* path)
{
	gchar* result = NULL;
#line 57 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 58 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_suffix (path, "/")) {
#line 290 "TeeJee.FileSystem.c"
		gint _tmp0_;
		gint _tmp1_;
		gchar* _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = strlen (path);
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = string_slice (path, (glong) 0, (glong) (_tmp1_ - 1));
#line 59 "Utility/TeeJee.FileSystem.vala"
		result = _tmp2_;
#line 59 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 304 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup (path);
#line 62 "Utility/TeeJee.FileSystem.vala"
		result = _tmp3_;
#line 62 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 313 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_or_dir_exists (const gchar* item_path)
{
	GFile* item = NULL;
	GFile* _tmp0_;
	gboolean result = FALSE;
#line 68 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (item_path != NULL, FALSE);
#line 72 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_file_parse_name (item_path);
#line 72 "Utility/TeeJee.FileSystem.vala"
	item = _tmp0_;
#line 73 "Utility/TeeJee.FileSystem.vala"
	result = g_file_query_exists (item, NULL);
#line 73 "Utility/TeeJee.FileSystem.vala"
	_g_object_unref0 (item);
#line 73 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 335 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_exists (const gchar* file_path)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 76 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 78 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 79 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = !g_file_test (file_path, G_FILE_TEST_IS_DIR);
#line 349 "TeeJee.FileSystem.c"
	} else {
#line 78 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 353 "TeeJee.FileSystem.c"
	}
#line 78 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 78 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 359 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_exists_regular (const gchar* file_path)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 82 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 84 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 85 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (file_path, G_FILE_TEST_IS_REGULAR);
#line 373 "TeeJee.FileSystem.c"
	} else {
#line 84 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 377 "TeeJee.FileSystem.c"
	}
#line 84 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 84 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 383 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_delete (const gchar* file_path)
{
	gboolean _tmp9_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 88 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 394 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 93 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 93 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 94 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 94 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 407 "TeeJee.FileSystem.c"
			GFile* _tmp2_;
#line 95 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 95 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp2_, NULL, &_inner_error0_);
#line 95 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 95 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 417 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
		}
#line 97 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 97 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 97 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 427 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 92 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 92 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 99 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = e;
#line 99 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_->message;
#line 99 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp4_, FALSE, FALSE);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_strdup_printf (": %s", file_path);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strconcat (_ ("Failed to delete file"), _tmp6_, NULL);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 100 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 100 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp6_);
#line 101 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 101 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 101 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 469 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 92 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 92 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 92 "Utility/TeeJee.FileSystem.vala"
	return _tmp9_;
#line 478 "TeeJee.FileSystem.c"
}

static glong
long_parse (const gchar* str,
            guint _base)
{
	glong result = 0L;
#line 315 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0L);
#line 316 "glib-2.0.vapi"
	result = strtol (str, NULL, (gint) _base);
#line 316 "glib-2.0.vapi"
	return result;
#line 492 "TeeJee.FileSystem.c"
}

gint64
tee_jee_file_system_file_line_count (const gchar* file_path)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gint64 _tmp10_;
	gint64 result = 0LL;
#line 105 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 107 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file_path);
#line 107 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 107 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("wc -l '%s'", _tmp1_);
#line 107 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 107 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 107 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 109 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 109 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 109 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 109 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 109 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = (gint64) long_parse (_tmp9_, (guint) 0);
#line 110 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 110 "Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 110 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 110 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 110 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 110 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 560 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_read (const gchar* file_path)
{
	gchar* txt = NULL;
	gsize size = 0UL;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 113 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 572 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_ = NULL;
		gsize _tmp1_ = 0UL;
#line 121 "Utility/TeeJee.FileSystem.vala"
		g_file_get_contents (file_path, &_tmp0_, &_tmp1_, &_inner_error0_);
#line 121 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 121 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp0_;
#line 121 "Utility/TeeJee.FileSystem.vala"
		size = _tmp1_;
#line 121 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 586 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 122 "Utility/TeeJee.FileSystem.vala"
		result = txt;
#line 122 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 593 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp2_;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 120 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 120 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 125 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = e;
#line 125 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = _tmp2_->message;
#line 125 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp3_, FALSE, FALSE);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = g_strdup_printf (": %s", file_path);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp4_;
#line 126 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_strconcat (_ ("Failed to read file"), _tmp5_, NULL);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = _tmp6_;
#line 126 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp7_, FALSE, FALSE);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp7_);
#line 126 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp5_);
#line 120 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 631 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 120 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 120 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 120 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 120 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 120 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 644 "TeeJee.FileSystem.c"
	}
#line 129 "Utility/TeeJee.FileSystem.vala"
	result = NULL;
#line 129 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (txt);
#line 129 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 652 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_write (const gchar* file_path,
                                const gchar* contents)
{
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 132 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 132 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (contents != NULL, FALSE);
#line 666 "TeeJee.FileSystem.c"
	{
		gchar* _tmp0_;
		gchar* _tmp1_;
		GFile* file = NULL;
		GFile* _tmp2_;
		GFile* _tmp3_;
		GFileOutputStream* file_stream = NULL;
		GFile* _tmp5_;
		GFileOutputStream* _tmp6_;
		GDataOutputStream* data_stream = NULL;
		GFileOutputStream* _tmp7_;
		GDataOutputStream* _tmp8_;
		GDataOutputStream* _tmp9_;
		GDataOutputStream* _tmp10_;
#line 138 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = tee_jee_file_system_file_parent (file_path);
#line 138 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = _tmp0_;
#line 138 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_dir_create (_tmp1_, FALSE);
#line 138 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp1_);
#line 140 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = g_file_new_for_path (file_path);
#line 140 "Utility/TeeJee.FileSystem.vala"
		file = _tmp2_;
#line 141 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = file;
#line 141 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp3_, NULL)) {
#line 697 "TeeJee.FileSystem.c"
			GFile* _tmp4_;
#line 142 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file;
#line 142 "Utility/TeeJee.FileSystem.vala"
			g_file_delete (_tmp4_, NULL, &_inner_error0_);
#line 142 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 142 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 707 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
		}
#line 145 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = file;
#line 145 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = g_file_create (_tmp5_, G_FILE_CREATE_REPLACE_DESTINATION, NULL, &_inner_error0_);
#line 145 "Utility/TeeJee.FileSystem.vala"
		file_stream = _tmp6_;
#line 145 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 145 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 721 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 146 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = file_stream;
#line 146 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = g_data_output_stream_new ((GOutputStream*) _tmp7_);
#line 146 "Utility/TeeJee.FileSystem.vala"
		data_stream = _tmp8_;
#line 147 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = data_stream;
#line 147 "Utility/TeeJee.FileSystem.vala"
		g_data_output_stream_put_string (_tmp9_, contents, NULL, &_inner_error0_);
#line 147 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 147 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 147 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 147 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 742 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 148 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = data_stream;
#line 148 "Utility/TeeJee.FileSystem.vala"
		g_output_stream_close ((GOutputStream*) _tmp10_, NULL, &_inner_error0_);
#line 148 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 148 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (data_stream);
#line 148 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_stream);
#line 148 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 757 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 149 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 149 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (data_stream);
#line 149 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_stream);
#line 149 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 149 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 770 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 136 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 136 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 152 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 152 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 152 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 153 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", file_path);
#line 153 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 153 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to write file"), _tmp14_, NULL);
#line 153 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 153 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 153 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 153 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 154 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 154 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 154 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 812 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 136 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 136 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 136 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 821 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_copy (const gchar* src_file,
                               const gchar* dest_file)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 158 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 158 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dest_file != NULL, FALSE);
#line 834 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 160 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 160 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 161 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 161 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 847 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 162 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 162 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 163 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 163 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 163 "Utility/TeeJee.FileSystem.vala"
			g_file_copy (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 163 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 163 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 163 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 868 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 164 "Utility/TeeJee.FileSystem.vala"
			result = TRUE;
#line 164 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 164 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_src);
#line 164 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 879 "TeeJee.FileSystem.c"
		}
#line 159 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 883 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 159 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 159 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 168 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 168 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 168 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 169 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 169 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 169 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_ ("Failed to copy file"), _tmp8_, NULL);
#line 169 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 169 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 169 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 169 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 159 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 921 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 159 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 926 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 159 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 159 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 159 "Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 934 "TeeJee.FileSystem.c"
	}
#line 172 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 172 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 940 "TeeJee.FileSystem.c"
}

void
tee_jee_file_system_file_move (const gchar* src_file,
                               const gchar* dest_file)
{
	GError* _inner_error0_ = NULL;
#line 175 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (src_file != NULL);
#line 175 "Utility/TeeJee.FileSystem.vala"
	g_return_if_fail (dest_file != NULL);
#line 952 "TeeJee.FileSystem.c"
	{
		GFile* file_src = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 177 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (src_file);
#line 177 "Utility/TeeJee.FileSystem.vala"
		file_src = _tmp0_;
#line 178 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file_src;
#line 178 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 965 "TeeJee.FileSystem.c"
			GFile* file_dest = NULL;
			GFile* _tmp2_;
			GFile* _tmp3_;
			GFile* _tmp4_;
#line 179 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = g_file_new_for_path (dest_file);
#line 179 "Utility/TeeJee.FileSystem.vala"
			file_dest = _tmp2_;
#line 180 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file_src;
#line 180 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = file_dest;
#line 180 "Utility/TeeJee.FileSystem.vala"
			g_file_move (_tmp3_, _tmp4_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 180 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 180 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_dest);
#line 180 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file_src);
#line 986 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 178 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file_dest);
#line 991 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp5_;
			gchar* _tmp6_;
			gchar* _tmp7_;
			gchar* _tmp8_;
#line 183 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_strdup_printf (": '%s'", src_file);
#line 183 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 183 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = g_strconcat (_ ("File not found"), _tmp6_, NULL);
#line 183 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp7_;
#line 183 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp8_, FALSE, FALSE);
#line 183 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp8_);
#line 183 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp6_);
#line 1011 "TeeJee.FileSystem.c"
		}
#line 176 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file_src);
#line 1015 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 176 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 176 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 187 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 187 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 187 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 188 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = g_strdup_printf (": '%s', '%s'", src_file, dest_file);
#line 188 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 188 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strconcat (_ ("Failed to move file"), _tmp12_, NULL);
#line 188 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 188 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp14_, FALSE, FALSE);
#line 188 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 188 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp12_);
#line 176 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1053 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 176 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 176 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 176 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 176 "Utility/TeeJee.FileSystem.vala"
		return;
#line 1064 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_file_is_symlink (const gchar* file_path)
{
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 192 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, FALSE);
#line 1075 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 195 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_new_for_path (file_path);
#line 195 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 197 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 197 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1088 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileInfo* _tmp5_;
			GFileInfo* _tmp6_;
			GFileType file_type = 0;
			GFileInfo* _tmp7_;
			GFileType _tmp8_;
#line 199 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = file;
#line 199 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_TYPE);
#line 199 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 199 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_query_info (_tmp2_, _tmp4_, G_FILE_QUERY_INFO_NOFOLLOW_SYMLINKS, NULL, &_inner_error0_);
#line 199 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 199 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 199 "Utility/TeeJee.FileSystem.vala"
			info = _tmp6_;
#line 199 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 199 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 1116 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 201 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = info;
#line 201 "Utility/TeeJee.FileSystem.vala"
			file_type = g_file_info_get_file_type (_tmp7_);
#line 203 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = file_type;
#line 203 "Utility/TeeJee.FileSystem.vala"
			result = _tmp8_ == G_FILE_TYPE_SYMBOLIC_LINK;
#line 203 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 203 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 203 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1133 "TeeJee.FileSystem.c"
		}
#line 194 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1137 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp9_;
		const gchar* _tmp10_;
#line 194 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 194 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 207 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = e;
#line 207 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_->message;
#line 207 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 194 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1157 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 194 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1162 "TeeJee.FileSystem.c"
		gboolean _tmp11_ = FALSE;
#line 194 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 194 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 194 "Utility/TeeJee.FileSystem.vala"
		return _tmp11_;
#line 1170 "TeeJee.FileSystem.c"
	}
#line 210 "Utility/TeeJee.FileSystem.vala"
	result = FALSE;
#line 210 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1176 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_gzip (const gchar* src_file)
{
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean result = FALSE;
#line 213 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 215 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strconcat (src_file, ".gz", NULL);
#line 215 "Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 216 "Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 218 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 218 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 218 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gzip '%s'", _tmp2_);
#line 218 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 218 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 218 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 220 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 220 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 220 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 220 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 220 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 222 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 222 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 222 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 222 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 222 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 222 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1236 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_file_gunzip (const gchar* src_file)
{
	gchar* dst_file = NULL;
	gchar* _tmp0_;
	gchar* cmd = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gboolean result = FALSE;
#line 225 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (src_file != NULL, FALSE);
#line 227 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup (src_file);
#line 227 "Utility/TeeJee.FileSystem.vala"
	dst_file = _tmp0_;
#line 228 "Utility/TeeJee.FileSystem.vala"
	tee_jee_file_system_file_delete (dst_file);
#line 230 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (src_file);
#line 230 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 230 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("gunzip '%s'", _tmp2_);
#line 230 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = _tmp3_;
#line 230 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 230 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp4_;
#line 232 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp5_, &_tmp6_);
#line 232 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 232 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 232 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 232 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 234 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_file_system_file_exists (dst_file);
#line 234 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 234 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 234 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 234 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (dst_file);
#line 234 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1296 "TeeJee.FileSystem.c"
}

static gboolean
string_contains (const gchar* self,
                 const gchar* needle)
{
	gchar* _tmp0_;
	gboolean result = FALSE;
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1530 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, FALSE);
#line 1531 "glib-2.0.vapi"
	_tmp0_ = strstr ((gchar*) self, (gchar*) needle);
#line 1531 "glib-2.0.vapi"
	result = _tmp0_ != NULL;
#line 1531 "glib-2.0.vapi"
	return result;
#line 1315 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_resolve_executable_path (const gchar* file_path)
{
	gchar* result = NULL;
#line 237 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 239 "Utility/TeeJee.FileSystem.vala"
	if (g_str_has_prefix (file_path, "/")) {
#line 1326 "TeeJee.FileSystem.c"
		gchar* _tmp0_;
#line 240 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_strdup (file_path);
#line 240 "Utility/TeeJee.FileSystem.vala"
		result = _tmp0_;
#line 240 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1334 "TeeJee.FileSystem.c"
	} else {
#line 242 "Utility/TeeJee.FileSystem.vala"
		if (!string_contains (file_path, "/")) {
#line 1338 "TeeJee.FileSystem.c"
			gchar* _tmp1_;
#line 243 "Utility/TeeJee.FileSystem.vala"
			_tmp1_ = g_find_program_in_path (file_path);
#line 243 "Utility/TeeJee.FileSystem.vala"
			result = _tmp1_;
#line 243 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1346 "TeeJee.FileSystem.c"
		} else {
#line 245 "Utility/TeeJee.FileSystem.vala"
			if (g_str_has_prefix (file_path, "./")) {
#line 1350 "TeeJee.FileSystem.c"
				gchar* _tmp2_;
				gchar* _tmp3_;
				gint _tmp4_;
				gint _tmp5_;
				gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp2_ = g_get_current_dir ();
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp3_ = _tmp2_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp4_ = strlen (file_path);
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp5_ = _tmp4_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp6_ = string_slice (file_path, (glong) 2, (glong) _tmp5_);
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp6_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = tee_jee_file_system_path_combine (_tmp3_, _tmp7_);
#line 246 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = _tmp8_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp7_);
#line 246 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp3_);
#line 246 "Utility/TeeJee.FileSystem.vala"
				result = _tmp9_;
#line 246 "Utility/TeeJee.FileSystem.vala"
				return result;
#line 1383 "TeeJee.FileSystem.c"
			} else {
#line 248 "Utility/TeeJee.FileSystem.vala"
				if (g_str_has_prefix (file_path, "../")) {
#line 1387 "TeeJee.FileSystem.c"
					gchar* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
					gchar* _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = g_get_current_dir ();
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp11_ = _tmp10_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp12_ = tee_jee_file_system_file_parent (_tmp11_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp13_ = _tmp12_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp14_ = strlen (file_path);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp15_ = _tmp14_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp16_ = string_slice (file_path, (glong) 3, (glong) _tmp15_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp17_ = _tmp16_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp18_ = tee_jee_file_system_path_combine (_tmp13_, _tmp17_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_tmp19_ = _tmp18_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp17_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp13_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp11_);
#line 249 "Utility/TeeJee.FileSystem.vala"
					result = _tmp19_;
#line 249 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1428 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp20_;
					gchar* _tmp21_;
					gchar* _tmp22_;
					gchar* _tmp23_;
#line 252 "Utility/TeeJee.FileSystem.vala"
					_tmp20_ = g_get_current_dir ();
#line 252 "Utility/TeeJee.FileSystem.vala"
					_tmp21_ = _tmp20_;
#line 252 "Utility/TeeJee.FileSystem.vala"
					_tmp22_ = tee_jee_file_system_path_combine (_tmp21_, file_path);
#line 252 "Utility/TeeJee.FileSystem.vala"
					_tmp23_ = _tmp22_;
#line 252 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp21_);
#line 252 "Utility/TeeJee.FileSystem.vala"
					result = _tmp23_;
#line 252 "Utility/TeeJee.FileSystem.vala"
					return result;
#line 1448 "TeeJee.FileSystem.c"
				}
			}
		}
	}
}

gint64
tee_jee_file_system_file_get_size (const gchar* file_path)
{
	GError* _inner_error0_ = NULL;
	gint64 result = 0LL;
#line 258 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, 0LL);
#line 1462 "TeeJee.FileSystem.c"
	{
		GFile* file = NULL;
		GFile* _tmp0_;
#line 262 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 262 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 264 "Utility/TeeJee.FileSystem.vala"
		if (g_file_test (file_path, G_FILE_TEST_EXISTS)) {
#line 1472 "TeeJee.FileSystem.c"
			gboolean _tmp1_ = FALSE;
#line 266 "Utility/TeeJee.FileSystem.vala"
			if (g_file_test (file_path, G_FILE_TEST_IS_REGULAR)) {
#line 267 "Utility/TeeJee.FileSystem.vala"
				_tmp1_ = !g_file_test (file_path, G_FILE_TEST_IS_SYMLINK);
#line 1478 "TeeJee.FileSystem.c"
			} else {
#line 266 "Utility/TeeJee.FileSystem.vala"
				_tmp1_ = FALSE;
#line 1482 "TeeJee.FileSystem.c"
			}
#line 266 "Utility/TeeJee.FileSystem.vala"
			if (_tmp1_) {
#line 1486 "TeeJee.FileSystem.c"
				GFileInfo* _tmp2_ = NULL;
				GFile* _tmp3_;
				GFileInfo* _tmp4_;
#line 269 "Utility/TeeJee.FileSystem.vala"
				_tmp3_ = file;
#line 269 "Utility/TeeJee.FileSystem.vala"
				_tmp4_ = g_file_query_info (_tmp3_, "standard::size", 0, NULL, &_inner_error0_);
#line 269 "Utility/TeeJee.FileSystem.vala"
				_tmp2_ = _tmp4_;
#line 269 "Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 269 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (file);
#line 1500 "TeeJee.FileSystem.c"
					goto __catch0_g_error;
				}
#line 269 "Utility/TeeJee.FileSystem.vala"
				result = g_file_info_get_size (_tmp2_);
#line 269 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp2_);
#line 269 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 269 "Utility/TeeJee.FileSystem.vala"
				return result;
#line 1511 "TeeJee.FileSystem.c"
			}
		}
#line 260 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 1516 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp5_;
		const gchar* _tmp6_;
#line 260 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 260 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 274 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = e;
#line 274 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_->message;
#line 274 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp6_, FALSE, FALSE);
#line 260 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1536 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 260 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1541 "TeeJee.FileSystem.c"
		gint64 _tmp7_ = -1LL;
#line 260 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 260 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 260 "Utility/TeeJee.FileSystem.vala"
		return _tmp7_;
#line 1549 "TeeJee.FileSystem.c"
	}
#line 277 "Utility/TeeJee.FileSystem.vala"
	result = (gint64) -1;
#line 277 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1555 "TeeJee.FileSystem.c"
}

GDateTime*
tee_jee_file_system_file_get_modified_date (const gchar* file_path)
{
	GDateTime* _tmp17_;
	GError* _inner_error0_ = NULL;
	GDateTime* result = NULL;
#line 280 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1566 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 283 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 283 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 284 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 284 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1580 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			GTimeVal _tmp10_ = {0};
			GDateTime* _tmp11_;
			GDateTime* _tmp12_;
			GDateTime* _tmp13_;
			GDateTime* _tmp14_;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_TIME_MODIFIED);
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error0_);
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 285 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 285 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 285 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1614 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 285 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 285 "Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 286 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 286 "Utility/TeeJee.FileSystem.vala"
			g_file_info_get_modification_time (_tmp9_, &_tmp10_);
#line 286 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_date_time_new_from_timeval_utc (&_tmp10_);
#line 286 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 286 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_date_time_to_local (_tmp12_);
#line 286 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 286 "Utility/TeeJee.FileSystem.vala"
			_g_date_time_unref0 (_tmp12_);
#line 286 "Utility/TeeJee.FileSystem.vala"
			result = _tmp14_;
#line 286 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 286 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 286 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 286 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1649 "TeeJee.FileSystem.c"
		}
#line 281 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 281 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1655 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 281 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 281 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 290 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = e;
#line 290 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_->message;
#line 290 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 281 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1675 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 281 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 281 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 281 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 281 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1686 "TeeJee.FileSystem.c"
	}
#line 293 "Utility/TeeJee.FileSystem.vala"
	_tmp17_ = g_date_time_new_from_unix_utc ((gint64) 0);
#line 293 "Utility/TeeJee.FileSystem.vala"
	result = _tmp17_;
#line 293 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1694 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_file_get_symlink_target (const gchar* file_path)
{
	gchar* _tmp14_;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 296 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 1705 "TeeJee.FileSystem.c"
	{
		GFileInfo* info = NULL;
		GFile* file = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 299 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (file_path);
#line 299 "Utility/TeeJee.FileSystem.vala"
		file = _tmp0_;
#line 300 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = file;
#line 300 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 1719 "TeeJee.FileSystem.c"
			GFileInfo* _tmp2_ = NULL;
			GFile* _tmp3_;
			gchar* _tmp4_;
			gchar* _tmp5_;
			GFileInfo* _tmp6_;
			GFileInfo* _tmp7_;
			GFileInfo* _tmp8_;
			GFileInfo* _tmp9_;
			const gchar* _tmp10_;
			gchar* _tmp11_;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = file;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET);
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = _tmp4_;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_file_query_info (_tmp3_, _tmp5_, 0, NULL, &_inner_error0_);
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp6_;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp5_);
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = _tmp7_;
#line 301 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 301 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 301 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 1750 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = _tmp2_;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = NULL;
#line 301 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 301 "Utility/TeeJee.FileSystem.vala"
			info = _tmp8_;
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = info;
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = g_file_info_get_symlink_target (_tmp9_);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strdup (_tmp10_);
#line 302 "Utility/TeeJee.FileSystem.vala"
			result = _tmp11_;
#line 302 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp2_);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 302 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 302 "Utility/TeeJee.FileSystem.vala"
			return result;
#line 1777 "TeeJee.FileSystem.c"
		}
#line 297 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 297 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (info);
#line 1783 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 297 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 297 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 306 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 306 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 306 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 297 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 1803 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 297 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 297 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 297 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 297 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 1814 "TeeJee.FileSystem.c"
	}
#line 309 "Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strdup ("");
#line 309 "Utility/TeeJee.FileSystem.vala"
	result = _tmp14_;
#line 309 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1822 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_exists (const gchar* dir_path)
{
	gboolean _tmp0_ = FALSE;
	gboolean result = FALSE;
#line 314 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 316 "Utility/TeeJee.FileSystem.vala"
	if (g_file_test (dir_path, G_FILE_TEST_EXISTS)) {
#line 316 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_test (dir_path, G_FILE_TEST_IS_DIR);
#line 1836 "TeeJee.FileSystem.c"
	} else {
#line 316 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = FALSE;
#line 1840 "TeeJee.FileSystem.c"
	}
#line 316 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 316 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 1846 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_create (const gchar* dir_path,
                                gboolean show_message)
{
	gboolean _tmp17_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 319 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 1858 "TeeJee.FileSystem.c"
	{
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 324 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 324 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 326 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 326 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL) == FALSE) {
#line 1871 "TeeJee.FileSystem.c"
			gboolean ok = FALSE;
			GFile* _tmp2_;
#line 328 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 328 "Utility/TeeJee.FileSystem.vala"
			ok = g_file_make_directory_with_parents (_tmp2_, NULL, &_inner_error0_);
#line 328 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 328 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 1882 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 330 "Utility/TeeJee.FileSystem.vala"
			if (show_message) {
#line 331 "Utility/TeeJee.FileSystem.vala"
				if (ok) {
#line 1889 "TeeJee.FileSystem.c"
					gchar* _tmp3_;
					gchar* _tmp4_;
					gchar* _tmp5_;
					gchar* _tmp6_;
#line 332 "Utility/TeeJee.FileSystem.vala"
					_tmp3_ = g_strdup_printf (": %s", dir_path);
#line 332 "Utility/TeeJee.FileSystem.vala"
					_tmp4_ = _tmp3_;
#line 332 "Utility/TeeJee.FileSystem.vala"
					_tmp5_ = g_strconcat (_ ("Created directory"), _tmp4_, NULL);
#line 332 "Utility/TeeJee.FileSystem.vala"
					_tmp6_ = _tmp5_;
#line 332 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_msg (_tmp6_, FALSE);
#line 332 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp6_);
#line 332 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp4_);
#line 1908 "TeeJee.FileSystem.c"
				} else {
					gchar* _tmp7_;
					gchar* _tmp8_;
					gchar* _tmp9_;
					gchar* _tmp10_;
#line 335 "Utility/TeeJee.FileSystem.vala"
					_tmp7_ = g_strdup_printf (": %s", dir_path);
#line 335 "Utility/TeeJee.FileSystem.vala"
					_tmp8_ = _tmp7_;
#line 335 "Utility/TeeJee.FileSystem.vala"
					_tmp9_ = g_strconcat (_ ("Failed to create directory"), _tmp8_, NULL);
#line 335 "Utility/TeeJee.FileSystem.vala"
					_tmp10_ = _tmp9_;
#line 335 "Utility/TeeJee.FileSystem.vala"
					tee_jee_logging_log_error (_tmp10_, FALSE, FALSE);
#line 335 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp10_);
#line 335 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp8_);
#line 1928 "TeeJee.FileSystem.c"
				}
			}
		}
#line 340 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 340 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 340 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1938 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 323 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 323 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 343 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = e;
#line 343 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_->message;
#line 343 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp12_, FALSE, FALSE);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = _tmp13_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = g_strconcat (_ ("Failed to create directory"), _tmp14_, NULL);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = _tmp15_;
#line 344 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp16_);
#line 344 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp14_);
#line 345 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 345 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 345 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 1980 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 323 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 323 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 323 "Utility/TeeJee.FileSystem.vala"
	return _tmp17_;
#line 1989 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_delete (const gchar* dir_path,
                                gboolean show_message)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint status = 0;
	const gchar* _tmp5_;
	gchar* _tmp6_ = NULL;
	gchar* _tmp7_ = NULL;
	gint _tmp8_;
	gboolean result = FALSE;
#line 349 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 353 "Utility/TeeJee.FileSystem.vala"
	if (!tee_jee_file_system_dir_exists (dir_path)) {
#line 354 "Utility/TeeJee.FileSystem.vala"
		result = TRUE;
#line 354 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2018 "TeeJee.FileSystem.c"
	}
#line 357 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 357 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 357 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("rm -rf '%s'", _tmp1_);
#line 357 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 357 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 357 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 359 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 359 "Utility/TeeJee.FileSystem.vala"
	tee_jee_logging_log_debug (_tmp4_);
#line 362 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 362 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_process_helper_exec_sync (_tmp5_, &_tmp6_, &_tmp7_);
#line 362 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 362 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp6_;
#line 362 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 362 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp7_;
#line 362 "Utility/TeeJee.FileSystem.vala"
	status = _tmp8_;
#line 364 "Utility/TeeJee.FileSystem.vala"
	if (show_message) {
#line 365 "Utility/TeeJee.FileSystem.vala"
		if (status == 0) {
#line 2054 "TeeJee.FileSystem.c"
			gchar* _tmp9_;
			gchar* _tmp10_;
			gchar* _tmp11_;
			gchar* _tmp12_;
#line 366 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_strdup_printf (": %s", dir_path);
#line 366 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp9_;
#line 366 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = g_strconcat (_ ("Deleted directory"), _tmp10_, NULL);
#line 366 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = _tmp11_;
#line 366 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_msg (_tmp12_, FALSE);
#line 366 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp12_);
#line 366 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp10_);
#line 2073 "TeeJee.FileSystem.c"
		} else {
			gchar* _tmp13_;
			gchar* _tmp14_;
			gchar* _tmp15_;
			gchar* _tmp16_;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
#line 369 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_strdup_printf (": %s", dir_path);
#line 369 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = _tmp13_;
#line 369 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = g_strconcat (_ ("Failed to delete directory"), _tmp14_, NULL);
#line 369 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = _tmp15_;
#line 369 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp16_, FALSE, FALSE);
#line 369 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp16_);
#line 369 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp14_);
#line 370 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = std_out;
#line 370 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp17_, FALSE, FALSE);
#line 371 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = std_err;
#line 371 "Utility/TeeJee.FileSystem.vala"
			tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 2103 "TeeJee.FileSystem.c"
		}
	}
#line 375 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 375 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 375 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 375 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 375 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2116 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_dir_is_empty (const gchar* dir_path)
{
	gboolean _tmp14_ = FALSE;
	GError* _inner_error0_ = NULL;
	gboolean result = FALSE;
#line 378 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 2127 "TeeJee.FileSystem.c"
	{
		gboolean is_empty = FALSE;
		GFile* dir = NULL;
		GFile* _tmp0_;
		GFile* _tmp1_;
#line 383 "Utility/TeeJee.FileSystem.vala"
		is_empty = TRUE;
#line 384 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = g_file_parse_name (dir_path);
#line 384 "Utility/TeeJee.FileSystem.vala"
		dir = _tmp0_;
#line 385 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = dir;
#line 385 "Utility/TeeJee.FileSystem.vala"
		if (g_file_query_exists (_tmp1_, NULL)) {
#line 2143 "TeeJee.FileSystem.c"
			GFileInfo* info = NULL;
			GFileEnumerator* enu = NULL;
			GFile* _tmp2_;
			gchar* _tmp3_;
			gchar* _tmp4_;
			GFileEnumerator* _tmp5_;
			GFileEnumerator* _tmp6_;
#line 387 "Utility/TeeJee.FileSystem.vala"
			_tmp2_ = dir;
#line 387 "Utility/TeeJee.FileSystem.vala"
			_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 387 "Utility/TeeJee.FileSystem.vala"
			_tmp4_ = _tmp3_;
#line 387 "Utility/TeeJee.FileSystem.vala"
			_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 387 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = _tmp5_;
#line 387 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp4_);
#line 387 "Utility/TeeJee.FileSystem.vala"
			enu = _tmp6_;
#line 387 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 387 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 387 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (dir);
#line 2171 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 388 "Utility/TeeJee.FileSystem.vala"
			while (TRUE) {
#line 2176 "TeeJee.FileSystem.c"
				GFileInfo* _tmp7_ = NULL;
				GFileEnumerator* _tmp8_;
				GFileInfo* _tmp9_;
				GFileInfo* _tmp10_;
				GFileInfo* _tmp11_;
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp8_ = enu;
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = _tmp9_;
#line 388 "Utility/TeeJee.FileSystem.vala"
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 388 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (enu);
#line 388 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (info);
#line 388 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (dir);
#line 2196 "TeeJee.FileSystem.c"
					goto __catch0_g_error;
				}
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp10_ = _tmp7_;
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp7_ = NULL;
#line 388 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (info);
#line 388 "Utility/TeeJee.FileSystem.vala"
				info = _tmp10_;
#line 388 "Utility/TeeJee.FileSystem.vala"
				_tmp11_ = info;
#line 388 "Utility/TeeJee.FileSystem.vala"
				if (!(_tmp11_ != NULL)) {
#line 388 "Utility/TeeJee.FileSystem.vala"
					_g_object_unref0 (_tmp7_);
#line 388 "Utility/TeeJee.FileSystem.vala"
					break;
#line 2215 "TeeJee.FileSystem.c"
				}
#line 389 "Utility/TeeJee.FileSystem.vala"
				is_empty = FALSE;
#line 390 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 390 "Utility/TeeJee.FileSystem.vala"
				break;
#line 2223 "TeeJee.FileSystem.c"
			}
#line 385 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (enu);
#line 385 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (info);
#line 2229 "TeeJee.FileSystem.c"
		}
#line 393 "Utility/TeeJee.FileSystem.vala"
		result = is_empty;
#line 393 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (dir);
#line 393 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2237 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 382 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 382 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 396 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = e;
#line 396 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_->message;
#line 396 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp13_, FALSE, FALSE);
#line 397 "Utility/TeeJee.FileSystem.vala"
		result = FALSE;
#line 397 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 397 "Utility/TeeJee.FileSystem.vala"
		return result;
#line 2261 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 382 "Utility/TeeJee.FileSystem.vala"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 382 "Utility/TeeJee.FileSystem.vala"
	g_clear_error (&_inner_error0_);
#line 382 "Utility/TeeJee.FileSystem.vala"
	return _tmp14_;
#line 2270 "TeeJee.FileSystem.c"
}

static gboolean
int64_try_parse (const gchar* str,
                 gint64* _result_,
                 const gchar* * unparsed,
                 guint _base)
{
	gint64 _vala__result_ = 0LL;
	const gchar* _vala_unparsed = NULL;
	gchar* endptr = NULL;
	gchar* _tmp0_ = NULL;
	gint64 _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gboolean result = FALSE;
#line 775 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 777 "glib-2.0.vapi"
	errno = 0;
#line 778 "glib-2.0.vapi"
	_tmp1_ = g_ascii_strtoll (str, &_tmp0_, _base);
#line 778 "glib-2.0.vapi"
	endptr = _tmp0_;
#line 778 "glib-2.0.vapi"
	_vala__result_ = _tmp1_;
#line 779 "glib-2.0.vapi"
	_tmp2_ = endptr;
#line 779 "glib-2.0.vapi"
	_tmp3_ = strlen (str);
#line 779 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 779 "glib-2.0.vapi"
	if (_tmp2_ == (((gchar*) str) + _tmp4_)) {
#line 2306 "TeeJee.FileSystem.c"
		gboolean _tmp5_ = FALSE;
#line 780 "glib-2.0.vapi"
		_vala_unparsed = "";
#line 781 "glib-2.0.vapi"
		if (errno != ERANGE) {
#line 781 "glib-2.0.vapi"
			_tmp5_ = errno != EINVAL;
#line 2314 "TeeJee.FileSystem.c"
		} else {
#line 781 "glib-2.0.vapi"
			_tmp5_ = FALSE;
#line 2318 "TeeJee.FileSystem.c"
		}
#line 781 "glib-2.0.vapi"
		result = _tmp5_;
#line 781 "glib-2.0.vapi"
		if (_result_) {
#line 781 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2326 "TeeJee.FileSystem.c"
		}
#line 781 "glib-2.0.vapi"
		if (unparsed) {
#line 781 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2332 "TeeJee.FileSystem.c"
		}
#line 781 "glib-2.0.vapi"
		return result;
#line 2336 "TeeJee.FileSystem.c"
	} else {
		gchar* _tmp6_;
#line 783 "glib-2.0.vapi"
		_tmp6_ = endptr;
#line 783 "glib-2.0.vapi"
		_vala_unparsed = (const gchar*) _tmp6_;
#line 784 "glib-2.0.vapi"
		result = FALSE;
#line 784 "glib-2.0.vapi"
		if (_result_) {
#line 784 "glib-2.0.vapi"
			*_result_ = _vala__result_;
#line 2349 "TeeJee.FileSystem.c"
		}
#line 784 "glib-2.0.vapi"
		if (unparsed) {
#line 784 "glib-2.0.vapi"
			*unparsed = _vala_unparsed;
#line 2355 "TeeJee.FileSystem.c"
		}
#line 784 "glib-2.0.vapi"
		return result;
#line 2359 "TeeJee.FileSystem.c"
	}
#line 775 "glib-2.0.vapi"
	if (_result_) {
#line 775 "glib-2.0.vapi"
		*_result_ = _vala__result_;
#line 2365 "TeeJee.FileSystem.c"
	}
#line 775 "glib-2.0.vapi"
	if (unparsed) {
#line 775 "glib-2.0.vapi"
		*unparsed = _vala_unparsed;
#line 2371 "TeeJee.FileSystem.c"
	}
}

gboolean
tee_jee_file_system_filesystem_supports_hardlinks (const gchar* path,
                                                   gboolean* is_readonly)
{
	gboolean _vala_is_readonly = FALSE;
	gboolean supports_hardlinks = FALSE;
	gchar* test_file = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	gboolean result = FALSE;
#line 401 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, FALSE);
#line 403 "Utility/TeeJee.FileSystem.vala"
	supports_hardlinks = FALSE;
#line 404 "Utility/TeeJee.FileSystem.vala"
	_vala_is_readonly = FALSE;
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strconcat (_tmp1_, "~", NULL);
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = tee_jee_file_system_path_combine (path, _tmp3_);
#line 406 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = _tmp4_;
#line 406 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp3_);
#line 406 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 406 "Utility/TeeJee.FileSystem.vala"
	test_file = _tmp5_;
#line 408 "Utility/TeeJee.FileSystem.vala"
	_tmp6_ = test_file;
#line 408 "Utility/TeeJee.FileSystem.vala"
	if (tee_jee_file_system_file_write (_tmp6_, "")) {
#line 2418 "TeeJee.FileSystem.c"
		gchar* test_file2 = NULL;
		gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* cmd = NULL;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		const gchar* _tmp16_;
		gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		gchar* _tmp20_;
		const gchar* _tmp21_;
		gint status = 0;
		const gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		const gchar* _tmp27_;
		gchar* std_out = NULL;
		gchar* std_err = NULL;
		const gchar* _tmp28_;
		gchar* _tmp29_ = NULL;
		gchar* _tmp30_ = NULL;
		gint _tmp31_;
		const gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gint64 count = 0LL;
		const gchar* _tmp35_;
		gint64 _tmp36_ = 0LL;
		gboolean _tmp37_;
		const gchar* _tmp38_;
		const gchar* _tmp39_;
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = tee_jee_misc_random_string (8, "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz1234567890");
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = g_strconcat (_tmp8_, "~", NULL);
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = _tmp9_;
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = tee_jee_file_system_path_combine (path, _tmp10_);
#line 410 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = _tmp11_;
#line 410 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp10_);
#line 410 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp8_);
#line 410 "Utility/TeeJee.FileSystem.vala"
		test_file2 = _tmp12_;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = test_file;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = tee_jee_file_system_escape_single_quote (_tmp13_);
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp15_ = _tmp14_;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp16_ = test_file2;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = tee_jee_file_system_escape_single_quote (_tmp16_);
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp19_ = g_strdup_printf ("ln '%s' '%s'", _tmp15_, _tmp18_);
#line 412 "Utility/TeeJee.FileSystem.vala"
		_tmp20_ = _tmp19_;
#line 412 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp18_);
#line 412 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp15_);
#line 412 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp20_;
#line 416 "Utility/TeeJee.FileSystem.vala"
		_tmp21_ = cmd;
#line 416 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp21_);
#line 418 "Utility/TeeJee.FileSystem.vala"
		_tmp22_ = cmd;
#line 418 "Utility/TeeJee.FileSystem.vala"
		status = tee_jee_process_helper_exec_sync (_tmp22_, NULL, NULL);
#line 420 "Utility/TeeJee.FileSystem.vala"
		_tmp23_ = test_file;
#line 420 "Utility/TeeJee.FileSystem.vala"
		_tmp24_ = tee_jee_file_system_escape_single_quote (_tmp23_);
#line 420 "Utility/TeeJee.FileSystem.vala"
		_tmp25_ = _tmp24_;
#line 420 "Utility/TeeJee.FileSystem.vala"
		_tmp26_ = g_strdup_printf ("stat --printf '%%h' '%s'", _tmp25_);
#line 420 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 420 "Utility/TeeJee.FileSystem.vala"
		cmd = _tmp26_;
#line 420 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp25_);
#line 423 "Utility/TeeJee.FileSystem.vala"
		_tmp27_ = cmd;
#line 423 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp27_);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_tmp28_ = cmd;
#line 426 "Utility/TeeJee.FileSystem.vala"
		_tmp31_ = tee_jee_process_helper_exec_sync (_tmp28_, &_tmp29_, &_tmp30_);
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 426 "Utility/TeeJee.FileSystem.vala"
		std_out = _tmp29_;
#line 426 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 426 "Utility/TeeJee.FileSystem.vala"
		std_err = _tmp30_;
#line 426 "Utility/TeeJee.FileSystem.vala"
		status = _tmp31_;
#line 427 "Utility/TeeJee.FileSystem.vala"
		_tmp32_ = std_out;
#line 427 "Utility/TeeJee.FileSystem.vala"
		_tmp33_ = g_strdup_printf ("stdout: %s", _tmp32_);
#line 427 "Utility/TeeJee.FileSystem.vala"
		_tmp34_ = _tmp33_;
#line 427 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_debug (_tmp34_);
#line 427 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp34_);
#line 429 "Utility/TeeJee.FileSystem.vala"
		count = (gint64) 0;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp35_ = std_out;
#line 430 "Utility/TeeJee.FileSystem.vala"
		_tmp37_ = int64_try_parse (_tmp35_, &_tmp36_, NULL, (guint) 0);
#line 430 "Utility/TeeJee.FileSystem.vala"
		count = _tmp36_;
#line 430 "Utility/TeeJee.FileSystem.vala"
		if (_tmp37_) {
#line 431 "Utility/TeeJee.FileSystem.vala"
			if (count > ((gint64) 1)) {
#line 432 "Utility/TeeJee.FileSystem.vala"
				supports_hardlinks = TRUE;
#line 2562 "TeeJee.FileSystem.c"
			}
		}
#line 436 "Utility/TeeJee.FileSystem.vala"
		_tmp38_ = test_file2;
#line 436 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp38_);
#line 437 "Utility/TeeJee.FileSystem.vala"
		_tmp39_ = test_file;
#line 437 "Utility/TeeJee.FileSystem.vala"
		tee_jee_file_system_file_delete (_tmp39_);
#line 408 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_err);
#line 408 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (std_out);
#line 408 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (cmd);
#line 408 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (test_file2);
#line 2581 "TeeJee.FileSystem.c"
	} else {
#line 440 "Utility/TeeJee.FileSystem.vala"
		_vala_is_readonly = TRUE;
#line 2585 "TeeJee.FileSystem.c"
	}
#line 443 "Utility/TeeJee.FileSystem.vala"
	result = supports_hardlinks;
#line 443 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (test_file);
#line 443 "Utility/TeeJee.FileSystem.vala"
	if (is_readonly) {
#line 443 "Utility/TeeJee.FileSystem.vala"
		*is_readonly = _vala_is_readonly;
#line 2595 "TeeJee.FileSystem.c"
	}
#line 443 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2599 "TeeJee.FileSystem.c"
}

static gint
__lambda15_ (const gchar* a,
             const gchar* b)
{
	GCompareFunc _tmp0_;
	gint result = 0;
#line 465 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 465 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 466 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 466 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_ (a, b);
#line 466 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2618 "TeeJee.FileSystem.c"
}

static gint
___lambda15__gcompare_data_func (gconstpointer a,
                                 gconstpointer b,
                                 gpointer self)
{
	gint result;
	result = __lambda15_ ((const gchar*) a, (const gchar*) b);
#line 465 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2630 "TeeJee.FileSystem.c"
}

GeeArrayList*
tee_jee_file_system_dir_list_names (const gchar* path)
{
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GCompareDataFunc entry_compare = NULL;
	gpointer entry_compare_target;
	GDestroyNotify entry_compare_target_destroy_notify;
	GeeArrayList* _tmp19_;
	GCompareDataFunc _tmp20_;
	gpointer _tmp20__target;
	GDestroyNotify _tmp20__target_destroy_notify;
	GError* _inner_error0_ = NULL;
	GeeArrayList* result = NULL;
#line 446 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 448 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 448 "Utility/TeeJee.FileSystem.vala"
	list = _tmp0_;
#line 2653 "TeeJee.FileSystem.c"
	{
		GFile* f_home = NULL;
		GFile* _tmp1_;
		GFileEnumerator* enumerator = NULL;
		GFile* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GFileEnumerator* _tmp5_;
		GFileEnumerator* _tmp6_;
		GFileInfo* file = NULL;
#line 452 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = g_file_new_for_path (path);
#line 452 "Utility/TeeJee.FileSystem.vala"
		f_home = _tmp1_;
#line 453 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = f_home;
#line 453 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = g_strdup_printf ("%s", G_FILE_ATTRIBUTE_STANDARD_NAME);
#line 453 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = _tmp3_;
#line 453 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = g_file_enumerate_children (_tmp2_, _tmp4_, 0, NULL, &_inner_error0_);
#line 453 "Utility/TeeJee.FileSystem.vala"
		_tmp6_ = _tmp5_;
#line 453 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp4_);
#line 453 "Utility/TeeJee.FileSystem.vala"
		enumerator = _tmp6_;
#line 453 "Utility/TeeJee.FileSystem.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 453 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (f_home);
#line 2686 "TeeJee.FileSystem.c"
			goto __catch0_g_error;
		}
#line 455 "Utility/TeeJee.FileSystem.vala"
		while (TRUE) {
#line 2691 "TeeJee.FileSystem.c"
			GFileInfo* _tmp7_ = NULL;
			GFileEnumerator* _tmp8_;
			GFileInfo* _tmp9_;
			GFileInfo* _tmp10_;
			GFileInfo* _tmp11_;
			gchar* name = NULL;
			GFileInfo* _tmp12_;
			const gchar* _tmp13_;
			gchar* _tmp14_;
			GeeArrayList* _tmp15_;
			const gchar* _tmp16_;
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp8_ = enumerator;
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp9_ = g_file_enumerator_next_file (_tmp8_, NULL, &_inner_error0_);
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = _tmp9_;
#line 455 "Utility/TeeJee.FileSystem.vala"
			if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 455 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (file);
#line 455 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (enumerator);
#line 455 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (f_home);
#line 2717 "TeeJee.FileSystem.c"
				goto __catch0_g_error;
			}
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp10_ = _tmp7_;
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp7_ = NULL;
#line 455 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (file);
#line 455 "Utility/TeeJee.FileSystem.vala"
			file = _tmp10_;
#line 455 "Utility/TeeJee.FileSystem.vala"
			_tmp11_ = file;
#line 455 "Utility/TeeJee.FileSystem.vala"
			if (!(_tmp11_ != NULL)) {
#line 455 "Utility/TeeJee.FileSystem.vala"
				_g_object_unref0 (_tmp7_);
#line 455 "Utility/TeeJee.FileSystem.vala"
				break;
#line 2736 "TeeJee.FileSystem.c"
			}
#line 456 "Utility/TeeJee.FileSystem.vala"
			_tmp12_ = file;
#line 456 "Utility/TeeJee.FileSystem.vala"
			_tmp13_ = g_file_info_get_name (_tmp12_);
#line 456 "Utility/TeeJee.FileSystem.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 456 "Utility/TeeJee.FileSystem.vala"
			name = _tmp14_;
#line 457 "Utility/TeeJee.FileSystem.vala"
			_tmp15_ = list;
#line 457 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = name;
#line 457 "Utility/TeeJee.FileSystem.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp15_, _tmp16_);
#line 455 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (name);
#line 455 "Utility/TeeJee.FileSystem.vala"
			_g_object_unref0 (_tmp7_);
#line 2756 "TeeJee.FileSystem.c"
		}
#line 450 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (file);
#line 450 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (enumerator);
#line 450 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (f_home);
#line 2764 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* e = NULL;
		GError* _tmp17_;
		const gchar* _tmp18_;
#line 450 "Utility/TeeJee.FileSystem.vala"
		e = _inner_error0_;
#line 450 "Utility/TeeJee.FileSystem.vala"
		_inner_error0_ = NULL;
#line 461 "Utility/TeeJee.FileSystem.vala"
		_tmp17_ = e;
#line 461 "Utility/TeeJee.FileSystem.vala"
		_tmp18_ = _tmp17_->message;
#line 461 "Utility/TeeJee.FileSystem.vala"
		tee_jee_logging_log_error (_tmp18_, FALSE, FALSE);
#line 450 "Utility/TeeJee.FileSystem.vala"
		_g_error_free0 (e);
#line 2784 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 450 "Utility/TeeJee.FileSystem.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 450 "Utility/TeeJee.FileSystem.vala"
		_g_object_unref0 (list);
#line 450 "Utility/TeeJee.FileSystem.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 450 "Utility/TeeJee.FileSystem.vala"
		g_clear_error (&_inner_error0_);
#line 450 "Utility/TeeJee.FileSystem.vala"
		return NULL;
#line 2797 "TeeJee.FileSystem.c"
	}
#line 465 "Utility/TeeJee.FileSystem.vala"
	entry_compare = ___lambda15__gcompare_data_func;
#line 465 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 465 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 468 "Utility/TeeJee.FileSystem.vala"
	_tmp19_ = list;
#line 468 "Utility/TeeJee.FileSystem.vala"
	_tmp20_ = entry_compare;
#line 468 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target = entry_compare_target;
#line 468 "Utility/TeeJee.FileSystem.vala"
	_tmp20__target_destroy_notify = entry_compare_target_destroy_notify;
#line 468 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 468 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 468 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 468 "Utility/TeeJee.FileSystem.vala"
	gee_list_sort ((GeeList*) _tmp19_, _tmp20_, _tmp20__target, _tmp20__target_destroy_notify);
#line 470 "Utility/TeeJee.FileSystem.vala"
	result = list;
#line 470 "Utility/TeeJee.FileSystem.vala"
	(entry_compare_target_destroy_notify == NULL) ? NULL : (entry_compare_target_destroy_notify (entry_compare_target), NULL);
#line 470 "Utility/TeeJee.FileSystem.vala"
	entry_compare = NULL;
#line 470 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target = NULL;
#line 470 "Utility/TeeJee.FileSystem.vala"
	entry_compare_target_destroy_notify = NULL;
#line 470 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2833 "TeeJee.FileSystem.c"
}

gboolean
tee_jee_file_system_chown (const gchar* dir_path,
                           const gchar* user,
                           const gchar* group)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint status = 0;
	gboolean result = FALSE;
#line 473 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (dir_path != NULL, FALSE);
#line 473 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (user != NULL, FALSE);
#line 473 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (group != NULL, FALSE);
#line 474 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (dir_path);
#line 474 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 474 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chown %s:%s -R '%s'", user, group, _tmp1_);
#line 474 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 474 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 474 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 475 "Utility/TeeJee.FileSystem.vala"
	status = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 476 "Utility/TeeJee.FileSystem.vala"
	result = status == 0;
#line 476 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 476 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2874 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_count (const gchar* path)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gint ret_val = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_ = NULL;
	gchar* _tmp6_ = NULL;
	gint _tmp7_;
	glong result = 0L;
#line 482 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 486 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("");
#line 486 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 491 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = tee_jee_file_system_escape_single_quote (path);
#line 491 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = _tmp1_;
#line 491 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strdup_printf ("find '%s' | wc -l", _tmp2_);
#line 491 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 491 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 491 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp2_);
#line 492 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = cmd;
#line 492 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = tee_jee_process_helper_exec_script_sync (_tmp4_, &_tmp5_, &_tmp6_, FALSE, FALSE, TRUE, FALSE);
#line 492 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 492 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp5_;
#line 492 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 492 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp6_;
#line 492 "Utility/TeeJee.FileSystem.vala"
	ret_val = _tmp7_;
#line 493 "Utility/TeeJee.FileSystem.vala"
	result = long_parse (std_out, (guint) 0);
#line 493 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 493 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 493 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 493 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 2935 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_size (const gchar* path)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* std_out = NULL;
	gchar* std_err = NULL;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_ = NULL;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	glong _tmp10_;
	glong result = 0L;
#line 497 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 501 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (path);
#line 501 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 501 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("du -s -b '%s'", _tmp1_);
#line 501 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 501 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 501 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 503 "Utility/TeeJee.FileSystem.vala"
	tee_jee_process_helper_exec_sync (cmd, &_tmp4_, &_tmp5_);
#line 503 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 503 "Utility/TeeJee.FileSystem.vala"
	std_out = _tmp4_;
#line 503 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 503 "Utility/TeeJee.FileSystem.vala"
	std_err = _tmp5_;
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = _tmp6_ = g_strsplit (std_out, "\t", 0);
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = _tmp7_;
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_[0];
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = long_parse (_tmp9_, (guint) 0);
#line 504 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 504 "Utility/TeeJee.FileSystem.vala"
	result = _tmp10_;
#line 504 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_err);
#line 504 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (std_out);
#line 504 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 504 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3003 "TeeJee.FileSystem.c"
}

glong
tee_jee_file_system_dir_size_kb (const gchar* path)
{
	glong result = 0L;
#line 508 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (path != NULL, 0L);
#line 512 "Utility/TeeJee.FileSystem.vala"
	result = (glong) (tee_jee_file_system_dir_size (path) / 1024.0);
#line 512 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3016 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_format_file_size (guint64 size,
                                      gboolean binary_units,
                                      const gchar* unit,
                                      gboolean show_units,
                                      gint decimals)
{
	gint _tmp0_ = 0;
	guint64 unit_k = 0ULL;
	guint64 _tmp1_ = 0ULL;
	guint64 unit_m = 0ULL;
	guint64 _tmp2_ = 0ULL;
	guint64 unit_g = 0ULL;
	guint64 _tmp3_ = 0ULL;
	guint64 unit_t = 0ULL;
	gchar* txt = NULL;
	gchar* _tmp4_;
	gboolean _tmp5_ = FALSE;
	gchar* result = NULL;
#line 517 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (unit != NULL, NULL);
#line 521 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 521 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1024;
#line 3044 "TeeJee.FileSystem.c"
	} else {
#line 521 "Utility/TeeJee.FileSystem.vala"
		_tmp0_ = 1000;
#line 3048 "TeeJee.FileSystem.c"
	}
#line 521 "Utility/TeeJee.FileSystem.vala"
	unit_k = (guint64) _tmp0_;
#line 522 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 522 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1024 * unit_k;
#line 3056 "TeeJee.FileSystem.c"
	} else {
#line 522 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = 1000 * unit_k;
#line 3060 "TeeJee.FileSystem.c"
	}
#line 522 "Utility/TeeJee.FileSystem.vala"
	unit_m = _tmp1_;
#line 523 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 523 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1024 * unit_m;
#line 3068 "TeeJee.FileSystem.c"
	} else {
#line 523 "Utility/TeeJee.FileSystem.vala"
		_tmp2_ = 1000 * unit_m;
#line 3072 "TeeJee.FileSystem.c"
	}
#line 523 "Utility/TeeJee.FileSystem.vala"
	unit_g = _tmp2_;
#line 524 "Utility/TeeJee.FileSystem.vala"
	if (binary_units) {
#line 524 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1024 * unit_g;
#line 3080 "TeeJee.FileSystem.c"
	} else {
#line 524 "Utility/TeeJee.FileSystem.vala"
		_tmp3_ = 1000 * unit_g;
#line 3084 "TeeJee.FileSystem.c"
	}
#line 524 "Utility/TeeJee.FileSystem.vala"
	unit_t = _tmp3_;
#line 528 "Utility/TeeJee.FileSystem.vala"
	_tmp4_ = g_strdup ("");
#line 528 "Utility/TeeJee.FileSystem.vala"
	txt = _tmp4_;
#line 530 "Utility/TeeJee.FileSystem.vala"
	if (size > unit_t) {
#line 3094 "TeeJee.FileSystem.c"
		gboolean _tmp6_ = FALSE;
		gint _tmp7_;
		gint _tmp8_;
#line 530 "Utility/TeeJee.FileSystem.vala"
		_tmp7_ = strlen (unit);
#line 530 "Utility/TeeJee.FileSystem.vala"
		_tmp8_ = _tmp7_;
#line 530 "Utility/TeeJee.FileSystem.vala"
		if (_tmp8_ == 0) {
#line 530 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = TRUE;
#line 3106 "TeeJee.FileSystem.c"
		} else {
#line 530 "Utility/TeeJee.FileSystem.vala"
			_tmp6_ = g_strcmp0 (unit, "t") == 0;
#line 3110 "TeeJee.FileSystem.c"
		}
#line 530 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = _tmp6_;
#line 3114 "TeeJee.FileSystem.c"
	} else {
#line 530 "Utility/TeeJee.FileSystem.vala"
		_tmp5_ = FALSE;
#line 3118 "TeeJee.FileSystem.c"
	}
#line 530 "Utility/TeeJee.FileSystem.vala"
	if (_tmp5_) {
#line 3122 "TeeJee.FileSystem.c"
		const gchar* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp9_ = txt;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp10_ = g_strdup_printf ("%%'0.%df", decimals);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp11_ = _tmp10_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp12_ = g_strdup_printf (_tmp11_, size / (1.0 * unit_t));
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp13_ = _tmp12_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_tmp14_ = g_strconcat (_tmp9_, _tmp13_, NULL);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (txt);
#line 531 "Utility/TeeJee.FileSystem.vala"
		txt = _tmp14_;
#line 531 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp13_);
#line 531 "Utility/TeeJee.FileSystem.vala"
		_g_free0 (_tmp11_);
#line 532 "Utility/TeeJee.FileSystem.vala"
		if (show_units) {
#line 3151 "TeeJee.FileSystem.c"
			const gchar* _tmp15_ = NULL;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gchar* _tmp19_;
#line 533 "Utility/TeeJee.FileSystem.vala"
			if (binary_units) {
#line 533 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "Ti";
#line 3161 "TeeJee.FileSystem.c"
			} else {
#line 533 "Utility/TeeJee.FileSystem.vala"
				_tmp15_ = "T";
#line 3165 "TeeJee.FileSystem.c"
			}
#line 533 "Utility/TeeJee.FileSystem.vala"
			_tmp16_ = txt;
#line 533 "Utility/TeeJee.FileSystem.vala"
			_tmp17_ = g_strdup_printf (" %sB", _tmp15_);
#line 533 "Utility/TeeJee.FileSystem.vala"
			_tmp18_ = _tmp17_;
#line 533 "Utility/TeeJee.FileSystem.vala"
			_tmp19_ = g_strconcat (_tmp16_, _tmp18_, NULL);
#line 533 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 533 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp19_;
#line 533 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp18_);
#line 3181 "TeeJee.FileSystem.c"
		}
	} else {
		gboolean _tmp20_ = FALSE;
#line 536 "Utility/TeeJee.FileSystem.vala"
		if (size > unit_g) {
#line 3187 "TeeJee.FileSystem.c"
			gboolean _tmp21_ = FALSE;
			gint _tmp22_;
			gint _tmp23_;
#line 536 "Utility/TeeJee.FileSystem.vala"
			_tmp22_ = strlen (unit);
#line 536 "Utility/TeeJee.FileSystem.vala"
			_tmp23_ = _tmp22_;
#line 536 "Utility/TeeJee.FileSystem.vala"
			if (_tmp23_ == 0) {
#line 536 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = TRUE;
#line 3199 "TeeJee.FileSystem.c"
			} else {
#line 536 "Utility/TeeJee.FileSystem.vala"
				_tmp21_ = g_strcmp0 (unit, "g") == 0;
#line 3203 "TeeJee.FileSystem.c"
			}
#line 536 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = _tmp21_;
#line 3207 "TeeJee.FileSystem.c"
		} else {
#line 536 "Utility/TeeJee.FileSystem.vala"
			_tmp20_ = FALSE;
#line 3211 "TeeJee.FileSystem.c"
		}
#line 536 "Utility/TeeJee.FileSystem.vala"
		if (_tmp20_) {
#line 3215 "TeeJee.FileSystem.c"
			const gchar* _tmp24_;
			gchar* _tmp25_;
			gchar* _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gchar* _tmp29_;
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp24_ = txt;
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp25_ = g_strdup_printf ("%%'0.%df", decimals);
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp26_ = _tmp25_;
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp27_ = g_strdup_printf (_tmp26_, size / (1.0 * unit_g));
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp28_ = _tmp27_;
#line 537 "Utility/TeeJee.FileSystem.vala"
			_tmp29_ = g_strconcat (_tmp24_, _tmp28_, NULL);
#line 537 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (txt);
#line 537 "Utility/TeeJee.FileSystem.vala"
			txt = _tmp29_;
#line 537 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp28_);
#line 537 "Utility/TeeJee.FileSystem.vala"
			_g_free0 (_tmp26_);
#line 538 "Utility/TeeJee.FileSystem.vala"
			if (show_units) {
#line 3244 "TeeJee.FileSystem.c"
				const gchar* _tmp30_ = NULL;
				const gchar* _tmp31_;
				gchar* _tmp32_;
				gchar* _tmp33_;
				gchar* _tmp34_;
#line 539 "Utility/TeeJee.FileSystem.vala"
				if (binary_units) {
#line 539 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "Gi";
#line 3254 "TeeJee.FileSystem.c"
				} else {
#line 539 "Utility/TeeJee.FileSystem.vala"
					_tmp30_ = "G";
#line 3258 "TeeJee.FileSystem.c"
				}
#line 539 "Utility/TeeJee.FileSystem.vala"
				_tmp31_ = txt;
#line 539 "Utility/TeeJee.FileSystem.vala"
				_tmp32_ = g_strdup_printf (" %sB", _tmp30_);
#line 539 "Utility/TeeJee.FileSystem.vala"
				_tmp33_ = _tmp32_;
#line 539 "Utility/TeeJee.FileSystem.vala"
				_tmp34_ = g_strconcat (_tmp31_, _tmp33_, NULL);
#line 539 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 539 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp34_;
#line 539 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp33_);
#line 3274 "TeeJee.FileSystem.c"
			}
		} else {
			gboolean _tmp35_ = FALSE;
#line 542 "Utility/TeeJee.FileSystem.vala"
			if (size > unit_m) {
#line 3280 "TeeJee.FileSystem.c"
				gboolean _tmp36_ = FALSE;
				gint _tmp37_;
				gint _tmp38_;
#line 542 "Utility/TeeJee.FileSystem.vala"
				_tmp37_ = strlen (unit);
#line 542 "Utility/TeeJee.FileSystem.vala"
				_tmp38_ = _tmp37_;
#line 542 "Utility/TeeJee.FileSystem.vala"
				if (_tmp38_ == 0) {
#line 542 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = TRUE;
#line 3292 "TeeJee.FileSystem.c"
				} else {
#line 542 "Utility/TeeJee.FileSystem.vala"
					_tmp36_ = g_strcmp0 (unit, "m") == 0;
#line 3296 "TeeJee.FileSystem.c"
				}
#line 542 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = _tmp36_;
#line 3300 "TeeJee.FileSystem.c"
			} else {
#line 542 "Utility/TeeJee.FileSystem.vala"
				_tmp35_ = FALSE;
#line 3304 "TeeJee.FileSystem.c"
			}
#line 542 "Utility/TeeJee.FileSystem.vala"
			if (_tmp35_) {
#line 3308 "TeeJee.FileSystem.c"
				const gchar* _tmp39_;
				gchar* _tmp40_;
				gchar* _tmp41_;
				gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp39_ = txt;
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp40_ = g_strdup_printf ("%%'0.%df", decimals);
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp41_ = _tmp40_;
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp42_ = g_strdup_printf (_tmp41_, size / (1.0 * unit_m));
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp43_ = _tmp42_;
#line 543 "Utility/TeeJee.FileSystem.vala"
				_tmp44_ = g_strconcat (_tmp39_, _tmp43_, NULL);
#line 543 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (txt);
#line 543 "Utility/TeeJee.FileSystem.vala"
				txt = _tmp44_;
#line 543 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp43_);
#line 543 "Utility/TeeJee.FileSystem.vala"
				_g_free0 (_tmp41_);
#line 544 "Utility/TeeJee.FileSystem.vala"
				if (show_units) {
#line 3337 "TeeJee.FileSystem.c"
					const gchar* _tmp45_ = NULL;
					const gchar* _tmp46_;
					gchar* _tmp47_;
					gchar* _tmp48_;
					gchar* _tmp49_;
#line 545 "Utility/TeeJee.FileSystem.vala"
					if (binary_units) {
#line 545 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "Mi";
#line 3347 "TeeJee.FileSystem.c"
					} else {
#line 545 "Utility/TeeJee.FileSystem.vala"
						_tmp45_ = "M";
#line 3351 "TeeJee.FileSystem.c"
					}
#line 545 "Utility/TeeJee.FileSystem.vala"
					_tmp46_ = txt;
#line 545 "Utility/TeeJee.FileSystem.vala"
					_tmp47_ = g_strdup_printf (" %sB", _tmp45_);
#line 545 "Utility/TeeJee.FileSystem.vala"
					_tmp48_ = _tmp47_;
#line 545 "Utility/TeeJee.FileSystem.vala"
					_tmp49_ = g_strconcat (_tmp46_, _tmp48_, NULL);
#line 545 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 545 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp49_;
#line 545 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp48_);
#line 3367 "TeeJee.FileSystem.c"
				}
			} else {
				gboolean _tmp50_ = FALSE;
#line 548 "Utility/TeeJee.FileSystem.vala"
				if (size > unit_k) {
#line 3373 "TeeJee.FileSystem.c"
					gboolean _tmp51_ = FALSE;
					gint _tmp52_;
					gint _tmp53_;
#line 548 "Utility/TeeJee.FileSystem.vala"
					_tmp52_ = strlen (unit);
#line 548 "Utility/TeeJee.FileSystem.vala"
					_tmp53_ = _tmp52_;
#line 548 "Utility/TeeJee.FileSystem.vala"
					if (_tmp53_ == 0) {
#line 548 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = TRUE;
#line 3385 "TeeJee.FileSystem.c"
					} else {
#line 548 "Utility/TeeJee.FileSystem.vala"
						_tmp51_ = g_strcmp0 (unit, "k") == 0;
#line 3389 "TeeJee.FileSystem.c"
					}
#line 548 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = _tmp51_;
#line 3393 "TeeJee.FileSystem.c"
				} else {
#line 548 "Utility/TeeJee.FileSystem.vala"
					_tmp50_ = FALSE;
#line 3397 "TeeJee.FileSystem.c"
				}
#line 548 "Utility/TeeJee.FileSystem.vala"
				if (_tmp50_) {
#line 3401 "TeeJee.FileSystem.c"
					const gchar* _tmp54_;
					gchar* _tmp55_;
					gchar* _tmp56_;
					gchar* _tmp57_;
					gchar* _tmp58_;
					gchar* _tmp59_;
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp54_ = txt;
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp55_ = g_strdup_printf ("%%'0.%df", decimals);
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp56_ = _tmp55_;
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp57_ = g_strdup_printf (_tmp56_, size / (1.0 * unit_k));
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp58_ = _tmp57_;
#line 549 "Utility/TeeJee.FileSystem.vala"
					_tmp59_ = g_strconcat (_tmp54_, _tmp58_, NULL);
#line 549 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 549 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp59_;
#line 549 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp58_);
#line 549 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp56_);
#line 550 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 3430 "TeeJee.FileSystem.c"
						const gchar* _tmp60_ = NULL;
						const gchar* _tmp61_;
						gchar* _tmp62_;
						gchar* _tmp63_;
						gchar* _tmp64_;
#line 551 "Utility/TeeJee.FileSystem.vala"
						if (binary_units) {
#line 551 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "Ki";
#line 3440 "TeeJee.FileSystem.c"
						} else {
#line 551 "Utility/TeeJee.FileSystem.vala"
							_tmp60_ = "K";
#line 3444 "TeeJee.FileSystem.c"
						}
#line 551 "Utility/TeeJee.FileSystem.vala"
						_tmp61_ = txt;
#line 551 "Utility/TeeJee.FileSystem.vala"
						_tmp62_ = g_strdup_printf (" %sB", _tmp60_);
#line 551 "Utility/TeeJee.FileSystem.vala"
						_tmp63_ = _tmp62_;
#line 551 "Utility/TeeJee.FileSystem.vala"
						_tmp64_ = g_strconcat (_tmp61_, _tmp63_, NULL);
#line 551 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 551 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp64_;
#line 551 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (_tmp63_);
#line 3460 "TeeJee.FileSystem.c"
					}
				} else {
					const gchar* _tmp65_;
					gchar* _tmp66_;
					gchar* _tmp67_;
					gchar* _tmp68_;
#line 555 "Utility/TeeJee.FileSystem.vala"
					_tmp65_ = txt;
#line 555 "Utility/TeeJee.FileSystem.vala"
					_tmp66_ = g_strdup_printf ("%'0lld", size);
#line 555 "Utility/TeeJee.FileSystem.vala"
					_tmp67_ = _tmp66_;
#line 555 "Utility/TeeJee.FileSystem.vala"
					_tmp68_ = g_strconcat (_tmp65_, _tmp67_, NULL);
#line 555 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (txt);
#line 555 "Utility/TeeJee.FileSystem.vala"
					txt = _tmp68_;
#line 555 "Utility/TeeJee.FileSystem.vala"
					_g_free0 (_tmp67_);
#line 556 "Utility/TeeJee.FileSystem.vala"
					if (show_units) {
#line 3483 "TeeJee.FileSystem.c"
						const gchar* _tmp69_;
						gchar* _tmp70_;
#line 557 "Utility/TeeJee.FileSystem.vala"
						_tmp69_ = txt;
#line 557 "Utility/TeeJee.FileSystem.vala"
						_tmp70_ = g_strconcat (_tmp69_, " B", NULL);
#line 557 "Utility/TeeJee.FileSystem.vala"
						_g_free0 (txt);
#line 557 "Utility/TeeJee.FileSystem.vala"
						txt = _tmp70_;
#line 3494 "TeeJee.FileSystem.c"
					}
				}
			}
		}
	}
#line 563 "Utility/TeeJee.FileSystem.vala"
	result = txt;
#line 563 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3504 "TeeJee.FileSystem.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 3526 "TeeJee.FileSystem.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 3530 "TeeJee.FileSystem.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 3536 "TeeJee.FileSystem.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 3540 "TeeJee.FileSystem.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 3544 "TeeJee.FileSystem.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 3552 "TeeJee.FileSystem.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1539 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3584 "TeeJee.FileSystem.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 3593 "TeeJee.FileSystem.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 3609 "TeeJee.FileSystem.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 3618 "TeeJee.FileSystem.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 3632 "TeeJee.FileSystem.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 3641 "TeeJee.FileSystem.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 3650 "TeeJee.FileSystem.c"
}

gchar*
tee_jee_file_system_escape_single_quote (const gchar* file_path)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 566 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file_path != NULL, NULL);
#line 568 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = string_replace (file_path, "'", "'\\''");
#line 568 "Utility/TeeJee.FileSystem.vala"
	result = _tmp0_;
#line 568 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3666 "TeeJee.FileSystem.c"
}

gint
tee_jee_file_system_chmod (const gchar* file,
                           const gchar* permission)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint result = 0;
#line 572 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (file != NULL, 0);
#line 572 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (permission != NULL, 0);
#line 574 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = tee_jee_file_system_escape_single_quote (file);
#line 574 "Utility/TeeJee.FileSystem.vala"
	_tmp1_ = _tmp0_;
#line 574 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = g_strdup_printf ("chmod %s '%s'", permission, _tmp1_);
#line 574 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = _tmp2_;
#line 574 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp1_);
#line 574 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 575 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_process_helper_exec_sync (cmd, NULL, NULL);
#line 575 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 575 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3701 "TeeJee.FileSystem.c"
}

gint
tee_jee_file_system_rsync (const gchar* sourceDirectory,
                           const gchar* destDirectory,
                           gboolean updateExisting,
                           gboolean deleteExtra)
{
	gchar* cmd = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_ = NULL;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_ = NULL;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	const gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	gint result = 0;
#line 578 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (sourceDirectory != NULL, 0);
#line 578 "Utility/TeeJee.FileSystem.vala"
	g_return_val_if_fail (destDirectory != NULL, 0);
#line 582 "Utility/TeeJee.FileSystem.vala"
	_tmp0_ = g_strdup ("rsync -avh");
#line 582 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp0_;
#line 583 "Utility/TeeJee.FileSystem.vala"
	if (updateExisting) {
#line 583 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = "";
#line 3746 "TeeJee.FileSystem.c"
	} else {
#line 583 "Utility/TeeJee.FileSystem.vala"
		_tmp1_ = " --ignore-existing";
#line 3750 "TeeJee.FileSystem.c"
	}
#line 583 "Utility/TeeJee.FileSystem.vala"
	_tmp2_ = cmd;
#line 583 "Utility/TeeJee.FileSystem.vala"
	_tmp3_ = g_strconcat (_tmp2_, _tmp1_, NULL);
#line 583 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 583 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp3_;
#line 584 "Utility/TeeJee.FileSystem.vala"
	if (deleteExtra) {
#line 584 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = " --delete";
#line 3764 "TeeJee.FileSystem.c"
	} else {
#line 584 "Utility/TeeJee.FileSystem.vala"
		_tmp4_ = "";
#line 3768 "TeeJee.FileSystem.c"
	}
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp5_ = cmd;
#line 584 "Utility/TeeJee.FileSystem.vala"
	_tmp6_ = g_strconcat (_tmp5_, _tmp4_, NULL);
#line 584 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 584 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp6_;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp7_ = cmd;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp8_ = tee_jee_file_system_escape_single_quote (sourceDirectory);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp9_ = _tmp8_;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp10_ = g_strconcat (_tmp9_, "//", NULL);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp11_ = _tmp10_;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp12_ = g_strdup_printf (" '%s'", _tmp11_);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp13_ = _tmp12_;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_tmp14_ = g_strconcat (_tmp7_, _tmp13_, NULL);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 585 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp14_;
#line 585 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp13_);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp11_);
#line 585 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp9_);
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp15_ = cmd;
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp16_ = tee_jee_file_system_escape_single_quote (destDirectory);
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp17_ = _tmp16_;
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp18_ = g_strdup_printf (" '%s'", _tmp17_);
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp19_ = _tmp18_;
#line 586 "Utility/TeeJee.FileSystem.vala"
	_tmp20_ = g_strconcat (_tmp15_, _tmp19_, NULL);
#line 586 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 586 "Utility/TeeJee.FileSystem.vala"
	cmd = _tmp20_;
#line 586 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp19_);
#line 586 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (_tmp17_);
#line 587 "Utility/TeeJee.FileSystem.vala"
	_tmp21_ = cmd;
#line 587 "Utility/TeeJee.FileSystem.vala"
	result = tee_jee_process_helper_exec_sync (_tmp21_, NULL, NULL);
#line 587 "Utility/TeeJee.FileSystem.vala"
	_g_free0 (cmd);
#line 587 "Utility/TeeJee.FileSystem.vala"
	return result;
#line 3832 "TeeJee.FileSystem.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

