/* SystemUser.c generated by valac 0.48.19, the Vala compiler
 * generated from SystemUser.vala, do not modify */

/*
 * SystemUser.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gee.h>

#define TYPE_SYSTEM_USER (system_user_get_type ())
#define SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SYSTEM_USER, SystemUser))
#define SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SYSTEM_USER, SystemUserClass))
#define IS_SYSTEM_USER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SYSTEM_USER))
#define IS_SYSTEM_USER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SYSTEM_USER))
#define SYSTEM_USER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SYSTEM_USER, SystemUserClass))

typedef struct _SystemUser SystemUser;
typedef struct _SystemUserClass SystemUserClass;
typedef struct _SystemUserPrivate SystemUserPrivate;
enum  {
	SYSTEM_USER_0_PROPERTY,
	SYSTEM_USER_IS_INSTALLED_PROPERTY,
	SYSTEM_USER_IS_SYSTEM_PROPERTY,
	SYSTEM_USER_GROUP_NAMES_PROPERTY,
	SYSTEM_USER_NUM_PROPERTIES
};
static GParamSpec* system_user_properties[SYSTEM_USER_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _SystemUser {
	GObject parent_instance;
	SystemUserPrivate * priv;
	gchar* name;
	gchar* password;
	gint uid;
	gint gid;
	gchar* user_info;
	gchar* home_path;
	gchar* shell_path;
	gchar* full_name;
	gchar* room_num;
	gchar* phone_work;
	gchar* phone_home;
	gchar* other_info;
	gchar* shadow_line;
	gchar* pwd_hash;
	gchar* pwd_last_changed;
	gchar* pwd_age_min;
	gchar* pwd_age_max;
	gchar* pwd_warning_period;
	gchar* pwd_inactivity_period;
	gchar* pwd_expiraton_date;
	gchar* reserved_field;
	gboolean has_encrypted_home;
	gboolean has_encrypted_private_dirs;
	GeeArrayList* encrypted_dirs;
	GeeArrayList* encrypted_private_dirs;
	gboolean is_selected;
};

struct _SystemUserClass {
	GObjectClass parent_class;
};

static gpointer system_user_parent_class = NULL;
extern GeeHashMap* system_user_all_users;
GeeHashMap* system_user_all_users = NULL;

GType system_user_get_type (void) G_GNUC_CONST;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (SystemUser, g_object_unref)
SystemUser* system_user_new (const gchar* name);
SystemUser* system_user_construct (GType object_type,
                                   const gchar* name);
void system_user_query_users (gboolean no_passwords);
GeeHashMap* system_user_read_users_from_file (const gchar* passwd_file,
                                              const gchar* shadow_file,
                                              const gchar* password);
gchar* tee_jee_file_system_file_read (const gchar* file_path);
static SystemUser* system_user_parse_line_passwd (const gchar* line);
static SystemUser* system_user_parse_line_shadow (const gchar* line,
                                           GeeHashMap* list);
void system_user_check_encrypted_dirs (SystemUser* self);
void tee_jee_logging_log_error (const gchar* message,
                                gboolean highlight,
                                gboolean is_warning);
gboolean tee_jee_file_system_file_exists (const gchar* file_path);
GeeArrayList* system_user_get_all_users_sorted (void);
static gint _system_user_all_users_sorted___lambda10_ (SystemUser* a,
                                                SystemUser* b);
static gint __system_user_all_users_sorted___lambda10__gcompare_data_func (gconstpointer a,
                                                                    gconstpointer b,
                                                                    gpointer self);
gboolean system_user_get_is_installed (SystemUser* self);
gboolean system_user_get_is_system (SystemUser* self);
gchar* system_user_get_group_names (SystemUser* self);
static void system_user_finalize (GObject * obj);
static GType system_user_get_type_once (void);
static void _vala_system_user_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

SystemUser*
system_user_construct (GType object_type,
                       const gchar* name)
{
	SystemUser * self = NULL;
	gchar* _tmp0_;
#line 65 "Utility/SystemUser.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 65 "Utility/SystemUser.vala"
	self = (SystemUser*) g_object_new (object_type, NULL);
#line 66 "Utility/SystemUser.vala"
	_tmp0_ = g_strdup (name);
#line 66 "Utility/SystemUser.vala"
	_g_free0 (self->name);
#line 66 "Utility/SystemUser.vala"
	self->name = _tmp0_;
#line 65 "Utility/SystemUser.vala"
	return self;
#line 153 "SystemUser.c"
}

SystemUser*
system_user_new (const gchar* name)
{
#line 65 "Utility/SystemUser.vala"
	return system_user_construct (TYPE_SYSTEM_USER, name);
#line 161 "SystemUser.c"
}

void
system_user_query_users (gboolean no_passwords)
{
#line 71 "Utility/SystemUser.vala"
	if (no_passwords) {
#line 169 "SystemUser.c"
		GeeHashMap* _tmp0_;
#line 72 "Utility/SystemUser.vala"
		_tmp0_ = system_user_read_users_from_file ("/etc/passwd", "", "");
#line 72 "Utility/SystemUser.vala"
		_g_object_unref0 (system_user_all_users);
#line 72 "Utility/SystemUser.vala"
		system_user_all_users = _tmp0_;
#line 177 "SystemUser.c"
	} else {
		GeeHashMap* _tmp1_;
#line 75 "Utility/SystemUser.vala"
		_tmp1_ = system_user_read_users_from_file ("/etc/passwd", "/etc/shadow", "");
#line 75 "Utility/SystemUser.vala"
		_g_object_unref0 (system_user_all_users);
#line 75 "Utility/SystemUser.vala"
		system_user_all_users = _tmp1_;
#line 186 "SystemUser.c"
	}
}

GeeHashMap*
system_user_read_users_from_file (const gchar* passwd_file,
                                  const gchar* shadow_file,
                                  const gchar* password)
{
	GeeHashMap* list = NULL;
	GeeHashMap* _tmp0_;
	gchar* txt = NULL;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gint _tmp21_;
	gint _tmp22_;
	gchar* _tmp23_;
	const gchar* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	const gchar* _tmp27_;
	gchar** _tmp28_;
	gchar** _tmp29_;
	GeeHashMap* result = NULL;
#line 96 "Utility/SystemUser.vala"
	g_return_val_if_fail (passwd_file != NULL, NULL);
#line 96 "Utility/SystemUser.vala"
	g_return_val_if_fail (shadow_file != NULL, NULL);
#line 96 "Utility/SystemUser.vala"
	g_return_val_if_fail (password != NULL, NULL);
#line 100 "Utility/SystemUser.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, TYPE_SYSTEM_USER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 100 "Utility/SystemUser.vala"
	list = _tmp0_;
#line 104 "Utility/SystemUser.vala"
	_tmp1_ = tee_jee_file_system_file_read (passwd_file);
#line 104 "Utility/SystemUser.vala"
	txt = _tmp1_;
#line 106 "Utility/SystemUser.vala"
	_tmp2_ = txt;
#line 106 "Utility/SystemUser.vala"
	_tmp3_ = strlen (_tmp2_);
#line 106 "Utility/SystemUser.vala"
	_tmp4_ = _tmp3_;
#line 106 "Utility/SystemUser.vala"
	if (_tmp4_ == 0) {
#line 107 "Utility/SystemUser.vala"
		result = list;
#line 107 "Utility/SystemUser.vala"
		_g_free0 (txt);
#line 107 "Utility/SystemUser.vala"
		return result;
#line 243 "SystemUser.c"
	}
#line 110 "Utility/SystemUser.vala"
	_tmp5_ = txt;
#line 110 "Utility/SystemUser.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 249 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 110 "Utility/SystemUser.vala"
		line_collection = _tmp7_;
#line 110 "Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp6_);
#line 110 "Utility/SystemUser.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 261 "SystemUser.c"
			gchar* _tmp8_;
			gchar* line = NULL;
#line 110 "Utility/SystemUser.vala"
			_tmp8_ = g_strdup (line_collection[line_it]);
#line 110 "Utility/SystemUser.vala"
			line = _tmp8_;
#line 268 "SystemUser.c"
			{
				gboolean _tmp9_ = FALSE;
				const gchar* _tmp10_;
				SystemUser* user = NULL;
				const gchar* _tmp14_;
				SystemUser* _tmp15_;
				SystemUser* _tmp16_;
#line 111 "Utility/SystemUser.vala"
				_tmp10_ = line;
#line 111 "Utility/SystemUser.vala"
				if (_tmp10_ == NULL) {
#line 111 "Utility/SystemUser.vala"
					_tmp9_ = TRUE;
#line 282 "SystemUser.c"
				} else {
					const gchar* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
#line 111 "Utility/SystemUser.vala"
					_tmp11_ = line;
#line 111 "Utility/SystemUser.vala"
					_tmp12_ = strlen (_tmp11_);
#line 111 "Utility/SystemUser.vala"
					_tmp13_ = _tmp12_;
#line 111 "Utility/SystemUser.vala"
					_tmp9_ = _tmp13_ == 0;
#line 295 "SystemUser.c"
				}
#line 111 "Utility/SystemUser.vala"
				if (_tmp9_) {
#line 112 "Utility/SystemUser.vala"
					_g_free0 (line);
#line 112 "Utility/SystemUser.vala"
					continue;
#line 303 "SystemUser.c"
				}
#line 114 "Utility/SystemUser.vala"
				_tmp14_ = line;
#line 114 "Utility/SystemUser.vala"
				_tmp15_ = system_user_parse_line_passwd (_tmp14_);
#line 114 "Utility/SystemUser.vala"
				user = _tmp15_;
#line 115 "Utility/SystemUser.vala"
				_tmp16_ = user;
#line 115 "Utility/SystemUser.vala"
				if (_tmp16_ != NULL) {
#line 315 "SystemUser.c"
					GeeHashMap* _tmp17_;
					SystemUser* _tmp18_;
					const gchar* _tmp19_;
					SystemUser* _tmp20_;
#line 116 "Utility/SystemUser.vala"
					_tmp17_ = list;
#line 116 "Utility/SystemUser.vala"
					_tmp18_ = user;
#line 116 "Utility/SystemUser.vala"
					_tmp19_ = _tmp18_->name;
#line 116 "Utility/SystemUser.vala"
					_tmp20_ = user;
#line 116 "Utility/SystemUser.vala"
					gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, _tmp19_, _tmp20_);
#line 330 "SystemUser.c"
				}
#line 110 "Utility/SystemUser.vala"
				_g_object_unref0 (user);
#line 110 "Utility/SystemUser.vala"
				_g_free0 (line);
#line 336 "SystemUser.c"
			}
		}
#line 110 "Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 341 "SystemUser.c"
	}
#line 120 "Utility/SystemUser.vala"
	_tmp21_ = strlen (shadow_file);
#line 120 "Utility/SystemUser.vala"
	_tmp22_ = _tmp21_;
#line 120 "Utility/SystemUser.vala"
	if (_tmp22_ == 0) {
#line 121 "Utility/SystemUser.vala"
		result = list;
#line 121 "Utility/SystemUser.vala"
		_g_free0 (txt);
#line 121 "Utility/SystemUser.vala"
		return result;
#line 355 "SystemUser.c"
	}
#line 126 "Utility/SystemUser.vala"
	_tmp23_ = tee_jee_file_system_file_read (shadow_file);
#line 126 "Utility/SystemUser.vala"
	_g_free0 (txt);
#line 126 "Utility/SystemUser.vala"
	txt = _tmp23_;
#line 128 "Utility/SystemUser.vala"
	_tmp24_ = txt;
#line 128 "Utility/SystemUser.vala"
	_tmp25_ = strlen (_tmp24_);
#line 128 "Utility/SystemUser.vala"
	_tmp26_ = _tmp25_;
#line 128 "Utility/SystemUser.vala"
	if (_tmp26_ == 0) {
#line 129 "Utility/SystemUser.vala"
		result = list;
#line 129 "Utility/SystemUser.vala"
		_g_free0 (txt);
#line 129 "Utility/SystemUser.vala"
		return result;
#line 377 "SystemUser.c"
	}
#line 132 "Utility/SystemUser.vala"
	_tmp27_ = txt;
#line 132 "Utility/SystemUser.vala"
	_tmp29_ = _tmp28_ = g_strsplit (_tmp27_, "\n", 0);
#line 383 "SystemUser.c"
	{
		gchar** line_collection = NULL;
		gint line_collection_length1 = 0;
		gint _line_collection_size_ = 0;
		gint line_it = 0;
#line 132 "Utility/SystemUser.vala"
		line_collection = _tmp29_;
#line 132 "Utility/SystemUser.vala"
		line_collection_length1 = _vala_array_length (_tmp28_);
#line 132 "Utility/SystemUser.vala"
		for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 395 "SystemUser.c"
			gchar* _tmp30_;
			gchar* line = NULL;
#line 132 "Utility/SystemUser.vala"
			_tmp30_ = g_strdup (line_collection[line_it]);
#line 132 "Utility/SystemUser.vala"
			line = _tmp30_;
#line 402 "SystemUser.c"
			{
				gboolean _tmp31_ = FALSE;
				const gchar* _tmp32_;
				const gchar* _tmp36_;
				GeeHashMap* _tmp37_;
				SystemUser* _tmp38_;
				SystemUser* _tmp39_;
#line 133 "Utility/SystemUser.vala"
				_tmp32_ = line;
#line 133 "Utility/SystemUser.vala"
				if (_tmp32_ == NULL) {
#line 133 "Utility/SystemUser.vala"
					_tmp31_ = TRUE;
#line 416 "SystemUser.c"
				} else {
					const gchar* _tmp33_;
					gint _tmp34_;
					gint _tmp35_;
#line 133 "Utility/SystemUser.vala"
					_tmp33_ = line;
#line 133 "Utility/SystemUser.vala"
					_tmp34_ = strlen (_tmp33_);
#line 133 "Utility/SystemUser.vala"
					_tmp35_ = _tmp34_;
#line 133 "Utility/SystemUser.vala"
					_tmp31_ = _tmp35_ == 0;
#line 429 "SystemUser.c"
				}
#line 133 "Utility/SystemUser.vala"
				if (_tmp31_) {
#line 134 "Utility/SystemUser.vala"
					_g_free0 (line);
#line 134 "Utility/SystemUser.vala"
					continue;
#line 437 "SystemUser.c"
				}
#line 136 "Utility/SystemUser.vala"
				_tmp36_ = line;
#line 136 "Utility/SystemUser.vala"
				_tmp37_ = list;
#line 136 "Utility/SystemUser.vala"
				_tmp38_ = system_user_parse_line_shadow (_tmp36_, _tmp37_);
#line 136 "Utility/SystemUser.vala"
				_tmp39_ = _tmp38_;
#line 136 "Utility/SystemUser.vala"
				_g_object_unref0 (_tmp39_);
#line 132 "Utility/SystemUser.vala"
				_g_free0 (line);
#line 451 "SystemUser.c"
			}
		}
#line 132 "Utility/SystemUser.vala"
		line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 456 "SystemUser.c"
	}
#line 139 "Utility/SystemUser.vala"
	result = list;
#line 139 "Utility/SystemUser.vala"
	_g_free0 (txt);
#line 139 "Utility/SystemUser.vala"
	return result;
#line 464 "SystemUser.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 485 "SystemUser.c"
}

static SystemUser*
system_user_parse_line_passwd (const gchar* line)
{
	gboolean _tmp0_ = FALSE;
	SystemUser* user = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	SystemUser* result = NULL;
#line 142 "Utility/SystemUser.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 144 "Utility/SystemUser.vala"
	if (line == NULL) {
#line 144 "Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 507 "SystemUser.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 144 "Utility/SystemUser.vala"
		_tmp1_ = strlen (line);
#line 144 "Utility/SystemUser.vala"
		_tmp2_ = _tmp1_;
#line 144 "Utility/SystemUser.vala"
		_tmp0_ = _tmp2_ == 0;
#line 517 "SystemUser.c"
	}
#line 144 "Utility/SystemUser.vala"
	if (_tmp0_) {
#line 145 "Utility/SystemUser.vala"
		result = NULL;
#line 145 "Utility/SystemUser.vala"
		return result;
#line 525 "SystemUser.c"
	}
#line 148 "Utility/SystemUser.vala"
	user = NULL;
#line 151 "Utility/SystemUser.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 151 "Utility/SystemUser.vala"
	fields = _tmp4_;
#line 151 "Utility/SystemUser.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 151 "Utility/SystemUser.vala"
	_fields_size_ = fields_length1;
#line 153 "Utility/SystemUser.vala"
	_tmp5_ = fields;
#line 153 "Utility/SystemUser.vala"
	_tmp5__length1 = fields_length1;
#line 153 "Utility/SystemUser.vala"
	if (_tmp5__length1 == 7) {
#line 543 "SystemUser.c"
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
		SystemUser* _tmp10_;
		SystemUser* _tmp11_;
		gchar** _tmp12_;
		gint _tmp12__length1;
		const gchar* _tmp13_;
		gchar* _tmp14_;
		SystemUser* _tmp15_;
		gchar** _tmp16_;
		gint _tmp16__length1;
		const gchar* _tmp17_;
		gchar* _tmp18_;
		gchar* _tmp19_;
		SystemUser* _tmp20_;
		gchar** _tmp21_;
		gint _tmp21__length1;
		const gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		SystemUser* _tmp25_;
		gchar** _tmp26_;
		gint _tmp26__length1;
		const gchar* _tmp27_;
		gchar* _tmp28_;
		SystemUser* _tmp29_;
		gchar** _tmp30_;
		gint _tmp30__length1;
		const gchar* _tmp31_;
		gchar* _tmp32_;
		SystemUser* _tmp33_;
		gchar** _tmp34_;
		gint _tmp34__length1;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar** arr = NULL;
		SystemUser* _tmp37_;
		const gchar* _tmp38_;
		gchar** _tmp39_;
		gchar** _tmp40_;
		gint arr_length1;
		gint _arr_size_;
		gchar** _tmp41_;
		gint _tmp41__length1;
		gchar** _tmp46_;
		gint _tmp46__length1;
		gchar** _tmp51_;
		gint _tmp51__length1;
		gchar** _tmp56_;
		gint _tmp56__length1;
		gchar** _tmp61_;
		gint _tmp61__length1;
		SystemUser* _tmp66_;
#line 154 "Utility/SystemUser.vala"
		_tmp6_ = fields;
#line 154 "Utility/SystemUser.vala"
		_tmp6__length1 = fields_length1;
#line 154 "Utility/SystemUser.vala"
		_tmp7_ = _tmp6_[0];
#line 154 "Utility/SystemUser.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 154 "Utility/SystemUser.vala"
		_tmp9_ = _tmp8_;
#line 154 "Utility/SystemUser.vala"
		_tmp10_ = system_user_new (_tmp9_);
#line 154 "Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 154 "Utility/SystemUser.vala"
		user = _tmp10_;
#line 154 "Utility/SystemUser.vala"
		_g_free0 (_tmp9_);
#line 155 "Utility/SystemUser.vala"
		_tmp11_ = user;
#line 155 "Utility/SystemUser.vala"
		_tmp12_ = fields;
#line 155 "Utility/SystemUser.vala"
		_tmp12__length1 = fields_length1;
#line 155 "Utility/SystemUser.vala"
		_tmp13_ = _tmp12_[1];
#line 155 "Utility/SystemUser.vala"
		_tmp14_ = string_strip (_tmp13_);
#line 155 "Utility/SystemUser.vala"
		_g_free0 (_tmp11_->password);
#line 155 "Utility/SystemUser.vala"
		_tmp11_->password = _tmp14_;
#line 156 "Utility/SystemUser.vala"
		_tmp15_ = user;
#line 156 "Utility/SystemUser.vala"
		_tmp16_ = fields;
#line 156 "Utility/SystemUser.vala"
		_tmp16__length1 = fields_length1;
#line 156 "Utility/SystemUser.vala"
		_tmp17_ = _tmp16_[2];
#line 156 "Utility/SystemUser.vala"
		_tmp18_ = string_strip (_tmp17_);
#line 156 "Utility/SystemUser.vala"
		_tmp19_ = _tmp18_;
#line 156 "Utility/SystemUser.vala"
		_tmp15_->uid = atoi (_tmp19_);
#line 156 "Utility/SystemUser.vala"
		_g_free0 (_tmp19_);
#line 157 "Utility/SystemUser.vala"
		_tmp20_ = user;
#line 157 "Utility/SystemUser.vala"
		_tmp21_ = fields;
#line 157 "Utility/SystemUser.vala"
		_tmp21__length1 = fields_length1;
#line 157 "Utility/SystemUser.vala"
		_tmp22_ = _tmp21_[3];
#line 157 "Utility/SystemUser.vala"
		_tmp23_ = string_strip (_tmp22_);
#line 157 "Utility/SystemUser.vala"
		_tmp24_ = _tmp23_;
#line 157 "Utility/SystemUser.vala"
		_tmp20_->gid = atoi (_tmp24_);
#line 157 "Utility/SystemUser.vala"
		_g_free0 (_tmp24_);
#line 158 "Utility/SystemUser.vala"
		_tmp25_ = user;
#line 158 "Utility/SystemUser.vala"
		_tmp26_ = fields;
#line 158 "Utility/SystemUser.vala"
		_tmp26__length1 = fields_length1;
#line 158 "Utility/SystemUser.vala"
		_tmp27_ = _tmp26_[4];
#line 158 "Utility/SystemUser.vala"
		_tmp28_ = string_strip (_tmp27_);
#line 158 "Utility/SystemUser.vala"
		_g_free0 (_tmp25_->user_info);
#line 158 "Utility/SystemUser.vala"
		_tmp25_->user_info = _tmp28_;
#line 159 "Utility/SystemUser.vala"
		_tmp29_ = user;
#line 159 "Utility/SystemUser.vala"
		_tmp30_ = fields;
#line 159 "Utility/SystemUser.vala"
		_tmp30__length1 = fields_length1;
#line 159 "Utility/SystemUser.vala"
		_tmp31_ = _tmp30_[5];
#line 159 "Utility/SystemUser.vala"
		_tmp32_ = string_strip (_tmp31_);
#line 159 "Utility/SystemUser.vala"
		_g_free0 (_tmp29_->home_path);
#line 159 "Utility/SystemUser.vala"
		_tmp29_->home_path = _tmp32_;
#line 160 "Utility/SystemUser.vala"
		_tmp33_ = user;
#line 160 "Utility/SystemUser.vala"
		_tmp34_ = fields;
#line 160 "Utility/SystemUser.vala"
		_tmp34__length1 = fields_length1;
#line 160 "Utility/SystemUser.vala"
		_tmp35_ = _tmp34_[6];
#line 160 "Utility/SystemUser.vala"
		_tmp36_ = string_strip (_tmp35_);
#line 160 "Utility/SystemUser.vala"
		_g_free0 (_tmp33_->shell_path);
#line 160 "Utility/SystemUser.vala"
		_tmp33_->shell_path = _tmp36_;
#line 162 "Utility/SystemUser.vala"
		_tmp37_ = user;
#line 162 "Utility/SystemUser.vala"
		_tmp38_ = _tmp37_->user_info;
#line 162 "Utility/SystemUser.vala"
		_tmp40_ = _tmp39_ = g_strsplit (_tmp38_, ",", 0);
#line 162 "Utility/SystemUser.vala"
		arr = _tmp40_;
#line 162 "Utility/SystemUser.vala"
		arr_length1 = _vala_array_length (_tmp39_);
#line 162 "Utility/SystemUser.vala"
		_arr_size_ = arr_length1;
#line 163 "Utility/SystemUser.vala"
		_tmp41_ = arr;
#line 163 "Utility/SystemUser.vala"
		_tmp41__length1 = arr_length1;
#line 163 "Utility/SystemUser.vala"
		if (_tmp41__length1 >= 1) {
#line 724 "SystemUser.c"
			SystemUser* _tmp42_;
			gchar** _tmp43_;
			gint _tmp43__length1;
			const gchar* _tmp44_;
			gchar* _tmp45_;
#line 164 "Utility/SystemUser.vala"
			_tmp42_ = user;
#line 164 "Utility/SystemUser.vala"
			_tmp43_ = arr;
#line 164 "Utility/SystemUser.vala"
			_tmp43__length1 = arr_length1;
#line 164 "Utility/SystemUser.vala"
			_tmp44_ = _tmp43_[0];
#line 164 "Utility/SystemUser.vala"
			_tmp45_ = g_strdup (_tmp44_);
#line 164 "Utility/SystemUser.vala"
			_g_free0 (_tmp42_->full_name);
#line 164 "Utility/SystemUser.vala"
			_tmp42_->full_name = _tmp45_;
#line 744 "SystemUser.c"
		}
#line 166 "Utility/SystemUser.vala"
		_tmp46_ = arr;
#line 166 "Utility/SystemUser.vala"
		_tmp46__length1 = arr_length1;
#line 166 "Utility/SystemUser.vala"
		if (_tmp46__length1 >= 2) {
#line 752 "SystemUser.c"
			SystemUser* _tmp47_;
			gchar** _tmp48_;
			gint _tmp48__length1;
			const gchar* _tmp49_;
			gchar* _tmp50_;
#line 167 "Utility/SystemUser.vala"
			_tmp47_ = user;
#line 167 "Utility/SystemUser.vala"
			_tmp48_ = arr;
#line 167 "Utility/SystemUser.vala"
			_tmp48__length1 = arr_length1;
#line 167 "Utility/SystemUser.vala"
			_tmp49_ = _tmp48_[1];
#line 167 "Utility/SystemUser.vala"
			_tmp50_ = g_strdup (_tmp49_);
#line 167 "Utility/SystemUser.vala"
			_g_free0 (_tmp47_->room_num);
#line 167 "Utility/SystemUser.vala"
			_tmp47_->room_num = _tmp50_;
#line 772 "SystemUser.c"
		}
#line 169 "Utility/SystemUser.vala"
		_tmp51_ = arr;
#line 169 "Utility/SystemUser.vala"
		_tmp51__length1 = arr_length1;
#line 169 "Utility/SystemUser.vala"
		if (_tmp51__length1 >= 3) {
#line 780 "SystemUser.c"
			SystemUser* _tmp52_;
			gchar** _tmp53_;
			gint _tmp53__length1;
			const gchar* _tmp54_;
			gchar* _tmp55_;
#line 170 "Utility/SystemUser.vala"
			_tmp52_ = user;
#line 170 "Utility/SystemUser.vala"
			_tmp53_ = arr;
#line 170 "Utility/SystemUser.vala"
			_tmp53__length1 = arr_length1;
#line 170 "Utility/SystemUser.vala"
			_tmp54_ = _tmp53_[2];
#line 170 "Utility/SystemUser.vala"
			_tmp55_ = g_strdup (_tmp54_);
#line 170 "Utility/SystemUser.vala"
			_g_free0 (_tmp52_->phone_work);
#line 170 "Utility/SystemUser.vala"
			_tmp52_->phone_work = _tmp55_;
#line 800 "SystemUser.c"
		}
#line 172 "Utility/SystemUser.vala"
		_tmp56_ = arr;
#line 172 "Utility/SystemUser.vala"
		_tmp56__length1 = arr_length1;
#line 172 "Utility/SystemUser.vala"
		if (_tmp56__length1 >= 4) {
#line 808 "SystemUser.c"
			SystemUser* _tmp57_;
			gchar** _tmp58_;
			gint _tmp58__length1;
			const gchar* _tmp59_;
			gchar* _tmp60_;
#line 173 "Utility/SystemUser.vala"
			_tmp57_ = user;
#line 173 "Utility/SystemUser.vala"
			_tmp58_ = arr;
#line 173 "Utility/SystemUser.vala"
			_tmp58__length1 = arr_length1;
#line 173 "Utility/SystemUser.vala"
			_tmp59_ = _tmp58_[3];
#line 173 "Utility/SystemUser.vala"
			_tmp60_ = g_strdup (_tmp59_);
#line 173 "Utility/SystemUser.vala"
			_g_free0 (_tmp57_->phone_home);
#line 173 "Utility/SystemUser.vala"
			_tmp57_->phone_home = _tmp60_;
#line 828 "SystemUser.c"
		}
#line 175 "Utility/SystemUser.vala"
		_tmp61_ = arr;
#line 175 "Utility/SystemUser.vala"
		_tmp61__length1 = arr_length1;
#line 175 "Utility/SystemUser.vala"
		if (_tmp61__length1 >= 5) {
#line 836 "SystemUser.c"
			SystemUser* _tmp62_;
			gchar** _tmp63_;
			gint _tmp63__length1;
			const gchar* _tmp64_;
			gchar* _tmp65_;
#line 176 "Utility/SystemUser.vala"
			_tmp62_ = user;
#line 176 "Utility/SystemUser.vala"
			_tmp63_ = arr;
#line 176 "Utility/SystemUser.vala"
			_tmp63__length1 = arr_length1;
#line 176 "Utility/SystemUser.vala"
			_tmp64_ = _tmp63_[4];
#line 176 "Utility/SystemUser.vala"
			_tmp65_ = g_strdup (_tmp64_);
#line 176 "Utility/SystemUser.vala"
			_g_free0 (_tmp62_->other_info);
#line 176 "Utility/SystemUser.vala"
			_tmp62_->other_info = _tmp65_;
#line 856 "SystemUser.c"
		}
#line 179 "Utility/SystemUser.vala"
		_tmp66_ = user;
#line 179 "Utility/SystemUser.vala"
		system_user_check_encrypted_dirs (_tmp66_);
#line 153 "Utility/SystemUser.vala"
		arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 864 "SystemUser.c"
	} else {
		gchar** _tmp67_;
		gint _tmp67__length1;
		gchar* _tmp68_;
		gchar* _tmp69_;
		gchar* _tmp70_;
		gchar* _tmp71_;
#line 182 "Utility/SystemUser.vala"
		_tmp67_ = fields;
#line 182 "Utility/SystemUser.vala"
		_tmp67__length1 = fields_length1;
#line 182 "Utility/SystemUser.vala"
		_tmp68_ = g_strdup_printf (": %d", _tmp67__length1);
#line 182 "Utility/SystemUser.vala"
		_tmp69_ = _tmp68_;
#line 182 "Utility/SystemUser.vala"
		_tmp70_ = g_strconcat ("'passwd' file contains a record with non-standard fields", _tmp69_, NULL);
#line 182 "Utility/SystemUser.vala"
		_tmp71_ = _tmp70_;
#line 182 "Utility/SystemUser.vala"
		tee_jee_logging_log_error (_tmp71_, FALSE, FALSE);
#line 182 "Utility/SystemUser.vala"
		_g_free0 (_tmp71_);
#line 182 "Utility/SystemUser.vala"
		_g_free0 (_tmp69_);
#line 183 "Utility/SystemUser.vala"
		result = NULL;
#line 183 "Utility/SystemUser.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 183 "Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 183 "Utility/SystemUser.vala"
		return result;
#line 898 "SystemUser.c"
	}
#line 186 "Utility/SystemUser.vala"
	result = user;
#line 186 "Utility/SystemUser.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 186 "Utility/SystemUser.vala"
	return result;
#line 906 "SystemUser.c"
}

static SystemUser*
system_user_parse_line_shadow (const gchar* line,
                               GeeHashMap* list)
{
	gboolean _tmp0_ = FALSE;
	SystemUser* user = NULL;
	gchar** fields = NULL;
	gchar** _tmp3_;
	gchar** _tmp4_;
	gint fields_length1;
	gint _fields_size_;
	gchar** _tmp5_;
	gint _tmp5__length1;
	SystemUser* result = NULL;
#line 189 "Utility/SystemUser.vala"
	g_return_val_if_fail (line != NULL, NULL);
#line 189 "Utility/SystemUser.vala"
	g_return_val_if_fail (list != NULL, NULL);
#line 191 "Utility/SystemUser.vala"
	if (line == NULL) {
#line 191 "Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 931 "SystemUser.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 191 "Utility/SystemUser.vala"
		_tmp1_ = strlen (line);
#line 191 "Utility/SystemUser.vala"
		_tmp2_ = _tmp1_;
#line 191 "Utility/SystemUser.vala"
		_tmp0_ = _tmp2_ == 0;
#line 941 "SystemUser.c"
	}
#line 191 "Utility/SystemUser.vala"
	if (_tmp0_) {
#line 192 "Utility/SystemUser.vala"
		result = NULL;
#line 192 "Utility/SystemUser.vala"
		return result;
#line 949 "SystemUser.c"
	}
#line 195 "Utility/SystemUser.vala"
	user = NULL;
#line 200 "Utility/SystemUser.vala"
	_tmp4_ = _tmp3_ = g_strsplit (line, ":", 0);
#line 200 "Utility/SystemUser.vala"
	fields = _tmp4_;
#line 200 "Utility/SystemUser.vala"
	fields_length1 = _vala_array_length (_tmp3_);
#line 200 "Utility/SystemUser.vala"
	_fields_size_ = fields_length1;
#line 202 "Utility/SystemUser.vala"
	_tmp5_ = fields;
#line 202 "Utility/SystemUser.vala"
	_tmp5__length1 = fields_length1;
#line 202 "Utility/SystemUser.vala"
	if (_tmp5__length1 == 9) {
#line 967 "SystemUser.c"
		gchar* user_name = NULL;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		const gchar* _tmp9_;
#line 203 "Utility/SystemUser.vala"
		_tmp6_ = fields;
#line 203 "Utility/SystemUser.vala"
		_tmp6__length1 = fields_length1;
#line 203 "Utility/SystemUser.vala"
		_tmp7_ = _tmp6_[0];
#line 203 "Utility/SystemUser.vala"
		_tmp8_ = string_strip (_tmp7_);
#line 203 "Utility/SystemUser.vala"
		user_name = _tmp8_;
#line 204 "Utility/SystemUser.vala"
		_tmp9_ = user_name;
#line 204 "Utility/SystemUser.vala"
		if (gee_abstract_map_has_key ((GeeAbstractMap*) list, _tmp9_)) {
#line 988 "SystemUser.c"
			const gchar* _tmp10_;
			gpointer _tmp11_;
			SystemUser* _tmp12_;
			gchar* _tmp13_;
			SystemUser* _tmp14_;
			gchar** _tmp15_;
			gint _tmp15__length1;
			const gchar* _tmp16_;
			gchar* _tmp17_;
			SystemUser* _tmp18_;
			gchar** _tmp19_;
			gint _tmp19__length1;
			const gchar* _tmp20_;
			gchar* _tmp21_;
			SystemUser* _tmp22_;
			gchar** _tmp23_;
			gint _tmp23__length1;
			const gchar* _tmp24_;
			gchar* _tmp25_;
			SystemUser* _tmp26_;
			gchar** _tmp27_;
			gint _tmp27__length1;
			const gchar* _tmp28_;
			gchar* _tmp29_;
			SystemUser* _tmp30_;
			gchar** _tmp31_;
			gint _tmp31__length1;
			const gchar* _tmp32_;
			gchar* _tmp33_;
			SystemUser* _tmp34_;
			gchar** _tmp35_;
			gint _tmp35__length1;
			const gchar* _tmp36_;
			gchar* _tmp37_;
			SystemUser* _tmp38_;
			gchar** _tmp39_;
			gint _tmp39__length1;
			const gchar* _tmp40_;
			gchar* _tmp41_;
			SystemUser* _tmp42_;
			gchar** _tmp43_;
			gint _tmp43__length1;
			const gchar* _tmp44_;
			gchar* _tmp45_;
#line 205 "Utility/SystemUser.vala"
			_tmp10_ = user_name;
#line 205 "Utility/SystemUser.vala"
			_tmp11_ = gee_abstract_map_get ((GeeAbstractMap*) list, _tmp10_);
#line 205 "Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 205 "Utility/SystemUser.vala"
			user = (SystemUser*) _tmp11_;
#line 206 "Utility/SystemUser.vala"
			_tmp12_ = user;
#line 206 "Utility/SystemUser.vala"
			_tmp13_ = g_strdup (line);
#line 206 "Utility/SystemUser.vala"
			_g_free0 (_tmp12_->shadow_line);
#line 206 "Utility/SystemUser.vala"
			_tmp12_->shadow_line = _tmp13_;
#line 207 "Utility/SystemUser.vala"
			_tmp14_ = user;
#line 207 "Utility/SystemUser.vala"
			_tmp15_ = fields;
#line 207 "Utility/SystemUser.vala"
			_tmp15__length1 = fields_length1;
#line 207 "Utility/SystemUser.vala"
			_tmp16_ = _tmp15_[1];
#line 207 "Utility/SystemUser.vala"
			_tmp17_ = string_strip (_tmp16_);
#line 207 "Utility/SystemUser.vala"
			_g_free0 (_tmp14_->pwd_hash);
#line 207 "Utility/SystemUser.vala"
			_tmp14_->pwd_hash = _tmp17_;
#line 208 "Utility/SystemUser.vala"
			_tmp18_ = user;
#line 208 "Utility/SystemUser.vala"
			_tmp19_ = fields;
#line 208 "Utility/SystemUser.vala"
			_tmp19__length1 = fields_length1;
#line 208 "Utility/SystemUser.vala"
			_tmp20_ = _tmp19_[2];
#line 208 "Utility/SystemUser.vala"
			_tmp21_ = string_strip (_tmp20_);
#line 208 "Utility/SystemUser.vala"
			_g_free0 (_tmp18_->pwd_last_changed);
#line 208 "Utility/SystemUser.vala"
			_tmp18_->pwd_last_changed = _tmp21_;
#line 209 "Utility/SystemUser.vala"
			_tmp22_ = user;
#line 209 "Utility/SystemUser.vala"
			_tmp23_ = fields;
#line 209 "Utility/SystemUser.vala"
			_tmp23__length1 = fields_length1;
#line 209 "Utility/SystemUser.vala"
			_tmp24_ = _tmp23_[3];
#line 209 "Utility/SystemUser.vala"
			_tmp25_ = string_strip (_tmp24_);
#line 209 "Utility/SystemUser.vala"
			_g_free0 (_tmp22_->pwd_age_min);
#line 209 "Utility/SystemUser.vala"
			_tmp22_->pwd_age_min = _tmp25_;
#line 210 "Utility/SystemUser.vala"
			_tmp26_ = user;
#line 210 "Utility/SystemUser.vala"
			_tmp27_ = fields;
#line 210 "Utility/SystemUser.vala"
			_tmp27__length1 = fields_length1;
#line 210 "Utility/SystemUser.vala"
			_tmp28_ = _tmp27_[4];
#line 210 "Utility/SystemUser.vala"
			_tmp29_ = string_strip (_tmp28_);
#line 210 "Utility/SystemUser.vala"
			_g_free0 (_tmp26_->pwd_age_max);
#line 210 "Utility/SystemUser.vala"
			_tmp26_->pwd_age_max = _tmp29_;
#line 211 "Utility/SystemUser.vala"
			_tmp30_ = user;
#line 211 "Utility/SystemUser.vala"
			_tmp31_ = fields;
#line 211 "Utility/SystemUser.vala"
			_tmp31__length1 = fields_length1;
#line 211 "Utility/SystemUser.vala"
			_tmp32_ = _tmp31_[5];
#line 211 "Utility/SystemUser.vala"
			_tmp33_ = string_strip (_tmp32_);
#line 211 "Utility/SystemUser.vala"
			_g_free0 (_tmp30_->pwd_warning_period);
#line 211 "Utility/SystemUser.vala"
			_tmp30_->pwd_warning_period = _tmp33_;
#line 212 "Utility/SystemUser.vala"
			_tmp34_ = user;
#line 212 "Utility/SystemUser.vala"
			_tmp35_ = fields;
#line 212 "Utility/SystemUser.vala"
			_tmp35__length1 = fields_length1;
#line 212 "Utility/SystemUser.vala"
			_tmp36_ = _tmp35_[6];
#line 212 "Utility/SystemUser.vala"
			_tmp37_ = string_strip (_tmp36_);
#line 212 "Utility/SystemUser.vala"
			_g_free0 (_tmp34_->pwd_inactivity_period);
#line 212 "Utility/SystemUser.vala"
			_tmp34_->pwd_inactivity_period = _tmp37_;
#line 213 "Utility/SystemUser.vala"
			_tmp38_ = user;
#line 213 "Utility/SystemUser.vala"
			_tmp39_ = fields;
#line 213 "Utility/SystemUser.vala"
			_tmp39__length1 = fields_length1;
#line 213 "Utility/SystemUser.vala"
			_tmp40_ = _tmp39_[7];
#line 213 "Utility/SystemUser.vala"
			_tmp41_ = string_strip (_tmp40_);
#line 213 "Utility/SystemUser.vala"
			_g_free0 (_tmp38_->pwd_expiraton_date);
#line 213 "Utility/SystemUser.vala"
			_tmp38_->pwd_expiraton_date = _tmp41_;
#line 214 "Utility/SystemUser.vala"
			_tmp42_ = user;
#line 214 "Utility/SystemUser.vala"
			_tmp43_ = fields;
#line 214 "Utility/SystemUser.vala"
			_tmp43__length1 = fields_length1;
#line 214 "Utility/SystemUser.vala"
			_tmp44_ = _tmp43_[8];
#line 214 "Utility/SystemUser.vala"
			_tmp45_ = string_strip (_tmp44_);
#line 214 "Utility/SystemUser.vala"
			_g_free0 (_tmp42_->reserved_field);
#line 214 "Utility/SystemUser.vala"
			_tmp42_->reserved_field = _tmp45_;
#line 215 "Utility/SystemUser.vala"
			result = user;
#line 215 "Utility/SystemUser.vala"
			_g_free0 (user_name);
#line 215 "Utility/SystemUser.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 215 "Utility/SystemUser.vala"
			return result;
#line 1169 "SystemUser.c"
		} else {
			const gchar* _tmp46_;
			gchar* _tmp47_;
			gchar* _tmp48_;
			gchar* _tmp49_;
			gchar* _tmp50_;
#line 218 "Utility/SystemUser.vala"
			_tmp46_ = user_name;
#line 218 "Utility/SystemUser.vala"
			_tmp47_ = g_strdup_printf (": %s", _tmp46_);
#line 218 "Utility/SystemUser.vala"
			_tmp48_ = _tmp47_;
#line 218 "Utility/SystemUser.vala"
			_tmp49_ = g_strconcat ("user in file 'shadow' does not exist in file 'passwd'", _tmp48_, NULL);
#line 218 "Utility/SystemUser.vala"
			_tmp50_ = _tmp49_;
#line 218 "Utility/SystemUser.vala"
			tee_jee_logging_log_error (_tmp50_, FALSE, FALSE);
#line 218 "Utility/SystemUser.vala"
			_g_free0 (_tmp50_);
#line 218 "Utility/SystemUser.vala"
			_g_free0 (_tmp48_);
#line 219 "Utility/SystemUser.vala"
			result = NULL;
#line 219 "Utility/SystemUser.vala"
			_g_free0 (user_name);
#line 219 "Utility/SystemUser.vala"
			fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 219 "Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 219 "Utility/SystemUser.vala"
			return result;
#line 1202 "SystemUser.c"
		}
#line 202 "Utility/SystemUser.vala"
		_g_free0 (user_name);
#line 1206 "SystemUser.c"
	} else {
		gchar** _tmp51_;
		gint _tmp51__length1;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
#line 223 "Utility/SystemUser.vala"
		_tmp51_ = fields;
#line 223 "Utility/SystemUser.vala"
		_tmp51__length1 = fields_length1;
#line 223 "Utility/SystemUser.vala"
		_tmp52_ = g_strdup_printf (": %d", _tmp51__length1);
#line 223 "Utility/SystemUser.vala"
		_tmp53_ = _tmp52_;
#line 223 "Utility/SystemUser.vala"
		_tmp54_ = g_strconcat ("'shadow' file contains a record with non-standard fields", _tmp53_, NULL);
#line 223 "Utility/SystemUser.vala"
		_tmp55_ = _tmp54_;
#line 223 "Utility/SystemUser.vala"
		tee_jee_logging_log_error (_tmp55_, FALSE, FALSE);
#line 223 "Utility/SystemUser.vala"
		_g_free0 (_tmp55_);
#line 223 "Utility/SystemUser.vala"
		_g_free0 (_tmp53_);
#line 224 "Utility/SystemUser.vala"
		result = NULL;
#line 224 "Utility/SystemUser.vala"
		fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 224 "Utility/SystemUser.vala"
		_g_object_unref0 (user);
#line 224 "Utility/SystemUser.vala"
		return result;
#line 1240 "SystemUser.c"
	}
#line 189 "Utility/SystemUser.vala"
	fields = (_vala_array_free (fields, fields_length1, (GDestroyNotify) g_free), NULL);
#line 189 "Utility/SystemUser.vala"
	_g_object_unref0 (user);
#line 1246 "SystemUser.c"
}

void
system_user_check_encrypted_dirs (SystemUser* self)
{
	gchar* ecryptfs_mount_file = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	const gchar* _tmp20_;
#line 228 "Utility/SystemUser.vala"
	g_return_if_fail (self != NULL);
#line 232 "Utility/SystemUser.vala"
	_tmp0_ = self->name;
#line 232 "Utility/SystemUser.vala"
	_tmp1_ = g_strdup_printf ("/home/.ecryptfs/%s/.ecryptfs/Private.mnt", _tmp0_);
#line 232 "Utility/SystemUser.vala"
	ecryptfs_mount_file = _tmp1_;
#line 234 "Utility/SystemUser.vala"
	_tmp2_ = ecryptfs_mount_file;
#line 234 "Utility/SystemUser.vala"
	if (tee_jee_file_system_file_exists (_tmp2_)) {
#line 1271 "SystemUser.c"
		gchar* txt = NULL;
		const gchar* _tmp3_;
		gchar* _tmp4_;
		const gchar* _tmp5_;
		gchar** _tmp6_;
		gchar** _tmp7_;
#line 236 "Utility/SystemUser.vala"
		_tmp3_ = ecryptfs_mount_file;
#line 236 "Utility/SystemUser.vala"
		_tmp4_ = tee_jee_file_system_file_read (_tmp3_);
#line 236 "Utility/SystemUser.vala"
		txt = _tmp4_;
#line 238 "Utility/SystemUser.vala"
		_tmp5_ = txt;
#line 238 "Utility/SystemUser.vala"
		_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "\n", 0);
#line 1288 "SystemUser.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 238 "Utility/SystemUser.vala"
			line_collection = _tmp7_;
#line 238 "Utility/SystemUser.vala"
			line_collection_length1 = _vala_array_length (_tmp6_);
#line 238 "Utility/SystemUser.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1300 "SystemUser.c"
				gchar* _tmp8_;
				gchar* line = NULL;
#line 238 "Utility/SystemUser.vala"
				_tmp8_ = g_strdup (line_collection[line_it]);
#line 238 "Utility/SystemUser.vala"
				line = _tmp8_;
#line 1307 "SystemUser.c"
				{
					gchar* path = NULL;
					const gchar* _tmp9_;
					gchar* _tmp10_;
					const gchar* _tmp11_;
					gint _tmp12_;
					gint _tmp13_;
					const gchar* _tmp14_;
					const gchar* _tmp15_;
					GeeArrayList* _tmp16_;
					const gchar* _tmp17_;
#line 240 "Utility/SystemUser.vala"
					_tmp9_ = line;
#line 240 "Utility/SystemUser.vala"
					_tmp10_ = string_strip (_tmp9_);
#line 240 "Utility/SystemUser.vala"
					path = _tmp10_;
#line 242 "Utility/SystemUser.vala"
					_tmp11_ = path;
#line 242 "Utility/SystemUser.vala"
					_tmp12_ = strlen (_tmp11_);
#line 242 "Utility/SystemUser.vala"
					_tmp13_ = _tmp12_;
#line 242 "Utility/SystemUser.vala"
					if (_tmp13_ == 0) {
#line 242 "Utility/SystemUser.vala"
						_g_free0 (path);
#line 242 "Utility/SystemUser.vala"
						_g_free0 (line);
#line 242 "Utility/SystemUser.vala"
						continue;
#line 1339 "SystemUser.c"
					}
#line 244 "Utility/SystemUser.vala"
					_tmp14_ = path;
#line 244 "Utility/SystemUser.vala"
					_tmp15_ = self->home_path;
#line 244 "Utility/SystemUser.vala"
					if (g_strcmp0 (_tmp14_, _tmp15_) == 0) {
#line 245 "Utility/SystemUser.vala"
						self->has_encrypted_home = TRUE;
#line 1349 "SystemUser.c"
					}
#line 248 "Utility/SystemUser.vala"
					_tmp16_ = self->encrypted_dirs;
#line 248 "Utility/SystemUser.vala"
					_tmp17_ = path;
#line 248 "Utility/SystemUser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp16_, _tmp17_);
#line 238 "Utility/SystemUser.vala"
					_g_free0 (path);
#line 238 "Utility/SystemUser.vala"
					_g_free0 (line);
#line 1361 "SystemUser.c"
				}
			}
#line 238 "Utility/SystemUser.vala"
			line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1366 "SystemUser.c"
		}
#line 234 "Utility/SystemUser.vala"
		_g_free0 (txt);
#line 1370 "SystemUser.c"
	}
#line 254 "Utility/SystemUser.vala"
	_tmp18_ = self->home_path;
#line 254 "Utility/SystemUser.vala"
	_tmp19_ = g_strdup_printf ("%s/.ecryptfs/Private.mnt", _tmp18_);
#line 254 "Utility/SystemUser.vala"
	_g_free0 (ecryptfs_mount_file);
#line 254 "Utility/SystemUser.vala"
	ecryptfs_mount_file = _tmp19_;
#line 256 "Utility/SystemUser.vala"
	_tmp20_ = ecryptfs_mount_file;
#line 256 "Utility/SystemUser.vala"
	if (tee_jee_file_system_file_exists (_tmp20_)) {
#line 1384 "SystemUser.c"
		gchar* txt = NULL;
		const gchar* _tmp21_;
		gchar* _tmp22_;
		const gchar* _tmp23_;
		gchar** _tmp24_;
		gchar** _tmp25_;
#line 258 "Utility/SystemUser.vala"
		_tmp21_ = ecryptfs_mount_file;
#line 258 "Utility/SystemUser.vala"
		_tmp22_ = tee_jee_file_system_file_read (_tmp21_);
#line 258 "Utility/SystemUser.vala"
		txt = _tmp22_;
#line 260 "Utility/SystemUser.vala"
		_tmp23_ = txt;
#line 260 "Utility/SystemUser.vala"
		_tmp25_ = _tmp24_ = g_strsplit (_tmp23_, "\n", 0);
#line 1401 "SystemUser.c"
		{
			gchar** line_collection = NULL;
			gint line_collection_length1 = 0;
			gint _line_collection_size_ = 0;
			gint line_it = 0;
#line 260 "Utility/SystemUser.vala"
			line_collection = _tmp25_;
#line 260 "Utility/SystemUser.vala"
			line_collection_length1 = _vala_array_length (_tmp24_);
#line 260 "Utility/SystemUser.vala"
			for (line_it = 0; line_it < line_collection_length1; line_it = line_it + 1) {
#line 1413 "SystemUser.c"
				gchar* _tmp26_;
				gchar* line = NULL;
#line 260 "Utility/SystemUser.vala"
				_tmp26_ = g_strdup (line_collection[line_it]);
#line 260 "Utility/SystemUser.vala"
				line = _tmp26_;
#line 1420 "SystemUser.c"
				{
					gchar* path = NULL;
					const gchar* _tmp27_;
					gchar* _tmp28_;
					const gchar* _tmp29_;
					gint _tmp30_;
					gint _tmp31_;
					const gchar* _tmp32_;
					const gchar* _tmp33_;
					GeeArrayList* _tmp36_;
					const gchar* _tmp37_;
#line 262 "Utility/SystemUser.vala"
					_tmp27_ = line;
#line 262 "Utility/SystemUser.vala"
					_tmp28_ = string_strip (_tmp27_);
#line 262 "Utility/SystemUser.vala"
					path = _tmp28_;
#line 264 "Utility/SystemUser.vala"
					_tmp29_ = path;
#line 264 "Utility/SystemUser.vala"
					_tmp30_ = strlen (_tmp29_);
#line 264 "Utility/SystemUser.vala"
					_tmp31_ = _tmp30_;
#line 264 "Utility/SystemUser.vala"
					if (_tmp31_ == 0) {
#line 264 "Utility/SystemUser.vala"
						_g_free0 (path);
#line 264 "Utility/SystemUser.vala"
						_g_free0 (line);
#line 264 "Utility/SystemUser.vala"
						continue;
#line 1452 "SystemUser.c"
					}
#line 266 "Utility/SystemUser.vala"
					_tmp32_ = path;
#line 266 "Utility/SystemUser.vala"
					_tmp33_ = self->home_path;
#line 266 "Utility/SystemUser.vala"
					if (g_strcmp0 (_tmp32_, _tmp33_) != 0) {
#line 1460 "SystemUser.c"
						GeeArrayList* _tmp34_;
						const gchar* _tmp35_;
#line 267 "Utility/SystemUser.vala"
						self->has_encrypted_private_dirs = TRUE;
#line 268 "Utility/SystemUser.vala"
						_tmp34_ = self->encrypted_private_dirs;
#line 268 "Utility/SystemUser.vala"
						_tmp35_ = path;
#line 268 "Utility/SystemUser.vala"
						gee_abstract_collection_add ((GeeAbstractCollection*) _tmp34_, _tmp35_);
#line 1471 "SystemUser.c"
					}
#line 271 "Utility/SystemUser.vala"
					_tmp36_ = self->encrypted_dirs;
#line 271 "Utility/SystemUser.vala"
					_tmp37_ = path;
#line 271 "Utility/SystemUser.vala"
					gee_abstract_collection_add ((GeeAbstractCollection*) _tmp36_, _tmp37_);
#line 260 "Utility/SystemUser.vala"
					_g_free0 (path);
#line 260 "Utility/SystemUser.vala"
					_g_free0 (line);
#line 1483 "SystemUser.c"
				}
			}
#line 260 "Utility/SystemUser.vala"
			line_collection = (_vala_array_free (line_collection, line_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1488 "SystemUser.c"
		}
#line 256 "Utility/SystemUser.vala"
		_g_free0 (txt);
#line 1492 "SystemUser.c"
	}
#line 228 "Utility/SystemUser.vala"
	_g_free0 (ecryptfs_mount_file);
#line 1496 "SystemUser.c"
}

static gint
_system_user_all_users_sorted___lambda10_ (SystemUser* a,
                                           SystemUser* b)
{
	GCompareFunc _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint result = 0;
#line 85 "Utility/SystemUser.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 85 "Utility/SystemUser.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 85 "Utility/SystemUser.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 85 "Utility/SystemUser.vala"
	_tmp1_ = a->name;
#line 85 "Utility/SystemUser.vala"
	_tmp2_ = b->name;
#line 85 "Utility/SystemUser.vala"
	result = _tmp0_ (_tmp1_, _tmp2_);
#line 85 "Utility/SystemUser.vala"
	return result;
#line 1521 "SystemUser.c"
}

static gint
__system_user_all_users_sorted___lambda10__gcompare_data_func (gconstpointer a,
                                                               gconstpointer b,
                                                               gpointer self)
{
	gint result;
	result = _system_user_all_users_sorted___lambda10_ ((SystemUser*) a, (SystemUser*) b);
#line 85 "Utility/SystemUser.vala"
	return result;
#line 1533 "SystemUser.c"
}

GeeArrayList*
system_user_get_all_users_sorted (void)
{
	GeeArrayList* result;
	GeeArrayList* list = NULL;
	GeeArrayList* _tmp0_;
	GeeArrayList* _tmp12_;
#line 81 "Utility/SystemUser.vala"
	_tmp0_ = gee_array_list_new (TYPE_SYSTEM_USER, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 81 "Utility/SystemUser.vala"
	list = _tmp0_;
#line 1547 "SystemUser.c"
	{
		GeeIterator* _user_it = NULL;
		GeeHashMap* _tmp1_;
		GeeCollection* _tmp2_;
		GeeCollection* _tmp3_;
		GeeCollection* _tmp4_;
		GeeIterator* _tmp5_;
		GeeIterator* _tmp6_;
#line 82 "Utility/SystemUser.vala"
		_tmp1_ = system_user_all_users;
#line 82 "Utility/SystemUser.vala"
		_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp1_);
#line 82 "Utility/SystemUser.vala"
		_tmp3_ = _tmp2_;
#line 82 "Utility/SystemUser.vala"
		_tmp4_ = _tmp3_;
#line 82 "Utility/SystemUser.vala"
		_tmp5_ = gee_iterable_iterator ((GeeIterable*) _tmp4_);
#line 82 "Utility/SystemUser.vala"
		_tmp6_ = _tmp5_;
#line 82 "Utility/SystemUser.vala"
		_g_object_unref0 (_tmp4_);
#line 82 "Utility/SystemUser.vala"
		_user_it = _tmp6_;
#line 82 "Utility/SystemUser.vala"
		while (TRUE) {
#line 1574 "SystemUser.c"
			GeeIterator* _tmp7_;
			SystemUser* user = NULL;
			GeeIterator* _tmp8_;
			gpointer _tmp9_;
			GeeArrayList* _tmp10_;
			SystemUser* _tmp11_;
#line 82 "Utility/SystemUser.vala"
			_tmp7_ = _user_it;
#line 82 "Utility/SystemUser.vala"
			if (!gee_iterator_next (_tmp7_)) {
#line 82 "Utility/SystemUser.vala"
				break;
#line 1587 "SystemUser.c"
			}
#line 82 "Utility/SystemUser.vala"
			_tmp8_ = _user_it;
#line 82 "Utility/SystemUser.vala"
			_tmp9_ = gee_iterator_get (_tmp8_);
#line 82 "Utility/SystemUser.vala"
			user = (SystemUser*) _tmp9_;
#line 83 "Utility/SystemUser.vala"
			_tmp10_ = list;
#line 83 "Utility/SystemUser.vala"
			_tmp11_ = user;
#line 83 "Utility/SystemUser.vala"
			gee_abstract_collection_add ((GeeAbstractCollection*) _tmp10_, _tmp11_);
#line 82 "Utility/SystemUser.vala"
			_g_object_unref0 (user);
#line 1603 "SystemUser.c"
		}
#line 82 "Utility/SystemUser.vala"
		_g_object_unref0 (_user_it);
#line 1607 "SystemUser.c"
	}
#line 85 "Utility/SystemUser.vala"
	_tmp12_ = list;
#line 85 "Utility/SystemUser.vala"
	gee_list_sort ((GeeList*) _tmp12_, __system_user_all_users_sorted___lambda10__gcompare_data_func, NULL, NULL);
#line 86 "Utility/SystemUser.vala"
	result = list;
#line 86 "Utility/SystemUser.vala"
	return result;
#line 1617 "SystemUser.c"
}

gboolean
system_user_get_is_installed (SystemUser* self)
{
	gboolean result;
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
#line 91 "Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 92 "Utility/SystemUser.vala"
	_tmp0_ = system_user_all_users;
#line 92 "Utility/SystemUser.vala"
	_tmp1_ = self->name;
#line 92 "Utility/SystemUser.vala"
	result = gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp1_);
#line 92 "Utility/SystemUser.vala"
	return result;
#line 1636 "SystemUser.c"
}

gboolean
system_user_get_is_system (SystemUser* self)
{
	gboolean result;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
#line 277 "Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 278 "Utility/SystemUser.vala"
	if (self->uid != 0) {
#line 278 "Utility/SystemUser.vala"
		_tmp2_ = self->uid < 1000;
#line 1652 "SystemUser.c"
	} else {
#line 278 "Utility/SystemUser.vala"
		_tmp2_ = FALSE;
#line 1656 "SystemUser.c"
	}
#line 278 "Utility/SystemUser.vala"
	if (_tmp2_) {
#line 278 "Utility/SystemUser.vala"
		_tmp1_ = TRUE;
#line 1662 "SystemUser.c"
	} else {
#line 278 "Utility/SystemUser.vala"
		_tmp1_ = self->uid == 65534;
#line 1666 "SystemUser.c"
	}
#line 278 "Utility/SystemUser.vala"
	if (_tmp1_) {
#line 278 "Utility/SystemUser.vala"
		_tmp0_ = TRUE;
#line 1672 "SystemUser.c"
	} else {
		const gchar* _tmp3_;
#line 278 "Utility/SystemUser.vala"
		_tmp3_ = self->name;
#line 278 "Utility/SystemUser.vala"
		_tmp0_ = g_strcmp0 (_tmp3_, "PinguyBuilder") == 0;
#line 1679 "SystemUser.c"
	}
#line 278 "Utility/SystemUser.vala"
	result = _tmp0_;
#line 278 "Utility/SystemUser.vala"
	return result;
#line 1685 "SystemUser.c"
}

gchar*
system_user_get_group_names (SystemUser* self)
{
	gchar* result;
	gchar* _tmp0_;
#line 283 "Utility/SystemUser.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 284 "Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 284 "Utility/SystemUser.vala"
	result = _tmp0_;
#line 284 "Utility/SystemUser.vala"
	return result;
#line 1701 "SystemUser.c"
}

static void
system_user_class_init (SystemUserClass * klass,
                        gpointer klass_data)
{
#line 29 "Utility/SystemUser.vala"
	system_user_parent_class = g_type_class_peek_parent (klass);
#line 29 "Utility/SystemUser.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_system_user_get_property;
#line 29 "Utility/SystemUser.vala"
	G_OBJECT_CLASS (klass)->finalize = system_user_finalize;
#line 29 "Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_IS_INSTALLED_PROPERTY, system_user_properties[SYSTEM_USER_IS_INSTALLED_PROPERTY] = g_param_spec_boolean ("is-installed", "is-installed", "is-installed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_IS_SYSTEM_PROPERTY, system_user_properties[SYSTEM_USER_IS_SYSTEM_PROPERTY] = g_param_spec_boolean ("is-system", "is-system", "is-system", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 29 "Utility/SystemUser.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SYSTEM_USER_GROUP_NAMES_PROPERTY, system_user_properties[SYSTEM_USER_GROUP_NAMES_PROPERTY] = g_param_spec_string ("group-names", "group-names", "group-names", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1720 "SystemUser.c"
}

static void
system_user_instance_init (SystemUser * self,
                           gpointer klass)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GeeArrayList* _tmp19_;
	GeeArrayList* _tmp20_;
#line 31 "Utility/SystemUser.vala"
	_tmp0_ = g_strdup ("");
#line 31 "Utility/SystemUser.vala"
	self->name = _tmp0_;
#line 32 "Utility/SystemUser.vala"
	_tmp1_ = g_strdup ("");
#line 32 "Utility/SystemUser.vala"
	self->password = _tmp1_;
#line 33 "Utility/SystemUser.vala"
	self->uid = -1;
#line 34 "Utility/SystemUser.vala"
	self->gid = -1;
#line 35 "Utility/SystemUser.vala"
	_tmp2_ = g_strdup ("");
#line 35 "Utility/SystemUser.vala"
	self->user_info = _tmp2_;
#line 36 "Utility/SystemUser.vala"
	_tmp3_ = g_strdup ("");
#line 36 "Utility/SystemUser.vala"
	self->home_path = _tmp3_;
#line 37 "Utility/SystemUser.vala"
	_tmp4_ = g_strdup ("");
#line 37 "Utility/SystemUser.vala"
	self->shell_path = _tmp4_;
#line 39 "Utility/SystemUser.vala"
	_tmp5_ = g_strdup ("");
#line 39 "Utility/SystemUser.vala"
	self->full_name = _tmp5_;
#line 40 "Utility/SystemUser.vala"
	_tmp6_ = g_strdup ("");
#line 40 "Utility/SystemUser.vala"
	self->room_num = _tmp6_;
#line 41 "Utility/SystemUser.vala"
	_tmp7_ = g_strdup ("");
#line 41 "Utility/SystemUser.vala"
	self->phone_work = _tmp7_;
#line 42 "Utility/SystemUser.vala"
	_tmp8_ = g_strdup ("");
#line 42 "Utility/SystemUser.vala"
	self->phone_home = _tmp8_;
#line 43 "Utility/SystemUser.vala"
	_tmp9_ = g_strdup ("");
#line 43 "Utility/SystemUser.vala"
	self->other_info = _tmp9_;
#line 46 "Utility/SystemUser.vala"
	_tmp10_ = g_strdup ("");
#line 46 "Utility/SystemUser.vala"
	self->shadow_line = _tmp10_;
#line 47 "Utility/SystemUser.vala"
	_tmp11_ = g_strdup ("");
#line 47 "Utility/SystemUser.vala"
	self->pwd_hash = _tmp11_;
#line 48 "Utility/SystemUser.vala"
	_tmp12_ = g_strdup ("");
#line 48 "Utility/SystemUser.vala"
	self->pwd_last_changed = _tmp12_;
#line 49 "Utility/SystemUser.vala"
	_tmp13_ = g_strdup ("");
#line 49 "Utility/SystemUser.vala"
	self->pwd_age_min = _tmp13_;
#line 50 "Utility/SystemUser.vala"
	_tmp14_ = g_strdup ("");
#line 50 "Utility/SystemUser.vala"
	self->pwd_age_max = _tmp14_;
#line 51 "Utility/SystemUser.vala"
	_tmp15_ = g_strdup ("");
#line 51 "Utility/SystemUser.vala"
	self->pwd_warning_period = _tmp15_;
#line 52 "Utility/SystemUser.vala"
	_tmp16_ = g_strdup ("");
#line 52 "Utility/SystemUser.vala"
	self->pwd_inactivity_period = _tmp16_;
#line 53 "Utility/SystemUser.vala"
	_tmp17_ = g_strdup ("");
#line 53 "Utility/SystemUser.vala"
	self->pwd_expiraton_date = _tmp17_;
#line 54 "Utility/SystemUser.vala"
	_tmp18_ = g_strdup ("");
#line 54 "Utility/SystemUser.vala"
	self->reserved_field = _tmp18_;
#line 56 "Utility/SystemUser.vala"
	self->has_encrypted_home = FALSE;
#line 57 "Utility/SystemUser.vala"
	self->has_encrypted_private_dirs = FALSE;
#line 58 "Utility/SystemUser.vala"
	_tmp19_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 58 "Utility/SystemUser.vala"
	self->encrypted_dirs = _tmp19_;
#line 59 "Utility/SystemUser.vala"
	_tmp20_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 59 "Utility/SystemUser.vala"
	self->encrypted_private_dirs = _tmp20_;
#line 61 "Utility/SystemUser.vala"
	self->is_selected = FALSE;
#line 1842 "SystemUser.c"
}

static void
system_user_finalize (GObject * obj)
{
	SystemUser * self;
#line 29 "Utility/SystemUser.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_SYSTEM_USER, SystemUser);
#line 31 "Utility/SystemUser.vala"
	_g_free0 (self->name);
#line 32 "Utility/SystemUser.vala"
	_g_free0 (self->password);
#line 35 "Utility/SystemUser.vala"
	_g_free0 (self->user_info);
#line 36 "Utility/SystemUser.vala"
	_g_free0 (self->home_path);
#line 37 "Utility/SystemUser.vala"
	_g_free0 (self->shell_path);
#line 39 "Utility/SystemUser.vala"
	_g_free0 (self->full_name);
#line 40 "Utility/SystemUser.vala"
	_g_free0 (self->room_num);
#line 41 "Utility/SystemUser.vala"
	_g_free0 (self->phone_work);
#line 42 "Utility/SystemUser.vala"
	_g_free0 (self->phone_home);
#line 43 "Utility/SystemUser.vala"
	_g_free0 (self->other_info);
#line 46 "Utility/SystemUser.vala"
	_g_free0 (self->shadow_line);
#line 47 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_hash);
#line 48 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_last_changed);
#line 49 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_age_min);
#line 50 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_age_max);
#line 51 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_warning_period);
#line 52 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_inactivity_period);
#line 53 "Utility/SystemUser.vala"
	_g_free0 (self->pwd_expiraton_date);
#line 54 "Utility/SystemUser.vala"
	_g_free0 (self->reserved_field);
#line 58 "Utility/SystemUser.vala"
	_g_object_unref0 (self->encrypted_dirs);
#line 59 "Utility/SystemUser.vala"
	_g_object_unref0 (self->encrypted_private_dirs);
#line 29 "Utility/SystemUser.vala"
	G_OBJECT_CLASS (system_user_parent_class)->finalize (obj);
#line 1895 "SystemUser.c"
}

static GType
system_user_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SystemUserClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) system_user_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SystemUser), 0, (GInstanceInitFunc) system_user_instance_init, NULL };
	GType system_user_type_id;
	system_user_type_id = g_type_register_static (G_TYPE_OBJECT, "SystemUser", &g_define_type_info, 0);
	return system_user_type_id;
}

GType
system_user_get_type (void)
{
	static volatile gsize system_user_type_id__volatile = 0;
	if (g_once_init_enter (&system_user_type_id__volatile)) {
		GType system_user_type_id;
		system_user_type_id = system_user_get_type_once ();
		g_once_init_leave (&system_user_type_id__volatile, system_user_type_id);
	}
	return system_user_type_id__volatile;
}

static void
_vala_system_user_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	SystemUser * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_SYSTEM_USER, SystemUser);
#line 29 "Utility/SystemUser.vala"
	switch (property_id) {
#line 29 "Utility/SystemUser.vala"
		case SYSTEM_USER_IS_INSTALLED_PROPERTY:
#line 29 "Utility/SystemUser.vala"
		g_value_set_boolean (value, system_user_get_is_installed (self));
#line 29 "Utility/SystemUser.vala"
		break;
#line 29 "Utility/SystemUser.vala"
		case SYSTEM_USER_IS_SYSTEM_PROPERTY:
#line 29 "Utility/SystemUser.vala"
		g_value_set_boolean (value, system_user_get_is_system (self));
#line 29 "Utility/SystemUser.vala"
		break;
#line 29 "Utility/SystemUser.vala"
		case SYSTEM_USER_GROUP_NAMES_PROPERTY:
#line 29 "Utility/SystemUser.vala"
		g_value_take_string (value, system_user_get_group_names (self));
#line 29 "Utility/SystemUser.vala"
		break;
#line 1947 "SystemUser.c"
		default:
#line 29 "Utility/SystemUser.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 29 "Utility/SystemUser.vala"
		break;
#line 1953 "SystemUser.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

