/* TeeJee.Misc.c generated by valac 0.48.19, the Vala compiler
 * generated from TeeJee.Misc.vala, do not modify */

/*
 * TeeJee.Misc.vala
 *
 * Copyright 2012-2018 Tony George <teejeetech@gmail.com>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
 * MA 02110-1301, USA.
 *
 *
 */

#define _XOPEN_SOURCE

#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <locale.h>
#include <time.h>
#include <float.h>
#include <math.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_date_time_unref0(var) ((var == NULL) ? NULL : (var = (g_date_time_unref (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

void tee_jee_misc_set_numeric_locale (const gchar* type);
gchar* tee_jee_misc_timestamp (gboolean show_millis);
gchar* tee_jee_misc_timestamp_numeric (void);
gchar* tee_jee_misc_timestamp_for_path (void);
gchar* tee_jee_misc_format_date (GDateTime* date);
gchar* tee_jee_misc_format_date_12_hour (GDateTime* date);
gchar* tee_jee_misc_format_duration (glong millis);
gchar* tee_jee_misc_format_time_left (gint64 millis);
gdouble tee_jee_misc_parse_time (const gchar* time);
gchar* tee_jee_misc_string_replace (const gchar* str,
                                    const gchar* search,
                                    const gchar* replacement,
                                    gint count);
gchar* tee_jee_misc_escape_html (const gchar* html,
                                 gboolean pango_markup);
gchar* tee_jee_misc_unescape_html (const gchar* html);
gchar* tee_jee_misc_uri_encode (const gchar* path,
                                gboolean encode_forward_slash);
gchar* tee_jee_misc_uri_decode (const gchar* path);
GDateTime* tee_jee_misc_datetime_from_string (const gchar* date_time_string);
gchar* tee_jee_misc_break_string_by_word (const gchar* input_text);
gchar** tee_jee_misc_array_concat (gchar** a,
                                   gint a_length1,
                                   gchar** b,
                                   gint b_length1,
                                   gint* result_length1);
static void _vala_array_add1 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add2 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
gchar* tee_jee_misc_random_string (gint length,
                                   const gchar* charset);
gchar* tee_jee_misc_pad_numbers_in_string (const gchar* input,
                                           gint max_length,
                                           gchar pad_char);
gboolean tee_jee_misc_is_numeric (const gchar* text);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

void
tee_jee_misc_set_numeric_locale (const gchar* type)
{
#line 36 "Utility/TeeJee.Misc.vala"
	g_return_if_fail (type != NULL);
#line 37 "Utility/TeeJee.Misc.vala"
	setlocale (LC_NUMERIC, type);
#line 38 "Utility/TeeJee.Misc.vala"
	setlocale (LC_COLLATE, type);
#line 39 "Utility/TeeJee.Misc.vala"
	setlocale (LC_TIME, type);
#line 101 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_timestamp (gboolean show_millis)
{
	GDateTime* now = NULL;
	GDateTime* _tmp0_;
	gchar* result = NULL;
#line 50 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_date_time_new_now_local ();
#line 50 "Utility/TeeJee.Misc.vala"
	now = _tmp0_;
#line 52 "Utility/TeeJee.Misc.vala"
	if (show_millis) {
#line 116 "TeeJee.Misc.c"
		gint msec = 0;
		GDateTime* _tmp1_;
		GDateTime* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
#line 53 "Utility/TeeJee.Misc.vala"
		_tmp1_ = now;
#line 53 "Utility/TeeJee.Misc.vala"
		msec = g_date_time_get_microsecond (_tmp1_) / 1000;
#line 54 "Utility/TeeJee.Misc.vala"
		_tmp2_ = now;
#line 54 "Utility/TeeJee.Misc.vala"
		_tmp3_ = g_date_time_format (_tmp2_, "%H:%M:%S");
#line 54 "Utility/TeeJee.Misc.vala"
		_tmp4_ = _tmp3_;
#line 54 "Utility/TeeJee.Misc.vala"
		_tmp5_ = g_strdup_printf ("%s.%03d", _tmp4_, msec);
#line 54 "Utility/TeeJee.Misc.vala"
		_tmp6_ = _tmp5_;
#line 54 "Utility/TeeJee.Misc.vala"
		_g_free0 (_tmp4_);
#line 54 "Utility/TeeJee.Misc.vala"
		result = _tmp6_;
#line 54 "Utility/TeeJee.Misc.vala"
		_g_date_time_unref0 (now);
#line 54 "Utility/TeeJee.Misc.vala"
		return result;
#line 146 "TeeJee.Misc.c"
	} else {
		GDateTime* _tmp7_;
		gchar* _tmp8_;
#line 57 "Utility/TeeJee.Misc.vala"
		_tmp7_ = now;
#line 57 "Utility/TeeJee.Misc.vala"
		_tmp8_ = g_date_time_format (_tmp7_, "%H:%M:%S");
#line 57 "Utility/TeeJee.Misc.vala"
		result = _tmp8_;
#line 57 "Utility/TeeJee.Misc.vala"
		_g_date_time_unref0 (now);
#line 57 "Utility/TeeJee.Misc.vala"
		return result;
#line 160 "TeeJee.Misc.c"
	}
#line 44 "Utility/TeeJee.Misc.vala"
	_g_date_time_unref0 (now);
#line 164 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_timestamp_numeric (void)
{
	time_t _tmp0_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 65 "Utility/TeeJee.Misc.vala"
	_tmp0_ = time (NULL);
#line 65 "Utility/TeeJee.Misc.vala"
	_tmp1_ = g_strdup_printf ("%ld", (glong) _tmp0_);
#line 65 "Utility/TeeJee.Misc.vala"
	result = _tmp1_;
#line 65 "Utility/TeeJee.Misc.vala"
	return result;
#line 181 "TeeJee.Misc.c"
}

static void
g_time_local (time_t time,
              struct tm* result)
{
	struct tm _result_ = {0};
	struct tm _tmp0_ = {0};
#line 3094 "glib-2.0.vapi"
	localtime_r (&time, &_tmp0_);
#line 3094 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 3095 "glib-2.0.vapi"
	*result = _result_;
#line 3095 "glib-2.0.vapi"
	return;
#line 198 "TeeJee.Misc.c"
}

static gchar*
g_time_format (struct tm *self,
               const gchar* format)
{
	gchar* buffer = NULL;
	gchar* _tmp0_;
	gint buffer_length1;
	gint _buffer_size_;
	gchar* _tmp1_;
	gchar* result = NULL;
#line 3102 "glib-2.0.vapi"
	g_return_val_if_fail (format != NULL, NULL);
#line 3103 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 64);
#line 3103 "glib-2.0.vapi"
	buffer = _tmp0_;
#line 3103 "glib-2.0.vapi"
	buffer_length1 = 64;
#line 3103 "glib-2.0.vapi"
	_buffer_size_ = buffer_length1;
#line 3104 "glib-2.0.vapi"
	strftime (buffer, (gint) buffer_length1, format, &(*self));
#line 3105 "glib-2.0.vapi"
	_tmp1_ = g_strdup ((const gchar*) buffer);
#line 3105 "glib-2.0.vapi"
	result = _tmp1_;
#line 3105 "glib-2.0.vapi"
	buffer = (g_free (buffer), NULL);
#line 3105 "glib-2.0.vapi"
	return result;
#line 231 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_timestamp_for_path (void)
{
	struct tm t = {0};
	time_t _tmp0_;
	struct tm _tmp1_ = {0};
	gchar* _tmp2_;
	gchar* result = NULL;
#line 72 "Utility/TeeJee.Misc.vala"
	_tmp0_ = time (NULL);
#line 72 "Utility/TeeJee.Misc.vala"
	g_time_local (_tmp0_, &_tmp1_);
#line 72 "Utility/TeeJee.Misc.vala"
	t = _tmp1_;
#line 73 "Utility/TeeJee.Misc.vala"
	_tmp2_ = g_time_format (&t, "%Y-%m-%d_%H-%M-%S");
#line 73 "Utility/TeeJee.Misc.vala"
	result = _tmp2_;
#line 73 "Utility/TeeJee.Misc.vala"
	return result;
#line 254 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_format_date (GDateTime* date)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 78 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 79 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_date_time_format (date, "%Y-%m-%d %H:%M");
#line 79 "Utility/TeeJee.Misc.vala"
	result = _tmp0_;
#line 79 "Utility/TeeJee.Misc.vala"
	return result;
#line 270 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_format_date_12_hour (GDateTime* date)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 82 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (date != NULL, NULL);
#line 83 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_date_time_format (date, "%Y-%m-%d %I:%M %p");
#line 83 "Utility/TeeJee.Misc.vala"
	result = _tmp0_;
#line 83 "Utility/TeeJee.Misc.vala"
	return result;
#line 286 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_format_duration (glong millis)
{
	gdouble time = 0.0;
	gdouble hr = 0.0;
	gdouble min = 0.0;
	gdouble sec = 0.0;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 90 "Utility/TeeJee.Misc.vala"
	time = millis / 1000.0;
#line 92 "Utility/TeeJee.Misc.vala"
	hr = floor (time / (60.0 * 60));
#line 93 "Utility/TeeJee.Misc.vala"
	time = time - ((hr * 60) * 60);
#line 94 "Utility/TeeJee.Misc.vala"
	min = floor (time / 60.0);
#line 95 "Utility/TeeJee.Misc.vala"
	time = time - (min * 60);
#line 96 "Utility/TeeJee.Misc.vala"
	sec = floor (time);
#line 98 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup_printf ("%02.0lf:%02.0lf:%02.0lf", hr, min, sec);
#line 98 "Utility/TeeJee.Misc.vala"
	result = _tmp0_;
#line 98 "Utility/TeeJee.Misc.vala"
	return result;
#line 316 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_format_time_left (gint64 millis)
{
	gdouble mins = 0.0;
	gdouble secs = 0.0;
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* result = NULL;
#line 102 "Utility/TeeJee.Misc.vala"
	mins = (millis * 1.0) / 60000;
#line 103 "Utility/TeeJee.Misc.vala"
	secs = fmod (millis * 1.0, 60000) / 1000;
#line 104 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup ("");
#line 104 "Utility/TeeJee.Misc.vala"
	txt = _tmp0_;
#line 105 "Utility/TeeJee.Misc.vala"
	if (mins >= ((gdouble) 1)) {
#line 341 "TeeJee.Misc.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 106 "Utility/TeeJee.Misc.vala"
		_tmp1_ = txt;
#line 106 "Utility/TeeJee.Misc.vala"
		_tmp2_ = g_strdup_printf ("%.0fm ", mins);
#line 106 "Utility/TeeJee.Misc.vala"
		_tmp3_ = _tmp2_;
#line 106 "Utility/TeeJee.Misc.vala"
		_tmp4_ = g_strconcat (_tmp1_, _tmp3_, NULL);
#line 106 "Utility/TeeJee.Misc.vala"
		_g_free0 (txt);
#line 106 "Utility/TeeJee.Misc.vala"
		txt = _tmp4_;
#line 106 "Utility/TeeJee.Misc.vala"
		_g_free0 (_tmp3_);
#line 360 "TeeJee.Misc.c"
	}
#line 108 "Utility/TeeJee.Misc.vala"
	_tmp5_ = txt;
#line 108 "Utility/TeeJee.Misc.vala"
	_tmp6_ = g_strdup_printf ("%.0fs", secs);
#line 108 "Utility/TeeJee.Misc.vala"
	_tmp7_ = _tmp6_;
#line 108 "Utility/TeeJee.Misc.vala"
	_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
#line 108 "Utility/TeeJee.Misc.vala"
	_g_free0 (txt);
#line 108 "Utility/TeeJee.Misc.vala"
	txt = _tmp8_;
#line 108 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp7_);
#line 109 "Utility/TeeJee.Misc.vala"
	result = txt;
#line 109 "Utility/TeeJee.Misc.vala"
	return result;
#line 380 "TeeJee.Misc.c"
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 995 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 996 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 996 "glib-2.0.vapi"
	return result;
#line 393 "TeeJee.Misc.c"
}

gdouble
tee_jee_misc_parse_time (const gchar* time)
{
	gchar** arr = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint arr_length1;
	gint _arr_size_;
	gdouble millis = 0.0;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gdouble result = 0.0;
#line 112 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (time != NULL, 0.0);
#line 116 "Utility/TeeJee.Misc.vala"
	_tmp1_ = _tmp0_ = g_strsplit (time, ":", 0);
#line 116 "Utility/TeeJee.Misc.vala"
	arr = _tmp1_;
#line 116 "Utility/TeeJee.Misc.vala"
	arr_length1 = _vala_array_length (_tmp0_);
#line 116 "Utility/TeeJee.Misc.vala"
	_arr_size_ = arr_length1;
#line 117 "Utility/TeeJee.Misc.vala"
	millis = (gdouble) 0;
#line 118 "Utility/TeeJee.Misc.vala"
	_tmp2_ = arr;
#line 118 "Utility/TeeJee.Misc.vala"
	_tmp2__length1 = arr_length1;
#line 118 "Utility/TeeJee.Misc.vala"
	if (_tmp2__length1 >= 3) {
#line 426 "TeeJee.Misc.c"
		gchar** _tmp3_;
		gint _tmp3__length1;
		const gchar* _tmp4_;
		gchar** _tmp5_;
		gint _tmp5__length1;
		const gchar* _tmp6_;
		gchar** _tmp7_;
		gint _tmp7__length1;
		const gchar* _tmp8_;
#line 119 "Utility/TeeJee.Misc.vala"
		_tmp3_ = arr;
#line 119 "Utility/TeeJee.Misc.vala"
		_tmp3__length1 = arr_length1;
#line 119 "Utility/TeeJee.Misc.vala"
		_tmp4_ = _tmp3_[0];
#line 119 "Utility/TeeJee.Misc.vala"
		millis += (double_parse (_tmp4_) * 60) * 60;
#line 120 "Utility/TeeJee.Misc.vala"
		_tmp5_ = arr;
#line 120 "Utility/TeeJee.Misc.vala"
		_tmp5__length1 = arr_length1;
#line 120 "Utility/TeeJee.Misc.vala"
		_tmp6_ = _tmp5_[1];
#line 120 "Utility/TeeJee.Misc.vala"
		millis += double_parse (_tmp6_) * 60;
#line 121 "Utility/TeeJee.Misc.vala"
		_tmp7_ = arr;
#line 121 "Utility/TeeJee.Misc.vala"
		_tmp7__length1 = arr_length1;
#line 121 "Utility/TeeJee.Misc.vala"
		_tmp8_ = _tmp7_[2];
#line 121 "Utility/TeeJee.Misc.vala"
		millis += double_parse (_tmp8_);
#line 460 "TeeJee.Misc.c"
	}
#line 123 "Utility/TeeJee.Misc.vala"
	result = millis;
#line 123 "Utility/TeeJee.Misc.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 123 "Utility/TeeJee.Misc.vala"
	return result;
#line 468 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_string_replace (const gchar* str,
                             const gchar* search,
                             const gchar* replacement,
                             gint count)
{
	gchar** arr = NULL;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gint arr_length1;
	gint _arr_size_;
	gchar* new_txt = NULL;
	gchar* _tmp2_;
	gboolean first = FALSE;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar* result = NULL;
#line 126 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (str != NULL, NULL);
#line 126 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (search != NULL, NULL);
#line 126 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 127 "Utility/TeeJee.Misc.vala"
	_tmp1_ = _tmp0_ = g_strsplit (str, search, 0);
#line 127 "Utility/TeeJee.Misc.vala"
	arr = _tmp1_;
#line 127 "Utility/TeeJee.Misc.vala"
	arr_length1 = _vala_array_length (_tmp0_);
#line 127 "Utility/TeeJee.Misc.vala"
	_arr_size_ = arr_length1;
#line 128 "Utility/TeeJee.Misc.vala"
	_tmp2_ = g_strdup ("");
#line 128 "Utility/TeeJee.Misc.vala"
	new_txt = _tmp2_;
#line 129 "Utility/TeeJee.Misc.vala"
	first = TRUE;
#line 131 "Utility/TeeJee.Misc.vala"
	_tmp3_ = arr;
#line 131 "Utility/TeeJee.Misc.vala"
	_tmp3__length1 = arr_length1;
#line 512 "TeeJee.Misc.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 131 "Utility/TeeJee.Misc.vala"
		part_collection = _tmp3_;
#line 131 "Utility/TeeJee.Misc.vala"
		part_collection_length1 = _tmp3__length1;
#line 131 "Utility/TeeJee.Misc.vala"
		for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 524 "TeeJee.Misc.c"
			gchar* _tmp4_;
			gchar* part = NULL;
#line 131 "Utility/TeeJee.Misc.vala"
			_tmp4_ = g_strdup (part_collection[part_it]);
#line 131 "Utility/TeeJee.Misc.vala"
			part = _tmp4_;
#line 531 "TeeJee.Misc.c"
			{
#line 132 "Utility/TeeJee.Misc.vala"
				if (first) {
#line 535 "TeeJee.Misc.c"
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					gchar* _tmp7_;
#line 133 "Utility/TeeJee.Misc.vala"
					_tmp5_ = new_txt;
#line 133 "Utility/TeeJee.Misc.vala"
					_tmp6_ = part;
#line 133 "Utility/TeeJee.Misc.vala"
					_tmp7_ = g_strconcat (_tmp5_, _tmp6_, NULL);
#line 133 "Utility/TeeJee.Misc.vala"
					_g_free0 (new_txt);
#line 133 "Utility/TeeJee.Misc.vala"
					new_txt = _tmp7_;
#line 549 "TeeJee.Misc.c"
				} else {
#line 136 "Utility/TeeJee.Misc.vala"
					if (count == 0) {
#line 553 "TeeJee.Misc.c"
						const gchar* _tmp8_;
						gchar* _tmp9_;
						const gchar* _tmp10_;
						const gchar* _tmp11_;
						gchar* _tmp12_;
#line 137 "Utility/TeeJee.Misc.vala"
						_tmp8_ = new_txt;
#line 137 "Utility/TeeJee.Misc.vala"
						_tmp9_ = g_strconcat (_tmp8_, search, NULL);
#line 137 "Utility/TeeJee.Misc.vala"
						_g_free0 (new_txt);
#line 137 "Utility/TeeJee.Misc.vala"
						new_txt = _tmp9_;
#line 138 "Utility/TeeJee.Misc.vala"
						_tmp10_ = new_txt;
#line 138 "Utility/TeeJee.Misc.vala"
						_tmp11_ = part;
#line 138 "Utility/TeeJee.Misc.vala"
						_tmp12_ = g_strconcat (_tmp10_, _tmp11_, NULL);
#line 138 "Utility/TeeJee.Misc.vala"
						_g_free0 (new_txt);
#line 138 "Utility/TeeJee.Misc.vala"
						new_txt = _tmp12_;
#line 577 "TeeJee.Misc.c"
					} else {
						const gchar* _tmp13_;
						gchar* _tmp14_;
						const gchar* _tmp15_;
						const gchar* _tmp16_;
						gchar* _tmp17_;
						gint _tmp18_;
#line 141 "Utility/TeeJee.Misc.vala"
						_tmp13_ = new_txt;
#line 141 "Utility/TeeJee.Misc.vala"
						_tmp14_ = g_strconcat (_tmp13_, replacement, NULL);
#line 141 "Utility/TeeJee.Misc.vala"
						_g_free0 (new_txt);
#line 141 "Utility/TeeJee.Misc.vala"
						new_txt = _tmp14_;
#line 142 "Utility/TeeJee.Misc.vala"
						_tmp15_ = new_txt;
#line 142 "Utility/TeeJee.Misc.vala"
						_tmp16_ = part;
#line 142 "Utility/TeeJee.Misc.vala"
						_tmp17_ = g_strconcat (_tmp15_, _tmp16_, NULL);
#line 142 "Utility/TeeJee.Misc.vala"
						_g_free0 (new_txt);
#line 142 "Utility/TeeJee.Misc.vala"
						new_txt = _tmp17_;
#line 143 "Utility/TeeJee.Misc.vala"
						_tmp18_ = count;
#line 143 "Utility/TeeJee.Misc.vala"
						count = _tmp18_ - 1;
#line 607 "TeeJee.Misc.c"
					}
				}
#line 146 "Utility/TeeJee.Misc.vala"
				first = FALSE;
#line 131 "Utility/TeeJee.Misc.vala"
				_g_free0 (part);
#line 614 "TeeJee.Misc.c"
			}
		}
	}
#line 149 "Utility/TeeJee.Misc.vala"
	result = new_txt;
#line 149 "Utility/TeeJee.Misc.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 149 "Utility/TeeJee.Misc.vala"
	return result;
#line 624 "TeeJee.Misc.c"
}

static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
	gchar* result = NULL;
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1534 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1535 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 646 "TeeJee.Misc.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 650 "TeeJee.Misc.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 656 "TeeJee.Misc.c"
	} else {
#line 1535 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 660 "TeeJee.Misc.c"
	}
#line 1535 "glib-2.0.vapi"
	if (_tmp0_) {
#line 664 "TeeJee.Misc.c"
		gchar* _tmp2_;
#line 1536 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1536 "glib-2.0.vapi"
		result = _tmp2_;
#line 1536 "glib-2.0.vapi"
		return result;
#line 672 "TeeJee.Misc.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1539 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1539 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1539 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1539 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1539 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1539 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1539 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1539 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1539 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1539 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 704 "TeeJee.Misc.c"
				goto __catch0_g_regex_error;
			}
#line 1539 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1539 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1539 "glib-2.0.vapi"
			return NULL;
#line 713 "TeeJee.Misc.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1540 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1540 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1540 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "glib-2.0.vapi"
			_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 729 "TeeJee.Misc.c"
				goto __catch0_g_regex_error;
			}
#line 1540 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1540 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1540 "glib-2.0.vapi"
			return NULL;
#line 738 "TeeJee.Misc.c"
		}
#line 1540 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1540 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1540 "glib-2.0.vapi"
		result = _tmp10_;
#line 1540 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1540 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1540 "glib-2.0.vapi"
		return result;
#line 752 "TeeJee.Misc.c"
	}
	goto __finally0;
	__catch0_g_regex_error:
	{
#line 1538 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1542 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 761 "TeeJee.Misc.c"
	}
	__finally0:
#line 1538 "glib-2.0.vapi"
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1538 "glib-2.0.vapi"
	g_clear_error (&_inner_error0_);
#line 1538 "glib-2.0.vapi"
	return NULL;
#line 770 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_escape_html (const gchar* html,
                          gboolean pango_markup)
{
	gchar* txt = NULL;
	gchar* _tmp0_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* result = NULL;
#line 152 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (html != NULL, NULL);
#line 153 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup (html);
#line 153 "Utility/TeeJee.Misc.vala"
	txt = _tmp0_;
#line 155 "Utility/TeeJee.Misc.vala"
	if (pango_markup) {
#line 796 "TeeJee.Misc.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
#line 156 "Utility/TeeJee.Misc.vala"
		_tmp1_ = txt;
#line 156 "Utility/TeeJee.Misc.vala"
		_tmp2_ = string_replace (_tmp1_, "\\u00", "");
#line 156 "Utility/TeeJee.Misc.vala"
		_tmp3_ = _tmp2_;
#line 156 "Utility/TeeJee.Misc.vala"
		_tmp4_ = string_replace (_tmp3_, "\\x", "");
#line 156 "Utility/TeeJee.Misc.vala"
		_g_free0 (txt);
#line 156 "Utility/TeeJee.Misc.vala"
		txt = _tmp4_;
#line 156 "Utility/TeeJee.Misc.vala"
		_g_free0 (_tmp3_);
#line 815 "TeeJee.Misc.c"
	} else {
		const gchar* _tmp5_;
		gchar* _tmp6_;
#line 161 "Utility/TeeJee.Misc.vala"
		_tmp5_ = txt;
#line 161 "Utility/TeeJee.Misc.vala"
		_tmp6_ = string_replace (_tmp5_, " ", "&nbsp;");
#line 161 "Utility/TeeJee.Misc.vala"
		_g_free0 (txt);
#line 161 "Utility/TeeJee.Misc.vala"
		txt = _tmp6_;
#line 827 "TeeJee.Misc.c"
	}
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp7_ = txt;
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp8_ = string_replace (_tmp7_, "&", "&amp;");
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp9_ = _tmp8_;
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp10_ = string_replace (_tmp9_, "\"", "&quot;");
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp11_ = _tmp10_;
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp12_ = string_replace (_tmp11_, "<", "&lt;");
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp13_ = _tmp12_;
#line 165 "Utility/TeeJee.Misc.vala"
	_tmp14_ = string_replace (_tmp13_, ">", "&gt;");
#line 165 "Utility/TeeJee.Misc.vala"
	_g_free0 (txt);
#line 165 "Utility/TeeJee.Misc.vala"
	txt = _tmp14_;
#line 165 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp13_);
#line 165 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp11_);
#line 165 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp9_);
#line 172 "Utility/TeeJee.Misc.vala"
	result = txt;
#line 172 "Utility/TeeJee.Misc.vala"
	return result;
#line 859 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_unescape_html (const gchar* html)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* result = NULL;
#line 175 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (html != NULL, NULL);
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp0_ = string_replace (html, "&amp;", "&");
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp1_ = _tmp0_;
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp2_ = string_replace (_tmp1_, "&quot;", "\"");
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp3_ = _tmp2_;
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp4_ = string_replace (_tmp3_, "&lt;", "<");
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp5_ = _tmp4_;
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp6_ = string_replace (_tmp5_, "&gt;", ">");
#line 176 "Utility/TeeJee.Misc.vala"
	_tmp7_ = _tmp6_;
#line 176 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp5_);
#line 176 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp3_);
#line 176 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp1_);
#line 176 "Utility/TeeJee.Misc.vala"
	result = _tmp7_;
#line 176 "Utility/TeeJee.Misc.vala"
	return result;
#line 902 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_uri_encode (const gchar* path,
                         gboolean encode_forward_slash)
{
	gchar* uri = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 185 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 186 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_uri_escape_string (path, NULL, TRUE);
#line 186 "Utility/TeeJee.Misc.vala"
	uri = _tmp0_;
#line 187 "Utility/TeeJee.Misc.vala"
	if (!encode_forward_slash) {
#line 920 "TeeJee.Misc.c"
		const gchar* _tmp1_;
		gchar* _tmp2_;
#line 188 "Utility/TeeJee.Misc.vala"
		_tmp1_ = uri;
#line 188 "Utility/TeeJee.Misc.vala"
		_tmp2_ = string_replace (_tmp1_, "%2F", "/");
#line 188 "Utility/TeeJee.Misc.vala"
		_g_free0 (uri);
#line 188 "Utility/TeeJee.Misc.vala"
		uri = _tmp2_;
#line 931 "TeeJee.Misc.c"
	}
#line 190 "Utility/TeeJee.Misc.vala"
	result = uri;
#line 190 "Utility/TeeJee.Misc.vala"
	return result;
#line 937 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_uri_decode (const gchar* path)
{
	gchar* _tmp0_;
	gchar* result = NULL;
#line 193 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (path != NULL, NULL);
#line 194 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_uri_unescape_string (path, NULL);
#line 194 "Utility/TeeJee.Misc.vala"
	result = _tmp0_;
#line 194 "Utility/TeeJee.Misc.vala"
	return result;
#line 953 "TeeJee.Misc.c"
}

static gchar*
string_strip (const gchar* self)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1359 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1360 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1360 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1361 "glib-2.0.vapi"
	g_strstrip (_result_);
#line 1362 "glib-2.0.vapi"
	result = _result_;
#line 1362 "glib-2.0.vapi"
	return result;
#line 974 "TeeJee.Misc.c"
}

GDateTime*
tee_jee_misc_datetime_from_string (const gchar* date_time_string)
{
	gchar** arr = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	gint arr_length1;
	gint _arr_size_;
	gint _tmp9_ = 0;
	gchar** _tmp10_;
	gint _tmp10__length1;
	gint year = 0;
	gint _tmp13_ = 0;
	gchar** _tmp14_;
	gint _tmp14__length1;
	gint month = 0;
	gint _tmp17_ = 0;
	gchar** _tmp18_;
	gint _tmp18__length1;
	gint day = 0;
	gint _tmp21_ = 0;
	gchar** _tmp22_;
	gint _tmp22__length1;
	gint hour = 0;
	gint _tmp25_ = 0;
	gchar** _tmp26_;
	gint _tmp26__length1;
	gint min = 0;
	gint _tmp29_ = 0;
	gchar** _tmp30_;
	gint _tmp30__length1;
	gint sec = 0;
	GDateTime* _tmp33_;
	GDateTime* result = NULL;
#line 197 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (date_time_string != NULL, NULL);
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp0_ = string_replace (date_time_string, ":", " ");
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp1_ = _tmp0_;
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp2_ = string_replace (_tmp1_, "-", " ");
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp3_ = _tmp2_;
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp4_ = string_strip (_tmp3_);
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp5_ = _tmp4_;
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, " ", 0);
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp8_ = _tmp7_;
#line 208 "Utility/TeeJee.Misc.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 208 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp5_);
#line 208 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp3_);
#line 208 "Utility/TeeJee.Misc.vala"
	_g_free0 (_tmp1_);
#line 208 "Utility/TeeJee.Misc.vala"
	arr = _tmp8_;
#line 208 "Utility/TeeJee.Misc.vala"
	arr_length1 = _tmp8__length1;
#line 208 "Utility/TeeJee.Misc.vala"
	_arr_size_ = arr_length1;
#line 210 "Utility/TeeJee.Misc.vala"
	_tmp10_ = arr;
#line 210 "Utility/TeeJee.Misc.vala"
	_tmp10__length1 = arr_length1;
#line 210 "Utility/TeeJee.Misc.vala"
	if (_tmp10__length1 >= 3) {
#line 1057 "TeeJee.Misc.c"
		gchar** _tmp11_;
		gint _tmp11__length1;
		const gchar* _tmp12_;
#line 210 "Utility/TeeJee.Misc.vala"
		_tmp11_ = arr;
#line 210 "Utility/TeeJee.Misc.vala"
		_tmp11__length1 = arr_length1;
#line 210 "Utility/TeeJee.Misc.vala"
		_tmp12_ = _tmp11_[0];
#line 210 "Utility/TeeJee.Misc.vala"
		_tmp9_ = atoi (_tmp12_);
#line 1069 "TeeJee.Misc.c"
	} else {
#line 210 "Utility/TeeJee.Misc.vala"
		_tmp9_ = 0;
#line 1073 "TeeJee.Misc.c"
	}
#line 210 "Utility/TeeJee.Misc.vala"
	year = _tmp9_;
#line 211 "Utility/TeeJee.Misc.vala"
	_tmp14_ = arr;
#line 211 "Utility/TeeJee.Misc.vala"
	_tmp14__length1 = arr_length1;
#line 211 "Utility/TeeJee.Misc.vala"
	if (_tmp14__length1 >= 3) {
#line 1083 "TeeJee.Misc.c"
		gchar** _tmp15_;
		gint _tmp15__length1;
		const gchar* _tmp16_;
#line 211 "Utility/TeeJee.Misc.vala"
		_tmp15_ = arr;
#line 211 "Utility/TeeJee.Misc.vala"
		_tmp15__length1 = arr_length1;
#line 211 "Utility/TeeJee.Misc.vala"
		_tmp16_ = _tmp15_[1];
#line 211 "Utility/TeeJee.Misc.vala"
		_tmp13_ = atoi (_tmp16_);
#line 1095 "TeeJee.Misc.c"
	} else {
#line 211 "Utility/TeeJee.Misc.vala"
		_tmp13_ = 0;
#line 1099 "TeeJee.Misc.c"
	}
#line 211 "Utility/TeeJee.Misc.vala"
	month = _tmp13_;
#line 212 "Utility/TeeJee.Misc.vala"
	_tmp18_ = arr;
#line 212 "Utility/TeeJee.Misc.vala"
	_tmp18__length1 = arr_length1;
#line 212 "Utility/TeeJee.Misc.vala"
	if (_tmp18__length1 >= 3) {
#line 1109 "TeeJee.Misc.c"
		gchar** _tmp19_;
		gint _tmp19__length1;
		const gchar* _tmp20_;
#line 212 "Utility/TeeJee.Misc.vala"
		_tmp19_ = arr;
#line 212 "Utility/TeeJee.Misc.vala"
		_tmp19__length1 = arr_length1;
#line 212 "Utility/TeeJee.Misc.vala"
		_tmp20_ = _tmp19_[2];
#line 212 "Utility/TeeJee.Misc.vala"
		_tmp17_ = atoi (_tmp20_);
#line 1121 "TeeJee.Misc.c"
	} else {
#line 212 "Utility/TeeJee.Misc.vala"
		_tmp17_ = 0;
#line 1125 "TeeJee.Misc.c"
	}
#line 212 "Utility/TeeJee.Misc.vala"
	day = _tmp17_;
#line 213 "Utility/TeeJee.Misc.vala"
	_tmp22_ = arr;
#line 213 "Utility/TeeJee.Misc.vala"
	_tmp22__length1 = arr_length1;
#line 213 "Utility/TeeJee.Misc.vala"
	if (_tmp22__length1 >= 4) {
#line 1135 "TeeJee.Misc.c"
		gchar** _tmp23_;
		gint _tmp23__length1;
		const gchar* _tmp24_;
#line 213 "Utility/TeeJee.Misc.vala"
		_tmp23_ = arr;
#line 213 "Utility/TeeJee.Misc.vala"
		_tmp23__length1 = arr_length1;
#line 213 "Utility/TeeJee.Misc.vala"
		_tmp24_ = _tmp23_[3];
#line 213 "Utility/TeeJee.Misc.vala"
		_tmp21_ = atoi (_tmp24_);
#line 1147 "TeeJee.Misc.c"
	} else {
#line 213 "Utility/TeeJee.Misc.vala"
		_tmp21_ = 0;
#line 1151 "TeeJee.Misc.c"
	}
#line 213 "Utility/TeeJee.Misc.vala"
	hour = _tmp21_;
#line 214 "Utility/TeeJee.Misc.vala"
	_tmp26_ = arr;
#line 214 "Utility/TeeJee.Misc.vala"
	_tmp26__length1 = arr_length1;
#line 214 "Utility/TeeJee.Misc.vala"
	if (_tmp26__length1 >= 5) {
#line 1161 "TeeJee.Misc.c"
		gchar** _tmp27_;
		gint _tmp27__length1;
		const gchar* _tmp28_;
#line 214 "Utility/TeeJee.Misc.vala"
		_tmp27_ = arr;
#line 214 "Utility/TeeJee.Misc.vala"
		_tmp27__length1 = arr_length1;
#line 214 "Utility/TeeJee.Misc.vala"
		_tmp28_ = _tmp27_[4];
#line 214 "Utility/TeeJee.Misc.vala"
		_tmp25_ = atoi (_tmp28_);
#line 1173 "TeeJee.Misc.c"
	} else {
#line 214 "Utility/TeeJee.Misc.vala"
		_tmp25_ = 0;
#line 1177 "TeeJee.Misc.c"
	}
#line 214 "Utility/TeeJee.Misc.vala"
	min = _tmp25_;
#line 215 "Utility/TeeJee.Misc.vala"
	_tmp30_ = arr;
#line 215 "Utility/TeeJee.Misc.vala"
	_tmp30__length1 = arr_length1;
#line 215 "Utility/TeeJee.Misc.vala"
	if (_tmp30__length1 >= 6) {
#line 1187 "TeeJee.Misc.c"
		gchar** _tmp31_;
		gint _tmp31__length1;
		const gchar* _tmp32_;
#line 215 "Utility/TeeJee.Misc.vala"
		_tmp31_ = arr;
#line 215 "Utility/TeeJee.Misc.vala"
		_tmp31__length1 = arr_length1;
#line 215 "Utility/TeeJee.Misc.vala"
		_tmp32_ = _tmp31_[5];
#line 215 "Utility/TeeJee.Misc.vala"
		_tmp29_ = atoi (_tmp32_);
#line 1199 "TeeJee.Misc.c"
	} else {
#line 215 "Utility/TeeJee.Misc.vala"
		_tmp29_ = 0;
#line 1203 "TeeJee.Misc.c"
	}
#line 215 "Utility/TeeJee.Misc.vala"
	sec = _tmp29_;
#line 217 "Utility/TeeJee.Misc.vala"
	_tmp33_ = g_date_time_new_utc (year, month, day, hour, min, (gdouble) sec);
#line 217 "Utility/TeeJee.Misc.vala"
	result = _tmp33_;
#line 217 "Utility/TeeJee.Misc.vala"
	arr = (_vala_array_free (arr, arr_length1, (GDestroyNotify) g_free), NULL);
#line 217 "Utility/TeeJee.Misc.vala"
	return result;
#line 1215 "TeeJee.Misc.c"
}

static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gchar* _tmp4_;
	gchar* result = NULL;
#line 1480 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1481 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1481 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1481 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1482 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1483 "glib-2.0.vapi"
		start = string_length + start;
#line 1242 "TeeJee.Misc.c"
	}
#line 1485 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1486 "glib-2.0.vapi"
		end = string_length + end;
#line 1248 "TeeJee.Misc.c"
	}
#line 1488 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = start <= string_length;
#line 1254 "TeeJee.Misc.c"
	} else {
#line 1488 "glib-2.0.vapi"
		_tmp2_ = FALSE;
#line 1258 "TeeJee.Misc.c"
	}
#line 1488 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp2_, NULL);
#line 1489 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = end <= string_length;
#line 1266 "TeeJee.Misc.c"
	} else {
#line 1489 "glib-2.0.vapi"
		_tmp3_ = FALSE;
#line 1270 "TeeJee.Misc.c"
	}
#line 1489 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp3_, NULL);
#line 1490 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1491 "glib-2.0.vapi"
	_tmp4_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1491 "glib-2.0.vapi"
	result = _tmp4_;
#line 1491 "glib-2.0.vapi"
	return result;
#line 1282 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_break_string_by_word (const gchar* input_text)
{
	gchar* text = NULL;
	gchar* _tmp0_;
	gchar* line = NULL;
	gchar* _tmp1_;
	gchar** _tmp2_;
	gchar** _tmp3_;
	const gchar* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	const gchar* _tmp27_;
	gchar* result = NULL;
#line 220 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (input_text != NULL, NULL);
#line 221 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup ("");
#line 221 "Utility/TeeJee.Misc.vala"
	text = _tmp0_;
#line 222 "Utility/TeeJee.Misc.vala"
	_tmp1_ = g_strdup ("");
#line 222 "Utility/TeeJee.Misc.vala"
	line = _tmp1_;
#line 223 "Utility/TeeJee.Misc.vala"
	_tmp3_ = _tmp2_ = g_strsplit (input_text, " ", 0);
#line 1311 "TeeJee.Misc.c"
	{
		gchar** part_collection = NULL;
		gint part_collection_length1 = 0;
		gint _part_collection_size_ = 0;
		gint part_it = 0;
#line 223 "Utility/TeeJee.Misc.vala"
		part_collection = _tmp3_;
#line 223 "Utility/TeeJee.Misc.vala"
		part_collection_length1 = _vala_array_length (_tmp2_);
#line 223 "Utility/TeeJee.Misc.vala"
		for (part_it = 0; part_it < part_collection_length1; part_it = part_it + 1) {
#line 1323 "TeeJee.Misc.c"
			gchar* _tmp4_;
			gchar* part = NULL;
#line 223 "Utility/TeeJee.Misc.vala"
			_tmp4_ = g_strdup (part_collection[part_it]);
#line 223 "Utility/TeeJee.Misc.vala"
			part = _tmp4_;
#line 1330 "TeeJee.Misc.c"
			{
				const gchar* _tmp5_;
				const gchar* _tmp6_;
				gchar* _tmp7_;
				gchar* _tmp8_;
				gchar* _tmp9_;
				const gchar* _tmp10_;
				gint _tmp11_;
				gint _tmp12_;
#line 224 "Utility/TeeJee.Misc.vala"
				_tmp5_ = line;
#line 224 "Utility/TeeJee.Misc.vala"
				_tmp6_ = part;
#line 224 "Utility/TeeJee.Misc.vala"
				_tmp7_ = g_strconcat (_tmp6_, " ", NULL);
#line 224 "Utility/TeeJee.Misc.vala"
				_tmp8_ = _tmp7_;
#line 224 "Utility/TeeJee.Misc.vala"
				_tmp9_ = g_strconcat (_tmp5_, _tmp8_, NULL);
#line 224 "Utility/TeeJee.Misc.vala"
				_g_free0 (line);
#line 224 "Utility/TeeJee.Misc.vala"
				line = _tmp9_;
#line 224 "Utility/TeeJee.Misc.vala"
				_g_free0 (_tmp8_);
#line 225 "Utility/TeeJee.Misc.vala"
				_tmp10_ = line;
#line 225 "Utility/TeeJee.Misc.vala"
				_tmp11_ = strlen (_tmp10_);
#line 225 "Utility/TeeJee.Misc.vala"
				_tmp12_ = _tmp11_;
#line 225 "Utility/TeeJee.Misc.vala"
				if (_tmp12_ > 50) {
#line 1364 "TeeJee.Misc.c"
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gchar* _tmp15_;
					gchar* _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					gchar* _tmp19_;
					gchar* _tmp20_;
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp13_ = text;
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp14_ = line;
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp15_ = string_strip (_tmp14_);
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp16_ = _tmp15_;
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp17_ = g_strconcat (_tmp16_, "\n", NULL);
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp18_ = _tmp17_;
#line 226 "Utility/TeeJee.Misc.vala"
					_tmp19_ = g_strconcat (_tmp13_, _tmp18_, NULL);
#line 226 "Utility/TeeJee.Misc.vala"
					_g_free0 (text);
#line 226 "Utility/TeeJee.Misc.vala"
					text = _tmp19_;
#line 226 "Utility/TeeJee.Misc.vala"
					_g_free0 (_tmp18_);
#line 226 "Utility/TeeJee.Misc.vala"
					_g_free0 (_tmp16_);
#line 227 "Utility/TeeJee.Misc.vala"
					_tmp20_ = g_strdup ("");
#line 227 "Utility/TeeJee.Misc.vala"
					_g_free0 (line);
#line 227 "Utility/TeeJee.Misc.vala"
					line = _tmp20_;
#line 1401 "TeeJee.Misc.c"
				}
#line 223 "Utility/TeeJee.Misc.vala"
				_g_free0 (part);
#line 1405 "TeeJee.Misc.c"
			}
		}
#line 223 "Utility/TeeJee.Misc.vala"
		part_collection = (_vala_array_free (part_collection, part_collection_length1, (GDestroyNotify) g_free), NULL);
#line 1410 "TeeJee.Misc.c"
	}
#line 230 "Utility/TeeJee.Misc.vala"
	_tmp21_ = line;
#line 230 "Utility/TeeJee.Misc.vala"
	_tmp22_ = strlen (_tmp21_);
#line 230 "Utility/TeeJee.Misc.vala"
	_tmp23_ = _tmp22_;
#line 230 "Utility/TeeJee.Misc.vala"
	if (_tmp23_ > 0) {
#line 1420 "TeeJee.Misc.c"
		const gchar* _tmp24_;
		const gchar* _tmp25_;
		gchar* _tmp26_;
#line 231 "Utility/TeeJee.Misc.vala"
		_tmp24_ = text;
#line 231 "Utility/TeeJee.Misc.vala"
		_tmp25_ = line;
#line 231 "Utility/TeeJee.Misc.vala"
		_tmp26_ = g_strconcat (_tmp24_, _tmp25_, NULL);
#line 231 "Utility/TeeJee.Misc.vala"
		_g_free0 (text);
#line 231 "Utility/TeeJee.Misc.vala"
		text = _tmp26_;
#line 1434 "TeeJee.Misc.c"
	}
#line 233 "Utility/TeeJee.Misc.vala"
	_tmp27_ = text;
#line 233 "Utility/TeeJee.Misc.vala"
	if (g_str_has_suffix (_tmp27_, "\n")) {
#line 1440 "TeeJee.Misc.c"
		const gchar* _tmp28_;
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp28_ = text;
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp29_ = text;
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp30_ = strlen (_tmp29_);
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp31_ = _tmp30_;
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp32_ = string_slice (_tmp28_, (glong) 0, (glong) (_tmp31_ - 1));
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp33_ = _tmp32_;
#line 234 "Utility/TeeJee.Misc.vala"
		_tmp34_ = string_strip (_tmp33_);
#line 234 "Utility/TeeJee.Misc.vala"
		_g_free0 (text);
#line 234 "Utility/TeeJee.Misc.vala"
		text = _tmp34_;
#line 234 "Utility/TeeJee.Misc.vala"
		_g_free0 (_tmp33_);
#line 1468 "TeeJee.Misc.c"
	}
#line 236 "Utility/TeeJee.Misc.vala"
	result = text;
#line 236 "Utility/TeeJee.Misc.vala"
	_g_free0 (line);
#line 236 "Utility/TeeJee.Misc.vala"
	return result;
#line 1476 "TeeJee.Misc.c"
}

static void
_vala_array_add1 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 241 "Utility/TeeJee.Misc.vala"
	if ((*length) == (*size)) {
#line 241 "Utility/TeeJee.Misc.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 241 "Utility/TeeJee.Misc.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1491 "TeeJee.Misc.c"
	}
#line 241 "Utility/TeeJee.Misc.vala"
	(*array)[(*length)++] = value;
#line 241 "Utility/TeeJee.Misc.vala"
	(*array)[*length] = NULL;
#line 1497 "TeeJee.Misc.c"
}

static void
_vala_array_add2 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
#line 242 "Utility/TeeJee.Misc.vala"
	if ((*length) == (*size)) {
#line 242 "Utility/TeeJee.Misc.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 242 "Utility/TeeJee.Misc.vala"
		*array = g_renew (gchar*, *array, (*size) + 1);
#line 1512 "TeeJee.Misc.c"
	}
#line 242 "Utility/TeeJee.Misc.vala"
	(*array)[(*length)++] = value;
#line 242 "Utility/TeeJee.Misc.vala"
	(*array)[*length] = NULL;
#line 1518 "TeeJee.Misc.c"
}

gchar**
tee_jee_misc_array_concat (gchar** a,
                           gint a_length1,
                           gchar** b,
                           gint b_length1,
                           gint* result_length1)
{
	gchar** c = NULL;
	gchar** _tmp0_;
	gint c_length1;
	gint _c_size_;
	gchar** _tmp7_;
	gint _tmp7__length1;
	gchar** result = NULL;
#line 240 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_new0 (gchar*, 0 + 1);
#line 240 "Utility/TeeJee.Misc.vala"
	c = _tmp0_;
#line 240 "Utility/TeeJee.Misc.vala"
	c_length1 = 0;
#line 240 "Utility/TeeJee.Misc.vala"
	_c_size_ = c_length1;
#line 1543 "TeeJee.Misc.c"
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 241 "Utility/TeeJee.Misc.vala"
		str_collection = a;
#line 241 "Utility/TeeJee.Misc.vala"
		str_collection_length1 = a_length1;
#line 241 "Utility/TeeJee.Misc.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 1555 "TeeJee.Misc.c"
			gchar* _tmp1_;
			gchar* str = NULL;
#line 241 "Utility/TeeJee.Misc.vala"
			_tmp1_ = g_strdup (str_collection[str_it]);
#line 241 "Utility/TeeJee.Misc.vala"
			str = _tmp1_;
#line 1562 "TeeJee.Misc.c"
			{
				const gchar* _tmp2_;
				gchar* _tmp3_;
#line 241 "Utility/TeeJee.Misc.vala"
				_tmp2_ = str;
#line 241 "Utility/TeeJee.Misc.vala"
				_tmp3_ = g_strdup (_tmp2_);
#line 241 "Utility/TeeJee.Misc.vala"
				_vala_array_add1 (&c, &c_length1, &_c_size_, _tmp3_);
#line 241 "Utility/TeeJee.Misc.vala"
				_g_free0 (str);
#line 1574 "TeeJee.Misc.c"
			}
		}
	}
	{
		gchar** str_collection = NULL;
		gint str_collection_length1 = 0;
		gint _str_collection_size_ = 0;
		gint str_it = 0;
#line 242 "Utility/TeeJee.Misc.vala"
		str_collection = b;
#line 242 "Utility/TeeJee.Misc.vala"
		str_collection_length1 = b_length1;
#line 242 "Utility/TeeJee.Misc.vala"
		for (str_it = 0; str_it < str_collection_length1; str_it = str_it + 1) {
#line 1589 "TeeJee.Misc.c"
			gchar* _tmp4_;
			gchar* str = NULL;
#line 242 "Utility/TeeJee.Misc.vala"
			_tmp4_ = g_strdup (str_collection[str_it]);
#line 242 "Utility/TeeJee.Misc.vala"
			str = _tmp4_;
#line 1596 "TeeJee.Misc.c"
			{
				const gchar* _tmp5_;
				gchar* _tmp6_;
#line 242 "Utility/TeeJee.Misc.vala"
				_tmp5_ = str;
#line 242 "Utility/TeeJee.Misc.vala"
				_tmp6_ = g_strdup (_tmp5_);
#line 242 "Utility/TeeJee.Misc.vala"
				_vala_array_add2 (&c, &c_length1, &_c_size_, _tmp6_);
#line 242 "Utility/TeeJee.Misc.vala"
				_g_free0 (str);
#line 1608 "TeeJee.Misc.c"
			}
		}
	}
#line 243 "Utility/TeeJee.Misc.vala"
	_tmp7_ = c;
#line 243 "Utility/TeeJee.Misc.vala"
	_tmp7__length1 = c_length1;
#line 243 "Utility/TeeJee.Misc.vala"
	if (result_length1) {
#line 243 "Utility/TeeJee.Misc.vala"
		*result_length1 = _tmp7__length1;
#line 1620 "TeeJee.Misc.c"
	}
#line 243 "Utility/TeeJee.Misc.vala"
	result = _tmp7_;
#line 243 "Utility/TeeJee.Misc.vala"
	return result;
#line 1626 "TeeJee.Misc.c"
}

static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1262 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1263 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1263 "glib-2.0.vapi"
	return result;
#line 1640 "TeeJee.Misc.c"
}

static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gchar* _tmp0_;
	gint result = 0;
#line 1282 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1283 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1283 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1283 "glib-2.0.vapi"
	return result;
#line 1657 "TeeJee.Misc.c"
}

static gchar*
g_unichar_to_string (gunichar self)
{
	gchar* str = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 1071 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, 7);
#line 1071 "glib-2.0.vapi"
	str = (gchar*) _tmp0_;
#line 1072 "glib-2.0.vapi"
	g_unichar_to_utf8 (self, str);
#line 1073 "glib-2.0.vapi"
	result = str;
#line 1073 "glib-2.0.vapi"
	return result;
#line 1676 "TeeJee.Misc.c"
}

gchar*
tee_jee_misc_random_string (gint length,
                            const gchar* charset)
{
	gchar* random = NULL;
	gchar* _tmp0_;
	gchar* result = NULL;
#line 246 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (charset != NULL, NULL);
#line 247 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup ("");
#line 247 "Utility/TeeJee.Misc.vala"
	random = _tmp0_;
#line 1692 "TeeJee.Misc.c"
	{
		gint i = 0;
#line 249 "Utility/TeeJee.Misc.vala"
		i = 0;
#line 1697 "TeeJee.Misc.c"
		{
			gboolean _tmp1_ = FALSE;
#line 249 "Utility/TeeJee.Misc.vala"
			_tmp1_ = TRUE;
#line 249 "Utility/TeeJee.Misc.vala"
			while (TRUE) {
#line 1704 "TeeJee.Misc.c"
				gint random_index = 0;
				gint _tmp3_;
				gint _tmp4_;
				gchar* ch = NULL;
				gchar* _tmp5_;
				const gchar* _tmp6_;
				const gchar* _tmp7_;
				gchar* _tmp8_;
#line 249 "Utility/TeeJee.Misc.vala"
				if (!_tmp1_) {
#line 1715 "TeeJee.Misc.c"
					gint _tmp2_;
#line 249 "Utility/TeeJee.Misc.vala"
					_tmp2_ = i;
#line 249 "Utility/TeeJee.Misc.vala"
					i = _tmp2_ + 1;
#line 1721 "TeeJee.Misc.c"
				}
#line 249 "Utility/TeeJee.Misc.vala"
				_tmp1_ = FALSE;
#line 249 "Utility/TeeJee.Misc.vala"
				if (!(i < length)) {
#line 249 "Utility/TeeJee.Misc.vala"
					break;
#line 1729 "TeeJee.Misc.c"
				}
#line 250 "Utility/TeeJee.Misc.vala"
				_tmp3_ = strlen (charset);
#line 250 "Utility/TeeJee.Misc.vala"
				_tmp4_ = _tmp3_;
#line 250 "Utility/TeeJee.Misc.vala"
				random_index = (gint) g_random_int_range ((gint32) 0, (gint32) _tmp4_);
#line 251 "Utility/TeeJee.Misc.vala"
				_tmp5_ = g_unichar_to_string (string_get_char (charset, (glong) string_index_of_nth_char (charset, (glong) random_index)));
#line 251 "Utility/TeeJee.Misc.vala"
				ch = _tmp5_;
#line 252 "Utility/TeeJee.Misc.vala"
				_tmp6_ = random;
#line 252 "Utility/TeeJee.Misc.vala"
				_tmp7_ = ch;
#line 252 "Utility/TeeJee.Misc.vala"
				_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 252 "Utility/TeeJee.Misc.vala"
				_g_free0 (random);
#line 252 "Utility/TeeJee.Misc.vala"
				random = _tmp8_;
#line 249 "Utility/TeeJee.Misc.vala"
				_g_free0 (ch);
#line 1753 "TeeJee.Misc.c"
			}
		}
	}
#line 255 "Utility/TeeJee.Misc.vala"
	result = random;
#line 255 "Utility/TeeJee.Misc.vala"
	return result;
#line 1761 "TeeJee.Misc.c"
}

static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
#line 1251 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1252 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1253 "glib-2.0.vapi"
	if (_vala_c != ((gunichar) 0)) {
#line 1777 "TeeJee.Misc.c"
		gchar* _tmp0_;
#line 1254 "glib-2.0.vapi"
		_tmp0_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1254 "glib-2.0.vapi"
		*index = (gint) (_tmp0_ - ((gchar*) self));
#line 1255 "glib-2.0.vapi"
		result = TRUE;
#line 1255 "glib-2.0.vapi"
		if (c) {
#line 1255 "glib-2.0.vapi"
			*c = _vala_c;
#line 1789 "TeeJee.Misc.c"
		}
#line 1255 "glib-2.0.vapi"
		return result;
#line 1793 "TeeJee.Misc.c"
	} else {
#line 1257 "glib-2.0.vapi"
		result = FALSE;
#line 1257 "glib-2.0.vapi"
		if (c) {
#line 1257 "glib-2.0.vapi"
			*c = _vala_c;
#line 1801 "TeeJee.Misc.c"
		}
#line 1257 "glib-2.0.vapi"
		return result;
#line 1805 "TeeJee.Misc.c"
	}
#line 1251 "glib-2.0.vapi"
	if (c) {
#line 1251 "glib-2.0.vapi"
		*c = _vala_c;
#line 1811 "TeeJee.Misc.c"
	}
}

gchar*
tee_jee_misc_pad_numbers_in_string (const gchar* input,
                                    gint max_length,
                                    gchar pad_char)
{
	gchar* sequence = NULL;
	gchar* _tmp0_;
	gchar* output = NULL;
	gchar* _tmp1_;
	gboolean seq_started = FALSE;
	gunichar c = 0U;
	gchar* character = NULL;
	const gchar* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	gchar* result = NULL;
#line 258 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (input != NULL, NULL);
#line 261 "Utility/TeeJee.Misc.vala"
	_tmp0_ = g_strdup ("");
#line 261 "Utility/TeeJee.Misc.vala"
	sequence = _tmp0_;
#line 262 "Utility/TeeJee.Misc.vala"
	_tmp1_ = g_strdup ("");
#line 262 "Utility/TeeJee.Misc.vala"
	output = _tmp1_;
#line 263 "Utility/TeeJee.Misc.vala"
	seq_started = FALSE;
#line 1843 "TeeJee.Misc.c"
	{
		gint i = 0;
#line 267 "Utility/TeeJee.Misc.vala"
		i = 0;
#line 1848 "TeeJee.Misc.c"
		{
			gboolean _tmp2_ = FALSE;
#line 267 "Utility/TeeJee.Misc.vala"
			_tmp2_ = TRUE;
#line 267 "Utility/TeeJee.Misc.vala"
			while (TRUE) {
#line 1855 "TeeJee.Misc.c"
				gunichar _tmp3_ = 0U;
				gboolean _tmp4_;
				gchar* _tmp5_;
#line 267 "Utility/TeeJee.Misc.vala"
				if (!_tmp2_) {
#line 1861 "TeeJee.Misc.c"
				}
#line 267 "Utility/TeeJee.Misc.vala"
				_tmp2_ = FALSE;
#line 267 "Utility/TeeJee.Misc.vala"
				_tmp4_ = string_get_next_char (input, &i, &_tmp3_);
#line 267 "Utility/TeeJee.Misc.vala"
				c = _tmp3_;
#line 267 "Utility/TeeJee.Misc.vala"
				if (!_tmp4_) {
#line 267 "Utility/TeeJee.Misc.vala"
					break;
#line 1873 "TeeJee.Misc.c"
				}
#line 268 "Utility/TeeJee.Misc.vala"
				_tmp5_ = g_unichar_to_string (c);
#line 268 "Utility/TeeJee.Misc.vala"
				_g_free0 (character);
#line 268 "Utility/TeeJee.Misc.vala"
				character = _tmp5_;
#line 270 "Utility/TeeJee.Misc.vala"
				if (g_unichar_isdigit (c)) {
#line 1883 "TeeJee.Misc.c"
					const gchar* _tmp6_;
					const gchar* _tmp7_;
					gchar* _tmp8_;
#line 271 "Utility/TeeJee.Misc.vala"
					_tmp6_ = sequence;
#line 271 "Utility/TeeJee.Misc.vala"
					_tmp7_ = character;
#line 271 "Utility/TeeJee.Misc.vala"
					_tmp8_ = g_strconcat (_tmp6_, _tmp7_, NULL);
#line 271 "Utility/TeeJee.Misc.vala"
					_g_free0 (sequence);
#line 271 "Utility/TeeJee.Misc.vala"
					sequence = _tmp8_;
#line 272 "Utility/TeeJee.Misc.vala"
					seq_started = TRUE;
#line 1899 "TeeJee.Misc.c"
				} else {
					const gchar* _tmp23_;
					const gchar* _tmp24_;
					gchar* _tmp25_;
#line 275 "Utility/TeeJee.Misc.vala"
					if (seq_started) {
#line 1906 "TeeJee.Misc.c"
						const gchar* _tmp9_;
						gint _tmp10_;
						gint _tmp11_;
						const gchar* _tmp19_;
						const gchar* _tmp20_;
						gchar* _tmp21_;
						gchar* _tmp22_;
#line 276 "Utility/TeeJee.Misc.vala"
						_tmp9_ = sequence;
#line 276 "Utility/TeeJee.Misc.vala"
						_tmp10_ = strlen (_tmp9_);
#line 276 "Utility/TeeJee.Misc.vala"
						_tmp11_ = _tmp10_;
#line 276 "Utility/TeeJee.Misc.vala"
						if ((max_length - _tmp11_) > 0) {
#line 1922 "TeeJee.Misc.c"
							const gchar* _tmp12_;
							gint _tmp13_;
							gint _tmp14_;
							gchar* _tmp15_;
							gchar* _tmp16_;
							const gchar* _tmp17_;
							gchar* _tmp18_;
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp12_ = sequence;
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp13_ = strlen (_tmp12_);
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp14_ = _tmp13_;
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp15_ = g_strnfill ((gsize) (max_length - _tmp14_), pad_char);
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp16_ = _tmp15_;
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp17_ = sequence;
#line 277 "Utility/TeeJee.Misc.vala"
							_tmp18_ = g_strconcat (_tmp16_, _tmp17_, NULL);
#line 277 "Utility/TeeJee.Misc.vala"
							_g_free0 (sequence);
#line 277 "Utility/TeeJee.Misc.vala"
							sequence = _tmp18_;
#line 277 "Utility/TeeJee.Misc.vala"
							_g_free0 (_tmp16_);
#line 1950 "TeeJee.Misc.c"
						}
#line 279 "Utility/TeeJee.Misc.vala"
						_tmp19_ = output;
#line 279 "Utility/TeeJee.Misc.vala"
						_tmp20_ = sequence;
#line 279 "Utility/TeeJee.Misc.vala"
						_tmp21_ = g_strconcat (_tmp19_, _tmp20_, NULL);
#line 279 "Utility/TeeJee.Misc.vala"
						_g_free0 (output);
#line 279 "Utility/TeeJee.Misc.vala"
						output = _tmp21_;
#line 280 "Utility/TeeJee.Misc.vala"
						_tmp22_ = g_strdup ("");
#line 280 "Utility/TeeJee.Misc.vala"
						_g_free0 (sequence);
#line 280 "Utility/TeeJee.Misc.vala"
						sequence = _tmp22_;
#line 281 "Utility/TeeJee.Misc.vala"
						seq_started = FALSE;
#line 1970 "TeeJee.Misc.c"
					}
#line 284 "Utility/TeeJee.Misc.vala"
					_tmp23_ = output;
#line 284 "Utility/TeeJee.Misc.vala"
					_tmp24_ = character;
#line 284 "Utility/TeeJee.Misc.vala"
					_tmp25_ = g_strconcat (_tmp23_, _tmp24_, NULL);
#line 284 "Utility/TeeJee.Misc.vala"
					_g_free0 (output);
#line 284 "Utility/TeeJee.Misc.vala"
					output = _tmp25_;
#line 1982 "TeeJee.Misc.c"
				}
			}
		}
	}
#line 289 "Utility/TeeJee.Misc.vala"
	_tmp26_ = sequence;
#line 289 "Utility/TeeJee.Misc.vala"
	_tmp27_ = strlen (_tmp26_);
#line 289 "Utility/TeeJee.Misc.vala"
	_tmp28_ = _tmp27_;
#line 289 "Utility/TeeJee.Misc.vala"
	if (_tmp28_ > 0) {
#line 1995 "TeeJee.Misc.c"
		const gchar* _tmp29_;
		gint _tmp30_;
		gint _tmp31_;
		const gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
#line 290 "Utility/TeeJee.Misc.vala"
		_tmp29_ = sequence;
#line 290 "Utility/TeeJee.Misc.vala"
		_tmp30_ = strlen (_tmp29_);
#line 290 "Utility/TeeJee.Misc.vala"
		_tmp31_ = _tmp30_;
#line 290 "Utility/TeeJee.Misc.vala"
		if ((max_length - _tmp31_) > 0) {
#line 2011 "TeeJee.Misc.c"
			const gchar* _tmp32_;
			gint _tmp33_;
			gint _tmp34_;
			gchar* _tmp35_;
			gchar* _tmp36_;
			const gchar* _tmp37_;
			gchar* _tmp38_;
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp32_ = sequence;
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp33_ = strlen (_tmp32_);
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp34_ = _tmp33_;
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp35_ = g_strnfill ((gsize) (max_length - _tmp34_), pad_char);
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp36_ = _tmp35_;
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp37_ = sequence;
#line 291 "Utility/TeeJee.Misc.vala"
			_tmp38_ = g_strconcat (_tmp36_, _tmp37_, NULL);
#line 291 "Utility/TeeJee.Misc.vala"
			_g_free0 (sequence);
#line 291 "Utility/TeeJee.Misc.vala"
			sequence = _tmp38_;
#line 291 "Utility/TeeJee.Misc.vala"
			_g_free0 (_tmp36_);
#line 2039 "TeeJee.Misc.c"
		}
#line 293 "Utility/TeeJee.Misc.vala"
		_tmp39_ = output;
#line 293 "Utility/TeeJee.Misc.vala"
		_tmp40_ = sequence;
#line 293 "Utility/TeeJee.Misc.vala"
		_tmp41_ = g_strconcat (_tmp39_, _tmp40_, NULL);
#line 293 "Utility/TeeJee.Misc.vala"
		_g_free0 (output);
#line 293 "Utility/TeeJee.Misc.vala"
		output = _tmp41_;
#line 294 "Utility/TeeJee.Misc.vala"
		_tmp42_ = g_strdup ("");
#line 294 "Utility/TeeJee.Misc.vala"
		_g_free0 (sequence);
#line 294 "Utility/TeeJee.Misc.vala"
		sequence = _tmp42_;
#line 2057 "TeeJee.Misc.c"
	}
#line 297 "Utility/TeeJee.Misc.vala"
	result = output;
#line 297 "Utility/TeeJee.Misc.vala"
	_g_free0 (character);
#line 297 "Utility/TeeJee.Misc.vala"
	_g_free0 (sequence);
#line 297 "Utility/TeeJee.Misc.vala"
	return result;
#line 2067 "TeeJee.Misc.c"
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result = '\0';
#line 1232 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1233 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1233 "glib-2.0.vapi"
	result = _tmp0_;
#line 1233 "glib-2.0.vapi"
	return result;
#line 2084 "TeeJee.Misc.c"
}

gboolean
tee_jee_misc_is_numeric (const gchar* text)
{
	gboolean result = FALSE;
#line 300 "Utility/TeeJee.Misc.vala"
	g_return_val_if_fail (text != NULL, FALSE);
#line 2093 "TeeJee.Misc.c"
	{
		gint i = 0;
#line 301 "Utility/TeeJee.Misc.vala"
		i = 0;
#line 2098 "TeeJee.Misc.c"
		{
			gboolean _tmp0_ = FALSE;
#line 301 "Utility/TeeJee.Misc.vala"
			_tmp0_ = TRUE;
#line 301 "Utility/TeeJee.Misc.vala"
			while (TRUE) {
#line 2105 "TeeJee.Misc.c"
				gint _tmp2_;
				gint _tmp3_;
#line 301 "Utility/TeeJee.Misc.vala"
				if (!_tmp0_) {
#line 2110 "TeeJee.Misc.c"
					gint _tmp1_;
#line 301 "Utility/TeeJee.Misc.vala"
					_tmp1_ = i;
#line 301 "Utility/TeeJee.Misc.vala"
					i = _tmp1_ + 1;
#line 2116 "TeeJee.Misc.c"
				}
#line 301 "Utility/TeeJee.Misc.vala"
				_tmp0_ = FALSE;
#line 301 "Utility/TeeJee.Misc.vala"
				_tmp2_ = strlen (text);
#line 301 "Utility/TeeJee.Misc.vala"
				_tmp3_ = _tmp2_;
#line 301 "Utility/TeeJee.Misc.vala"
				if (!(i < _tmp3_)) {
#line 301 "Utility/TeeJee.Misc.vala"
					break;
#line 2128 "TeeJee.Misc.c"
				}
#line 302 "Utility/TeeJee.Misc.vala"
				if (!g_ascii_isdigit (string_get (text, (glong) i))) {
#line 303 "Utility/TeeJee.Misc.vala"
					result = FALSE;
#line 303 "Utility/TeeJee.Misc.vala"
					return result;
#line 2136 "TeeJee.Misc.c"
				}
			}
		}
	}
#line 306 "Utility/TeeJee.Misc.vala"
	result = TRUE;
#line 306 "Utility/TeeJee.Misc.vala"
	return result;
#line 2145 "TeeJee.Misc.c"
}

static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gint i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static gint
_vala_array_length (gpointer array)
{
	gint length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}

